// This program was compiled from OCaml by js_of_ocaml 1.3
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_get_exception_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_get_exception_backtrace' not implemented");
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function MlStringFromArray (a) {
  var len = a.length; this.array = a; this.len = this.last = len;
}
MlStringFromArray.prototype = new MlString ();
var caml_md5_string =
function () {
  function add (x, y) { return (x + y) | 0; }
  function xx(q,a,b,x,s,t) {
    a = add(add(a, q), add(x, t));
    return add((a << s) | (a >>> (32 - s)), b);
  }
  function ff(a,b,c,d,x,s,t) {
    return xx((b & c) | ((~b) & d), a, b, x, s, t);
  }
  function gg(a,b,c,d,x,s,t) {
    return xx((b & d) | (c & (~d)), a, b, x, s, t);
  }
  function hh(a,b,c,d,x,s,t) { return xx(b ^ c ^ d, a, b, x, s, t); }
  function ii(a,b,c,d,x,s,t) { return xx(c ^ (b | (~d)), a, b, x, s, t); }
  function md5(buffer, length) {
    var i = length;
    buffer[i >> 2] |= 0x80 << (8 * (i & 3));
    for (i = (i & ~0x3) + 4;(i & 0x3F) < 56 ;i += 4)
      buffer[i >> 2] = 0;
    buffer[i >> 2] = length << 3;
    i += 4;
    buffer[i >> 2] = (length >> 29) & 0x1FFFFFFF;
    var w = [0x67452301, 0xEFCDAB89, 0x98BADCFE, 0x10325476];
    for(i = 0; i < buffer.length; i += 16) {
      var a = w[0], b = w[1], c = w[2], d = w[3];
      a = ff(a, b, c, d, buffer[i+ 0], 7, 0xD76AA478);
      d = ff(d, a, b, c, buffer[i+ 1], 12, 0xE8C7B756);
      c = ff(c, d, a, b, buffer[i+ 2], 17, 0x242070DB);
      b = ff(b, c, d, a, buffer[i+ 3], 22, 0xC1BDCEEE);
      a = ff(a, b, c, d, buffer[i+ 4], 7, 0xF57C0FAF);
      d = ff(d, a, b, c, buffer[i+ 5], 12, 0x4787C62A);
      c = ff(c, d, a, b, buffer[i+ 6], 17, 0xA8304613);
      b = ff(b, c, d, a, buffer[i+ 7], 22, 0xFD469501);
      a = ff(a, b, c, d, buffer[i+ 8], 7, 0x698098D8);
      d = ff(d, a, b, c, buffer[i+ 9], 12, 0x8B44F7AF);
      c = ff(c, d, a, b, buffer[i+10], 17, 0xFFFF5BB1);
      b = ff(b, c, d, a, buffer[i+11], 22, 0x895CD7BE);
      a = ff(a, b, c, d, buffer[i+12], 7, 0x6B901122);
      d = ff(d, a, b, c, buffer[i+13], 12, 0xFD987193);
      c = ff(c, d, a, b, buffer[i+14], 17, 0xA679438E);
      b = ff(b, c, d, a, buffer[i+15], 22, 0x49B40821);
      a = gg(a, b, c, d, buffer[i+ 1], 5, 0xF61E2562);
      d = gg(d, a, b, c, buffer[i+ 6], 9, 0xC040B340);
      c = gg(c, d, a, b, buffer[i+11], 14, 0x265E5A51);
      b = gg(b, c, d, a, buffer[i+ 0], 20, 0xE9B6C7AA);
      a = gg(a, b, c, d, buffer[i+ 5], 5, 0xD62F105D);
      d = gg(d, a, b, c, buffer[i+10], 9, 0x02441453);
      c = gg(c, d, a, b, buffer[i+15], 14, 0xD8A1E681);
      b = gg(b, c, d, a, buffer[i+ 4], 20, 0xE7D3FBC8);
      a = gg(a, b, c, d, buffer[i+ 9], 5, 0x21E1CDE6);
      d = gg(d, a, b, c, buffer[i+14], 9, 0xC33707D6);
      c = gg(c, d, a, b, buffer[i+ 3], 14, 0xF4D50D87);
      b = gg(b, c, d, a, buffer[i+ 8], 20, 0x455A14ED);
      a = gg(a, b, c, d, buffer[i+13], 5, 0xA9E3E905);
      d = gg(d, a, b, c, buffer[i+ 2], 9, 0xFCEFA3F8);
      c = gg(c, d, a, b, buffer[i+ 7], 14, 0x676F02D9);
      b = gg(b, c, d, a, buffer[i+12], 20, 0x8D2A4C8A);
      a = hh(a, b, c, d, buffer[i+ 5], 4, 0xFFFA3942);
      d = hh(d, a, b, c, buffer[i+ 8], 11, 0x8771F681);
      c = hh(c, d, a, b, buffer[i+11], 16, 0x6D9D6122);
      b = hh(b, c, d, a, buffer[i+14], 23, 0xFDE5380C);
      a = hh(a, b, c, d, buffer[i+ 1], 4, 0xA4BEEA44);
      d = hh(d, a, b, c, buffer[i+ 4], 11, 0x4BDECFA9);
      c = hh(c, d, a, b, buffer[i+ 7], 16, 0xF6BB4B60);
      b = hh(b, c, d, a, buffer[i+10], 23, 0xBEBFBC70);
      a = hh(a, b, c, d, buffer[i+13], 4, 0x289B7EC6);
      d = hh(d, a, b, c, buffer[i+ 0], 11, 0xEAA127FA);
      c = hh(c, d, a, b, buffer[i+ 3], 16, 0xD4EF3085);
      b = hh(b, c, d, a, buffer[i+ 6], 23, 0x04881D05);
      a = hh(a, b, c, d, buffer[i+ 9], 4, 0xD9D4D039);
      d = hh(d, a, b, c, buffer[i+12], 11, 0xE6DB99E5);
      c = hh(c, d, a, b, buffer[i+15], 16, 0x1FA27CF8);
      b = hh(b, c, d, a, buffer[i+ 2], 23, 0xC4AC5665);
      a = ii(a, b, c, d, buffer[i+ 0], 6, 0xF4292244);
      d = ii(d, a, b, c, buffer[i+ 7], 10, 0x432AFF97);
      c = ii(c, d, a, b, buffer[i+14], 15, 0xAB9423A7);
      b = ii(b, c, d, a, buffer[i+ 5], 21, 0xFC93A039);
      a = ii(a, b, c, d, buffer[i+12], 6, 0x655B59C3);
      d = ii(d, a, b, c, buffer[i+ 3], 10, 0x8F0CCC92);
      c = ii(c, d, a, b, buffer[i+10], 15, 0xFFEFF47D);
      b = ii(b, c, d, a, buffer[i+ 1], 21, 0x85845DD1);
      a = ii(a, b, c, d, buffer[i+ 8], 6, 0x6FA87E4F);
      d = ii(d, a, b, c, buffer[i+15], 10, 0xFE2CE6E0);
      c = ii(c, d, a, b, buffer[i+ 6], 15, 0xA3014314);
      b = ii(b, c, d, a, buffer[i+13], 21, 0x4E0811A1);
      a = ii(a, b, c, d, buffer[i+ 4], 6, 0xF7537E82);
      d = ii(d, a, b, c, buffer[i+11], 10, 0xBD3AF235);
      c = ii(c, d, a, b, buffer[i+ 2], 15, 0x2AD7D2BB);
      b = ii(b, c, d, a, buffer[i+ 9], 21, 0xEB86D391);
      w[0] = add(a, w[0]);
      w[1] = add(b, w[1]);
      w[2] = add(c, w[2]);
      w[3] = add(d, w[3]);
    }
    var t = [];
    for (var i = 0; i < 4; i++)
      for (var j = 0; j < 4; j++)
        t[i * 4 + j] = (w[i] >> (8 * j)) & 0xFF;
    return t;
  }
  return function (s, ofs, len) {
    var buf = [];
    if (s.array) {
      var a = s.array;
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] = a[j] | (a[j+1] << 8) | (a[j+2] << 16) | (a[j+3] << 24);
      }
      for (; i < len; i++) buf[i>>2] |= a[i + ofs] << (8 * (i & 3));
    } else {
      var b = s.getFullBytes();
      for (var i = 0; i < len; i+=4) {
        var j = i + ofs;
        buf[i>>2] =
          b.charCodeAt(j) | (b.charCodeAt(j+1) << 8) |
          (b.charCodeAt(j+2) << 16) | (b.charCodeAt(j+3) << 24);
      }
      for (; i < len; i++) buf[i>>2] |= b.charCodeAt(i + ofs) << (8 * (i & 3));
    }
    return new MlStringFromArray(md5(buf, len));
  }
} ();
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32, 0];
}
function caml_sys_random_seed () {
  var x = new Date()^0xffffffff*Math.random();
  return {valueOf:function(){return x;},0:0,1:x,length:2};
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function(){function g3(l8,l9,l_,l$,ma,mb,mc){return l8.length==6?l8(l9,l_,l$,ma,mb,mc):caml_call_gen(l8,[l9,l_,l$,ma,mb,mc]);}function cV(l4,l5,l6,l7){return l4.length==3?l4(l5,l6,l7):caml_call_gen(l4,[l5,l6,l7]);}function dp(l1,l2,l3){return l1.length==2?l1(l2,l3):caml_call_gen(l1,[l2,l3]);}function a9(lZ,l0){return lZ.length==1?lZ(l0):caml_call_gen(lZ,[l0]);}var a=[0,new MlString("Failure")],b=[0,new MlString("Invalid_argument")],c=[0,new MlString("Assert_failure")],d=new MlString("File \"%s\", line %d, characters %d-%d: %s");caml_register_global(6,[0,new MlString("Not_found")]);caml_register_global(5,[0,new MlString("Division_by_zero")]);caml_register_global(3,b);caml_register_global(2,a);var aB=[0,new MlString("Out_of_memory")],aA=[0,new MlString("Match_failure")],az=[0,new MlString("Stack_overflow")],ay=new MlString("%.12g"),ax=new MlString("."),aw=new MlString("%d"),av=new MlString("true"),au=new MlString("false"),at=new MlString("Pervasives.do_at_exit"),as=new MlString("\\b"),ar=new MlString("\\t"),aq=new MlString("\\n"),ap=new MlString("\\r"),ao=new MlString("\\\\"),an=new MlString("\\'"),am=new MlString("String.blit"),al=new MlString("String.sub"),ak=new MlString("Queue.Empty"),aj=new MlString("Buffer.add: cannot grow buffer"),ai=new MlString("%"),ah=new MlString(""),ag=new MlString(""),af=new MlString("\""),ae=new MlString("\""),ad=new MlString("'"),ac=new MlString("'"),ab=new MlString("."),aa=new MlString("printf: bad positional specification (0)."),$=new MlString("%_"),_=[0,new MlString("printf.ml"),144,8],Z=new MlString("''"),Y=new MlString("Printf: premature end of format string ``"),X=new MlString("''"),W=new MlString(" in format string ``"),V=new MlString(", at char number "),U=new MlString("Printf: bad conversion %"),T=new MlString("Sformat.index_of_int: negative argument "),S=new MlString(""),R=new MlString(", %s%s"),Q=[1,1],P=new MlString("%s\n"),O=new MlString("(Program not linked with -g, cannot print stack backtrace)\n"),N=new MlString("Raised at"),M=new MlString("Re-raised at"),L=new MlString("Raised by primitive operation at"),K=new MlString("Called from"),J=new MlString("%s file \"%s\", line %d, characters %d-%d"),I=new MlString("%s unknown location"),H=new MlString("Pattern matching failed"),G=new MlString("Assertion failed"),F=new MlString("(%s%s)"),E=new MlString(""),D=new MlString(""),C=new MlString("(%s)"),B=new MlString("%d"),A=new MlString("%S"),z=new MlString("_"),y=new MlString("Random.int"),x=new MlString("x"),w=[0,-85831125,-577944012,364182224,414272206,318284740,-83334073,383018966,-803368505,840823159,-1049181805,536292337,-561475319,189156120,-343492228,-929965496,51606627,-933575263,366354223,-70331559,-373178062,-91851154,913149062,526082594,-52316769,784300257,-405988474,-443597373,-124092012,-1025194932,-658227331,258888527,511570777,-983757954,283659902,308386020,-831053109,-591471064,-208553628,-46077654,-866544835,193777847,-454033636,671350186,149669678,-816697806,-986083620,558145612,-890291011,-1045608679,-172409642,710253903,-563095704,-421363914,409934019,801085050],v=[0,new MlString("src/core/lwt.ml"),648,20],u=[0,new MlString("src/core/lwt.ml"),651,8],t=[0,new MlString("src/core/lwt.ml"),498,8],s=[0,new MlString("src/core/lwt.ml"),487,9],r=new MlString("Lwt.wakeup_result"),q=new MlString("Lwt.Canceled"),p=new MlString("canvas"),o=new MlString("2d"),n=new MlString("Dom_html.Canvas_not_available"),m=new MlString("copy"),l=new MlString("lighter"),k=new MlString("source-over"),j=new MlString("#a8a8f6"),i=new MlString("#d9d9d9"),h=new MlString("#767676");function g(e){throw [0,a,e];}function aC(f){throw [0,b,f];}function aN(aD,aF){var aE=aD.getLen(),aG=aF.getLen(),aH=caml_create_string(aE+aG|0);caml_blit_string(aD,0,aH,0,aE);caml_blit_string(aF,0,aH,aE,aG);return aH;}function aS(aI){return caml_format_int(aw,aI);}function aT(aJ){var aK=caml_format_float(ay,aJ),aL=0,aM=aK.getLen();for(;;){if(aM<=aL)var aO=aN(aK,ax);else{var aP=aK.safeGet(aL),aQ=48<=aP?58<=aP?0:1:45===aP?1:0;if(aQ){var aR=aL+1|0,aL=aR;continue;}var aO=aK;}return aO;}}var aU=caml_ml_open_descriptor_out(2);function a2(aW,aV){return caml_ml_output(aW,aV,0,aV.getLen());}function a1(a0){var aX=caml_ml_out_channels_list(0);for(;;){if(aX){var aY=aX[2];try {}catch(aZ){}var aX=aY;continue;}return 0;}}caml_register_named_value(at,a1);function a6(a4,a3){return caml_ml_output_char(a4,a3);}function be(a5){return caml_ml_flush(a5);}function bd(a7,a8){if(0===a7)return [0];var a_=caml_make_vect(a7,a9(a8,0)),a$=1,ba=a7-1|0;if(!(ba<a$)){var bb=a$;for(;;){a_[bb+1]=a9(a8,bb);var bc=bb+1|0;if(ba!==bb){var bb=bc;continue;}break;}}return a_;}function br(bf,bh){var bg=caml_create_string(bf);caml_fill_string(bg,0,bf,bh);return bg;}function bs(bk,bi,bj){if(0<=bi&&0<=bj&&!((bk.getLen()-bj|0)<bi)){var bl=caml_create_string(bj);caml_blit_string(bk,bi,bl,0,bj);return bl;}return aC(al);}function bt(bo,bn,bq,bp,bm){if(0<=bm&&0<=bn&&!((bo.getLen()-bm|0)<bn)&&0<=bp&&!((bq.getLen()-bm|0)<bp))return caml_blit_string(bo,bn,bq,bp,bm);return aC(am);}var bu=caml_sys_get_config(0)[2],bv=caml_mul(bu/8|0,(1<<(bu-10|0))-1|0)-1|0,bQ=252,bP=253,bO=[0,ak];function bN(bw){var bx=1<=bw?bw:1,by=bv<bx?bv:bx,bz=caml_create_string(by);return [0,bz,0,by,bz];}function bR(bA){return bs(bA[1],0,bA[2]);}function bH(bB,bD){var bC=[0,bB[3]];for(;;){if(bC[1]<(bB[2]+bD|0)){bC[1]=2*bC[1]|0;continue;}if(bv<bC[1])if((bB[2]+bD|0)<=bv)bC[1]=bv;else g(aj);var bE=caml_create_string(bC[1]);bt(bB[1],0,bE,0,bB[2]);bB[1]=bE;bB[3]=bC[1];return 0;}}function bS(bF,bI){var bG=bF[2];if(bF[3]<=bG)bH(bF,1);bF[1].safeSet(bG,bI);bF[2]=bG+1|0;return 0;}function bT(bL,bJ){var bK=bJ.getLen(),bM=bL[2]+bK|0;if(bL[3]<bM)bH(bL,bK);bt(bJ,0,bL[1],bL[2],bK);bL[2]=bM;return 0;}function bX(bU){return 0<=bU?bU:g(aN(T,aS(bU)));}function bY(bV,bW){return bX(bV+bW|0);}var bZ=a9(bY,1);function b6(b0){return bs(b0,0,b0.getLen());}function b8(b1,b2,b4){var b3=aN(W,aN(b1,X)),b5=aN(V,aN(aS(b2),b3));return aC(aN(U,aN(br(1,b4),b5)));}function c1(b7,b_,b9){return b8(b6(b7),b_,b9);}function c2(b$){return aC(aN(Y,aN(b6(b$),Z)));}function cx(ca,ci,ck,cm){function ch(cb){if((ca.safeGet(cb)-48|0)<0||9<(ca.safeGet(cb)-48|0))return cb;var cc=cb+1|0;for(;;){var cd=ca.safeGet(cc);if(48<=cd){if(!(58<=cd)){var cf=cc+1|0,cc=cf;continue;}var ce=0;}else if(36===cd){var cg=cc+1|0,ce=1;}else var ce=0;if(!ce)var cg=cb;return cg;}}var cj=ch(ci+1|0),cl=bN((ck-cj|0)+10|0);bS(cl,37);var cn=cm,co=0;for(;;){if(cn){var cp=cn[2],cq=[0,cn[1],co],cn=cp,co=cq;continue;}var cr=cj,cs=co;for(;;){if(cr<=ck){var ct=ca.safeGet(cr);if(42===ct){if(cs){var cu=cs[2];bT(cl,aS(cs[1]));var cv=ch(cr+1|0),cr=cv,cs=cu;continue;}throw [0,c,_];}bS(cl,ct);var cw=cr+1|0,cr=cw;continue;}return bR(cl);}}}function er(cD,cB,cA,cz,cy){var cC=cx(cB,cA,cz,cy);if(78!==cD&&110!==cD)return cC;cC.safeSet(cC.getLen()-1|0,117);return cC;}function c3(cK,cU,cZ,cE,cY){var cF=cE.getLen();function cW(cG,cT){var cH=40===cG?41:125;function cS(cI){var cJ=cI;for(;;){if(cF<=cJ)return a9(cK,cE);if(37===cE.safeGet(cJ)){var cL=cJ+1|0;if(cF<=cL)var cM=a9(cK,cE);else{var cN=cE.safeGet(cL),cO=cN-40|0;if(cO<0||1<cO){var cP=cO-83|0;if(cP<0||2<cP)var cQ=1;else switch(cP){case 1:var cQ=1;break;case 2:var cR=1,cQ=0;break;default:var cR=0,cQ=0;}if(cQ){var cM=cS(cL+1|0),cR=2;}}else var cR=0===cO?0:1;switch(cR){case 1:var cM=cN===cH?cL+1|0:cV(cU,cE,cT,cN);break;case 2:break;default:var cM=cS(cW(cN,cL+1|0)+1|0);}}return cM;}var cX=cJ+1|0,cJ=cX;continue;}}return cS(cT);}return cW(cZ,cY);}function ds(c0){return cV(c3,c2,c1,c0);}function dI(c4,dd,dn){var c5=c4.getLen()-1|0;function dq(c6){var c7=c6;a:for(;;){if(c7<c5){if(37===c4.safeGet(c7)){var c8=0,c9=c7+1|0;for(;;){if(c5<c9)var c_=c2(c4);else{var c$=c4.safeGet(c9);if(58<=c$){if(95===c$){var db=c9+1|0,da=1,c8=da,c9=db;continue;}}else if(32<=c$)switch(c$-32|0){case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 9:case 12:case 15:break;case 0:case 3:case 11:case 13:var dc=c9+1|0,c9=dc;continue;case 10:var de=cV(dd,c8,c9,105),c9=de;continue;default:var df=c9+1|0,c9=df;continue;}var dg=c9;c:for(;;){if(c5<dg)var dh=c2(c4);else{var di=c4.safeGet(dg);if(126<=di)var dj=0;else switch(di){case 78:case 88:case 100:case 105:case 111:case 117:case 120:var dh=cV(dd,c8,dg,105),dj=1;break;case 69:case 70:case 71:case 101:case 102:case 103:var dh=cV(dd,c8,dg,102),dj=1;break;case 33:case 37:case 44:var dh=dg+1|0,dj=1;break;case 83:case 91:case 115:var dh=cV(dd,c8,dg,115),dj=1;break;case 97:case 114:case 116:var dh=cV(dd,c8,dg,di),dj=1;break;case 76:case 108:case 110:var dk=dg+1|0;if(c5<dk){var dh=cV(dd,c8,dg,105),dj=1;}else{var dl=c4.safeGet(dk)-88|0;if(dl<0||32<dl)var dm=1;else switch(dl){case 0:case 12:case 17:case 23:case 29:case 32:var dh=dp(dn,cV(dd,c8,dg,di),105),dj=1,dm=0;break;default:var dm=1;}if(dm){var dh=cV(dd,c8,dg,105),dj=1;}}break;case 67:case 99:var dh=cV(dd,c8,dg,99),dj=1;break;case 66:case 98:var dh=cV(dd,c8,dg,66),dj=1;break;case 41:case 125:var dh=cV(dd,c8,dg,di),dj=1;break;case 40:var dh=dq(cV(dd,c8,dg,di)),dj=1;break;case 123:var dr=cV(dd,c8,dg,di),dt=cV(ds,di,c4,dr),du=dr;for(;;){if(du<(dt-2|0)){var dv=dp(dn,du,c4.safeGet(du)),du=dv;continue;}var dw=dt-1|0,dg=dw;continue c;}default:var dj=0;}if(!dj)var dh=c1(c4,dg,di);}var c_=dh;break;}}var c7=c_;continue a;}}var dx=c7+1|0,c7=dx;continue;}return c7;}}dq(0);return 0;}function fG(dJ){var dy=[0,0,0,0];function dH(dD,dE,dz){var dA=41!==dz?1:0,dB=dA?125!==dz?1:0:dA;if(dB){var dC=97===dz?2:1;if(114===dz)dy[3]=dy[3]+1|0;if(dD)dy[2]=dy[2]+dC|0;else dy[1]=dy[1]+dC|0;}return dE+1|0;}dI(dJ,dH,function(dF,dG){return dF+1|0;});return dy[1];}function en(dK,dN,dV,dL){var dM=dK.safeGet(dL);if((dM-48|0)<0||9<(dM-48|0))return dp(dN,0,dL);var dO=dM-48|0,dP=dL+1|0;for(;;){var dQ=dK.safeGet(dP);if(48<=dQ){if(!(58<=dQ)){var dT=dP+1|0,dS=(10*dO|0)+(dQ-48|0)|0,dO=dS,dP=dT;continue;}var dR=0;}else if(36===dQ)if(0===dO){var dU=g(aa),dR=1;}else{var dU=dp(dN,[0,bX(dO-1|0)],dP+1|0),dR=1;}else var dR=0;if(!dR)var dU=dp(dN,0,dL);return dU;}}function ei(dW,dX){return dW?dX:a9(bZ,dX);}function d9(dY,dZ){return dY?dY[1]:dZ;}function g2(f0,d1,ga,f1,fL,gg,d0){var d2=a9(d1,d0);function fK(d7,gf,d3,ea){var d6=d3.getLen();function fH(f9,d4){var d5=d4;for(;;){if(d6<=d5)return a9(d7,d2);var d8=d3.safeGet(d5);if(37===d8){var ee=function(d$,d_){return caml_array_get(ea,d9(d$,d_));},ek=function(em,ef,eh,eb){var ec=eb;for(;;){var ed=d3.safeGet(ec)-32|0;if(!(ed<0||25<ed))switch(ed){case 1:case 2:case 4:case 5:case 6:case 7:case 8:case 9:case 12:case 15:break;case 10:return en(d3,function(eg,el){var ej=[0,ee(eg,ef),eh];return ek(em,ei(eg,ef),ej,el);},ef,ec+1|0);default:var eo=ec+1|0,ec=eo;continue;}var ep=d3.safeGet(ec);if(124<=ep)var eq=0;else switch(ep){case 78:case 88:case 100:case 105:case 111:case 117:case 120:var es=ee(em,ef),et=caml_format_int(er(ep,d3,d5,ec,eh),es),ev=eu(ei(em,ef),et,ec+1|0),eq=1;break;case 69:case 71:case 101:case 102:case 103:var ew=ee(em,ef),ex=caml_format_float(cx(d3,d5,ec,eh),ew),ev=eu(ei(em,ef),ex,ec+1|0),eq=1;break;case 76:case 108:case 110:var ey=d3.safeGet(ec+1|0)-88|0;if(ey<0||32<ey)var ez=1;else switch(ey){case 0:case 12:case 17:case 23:case 29:case 32:var eA=ec+1|0,eB=ep-108|0;if(eB<0||2<eB)var eC=0;else{switch(eB){case 1:var eC=0,eD=0;break;case 2:var eE=ee(em,ef),eF=caml_format_int(cx(d3,d5,eA,eh),eE),eD=1;break;default:var eG=ee(em,ef),eF=caml_format_int(cx(d3,d5,eA,eh),eG),eD=1;}if(eD){var eH=eF,eC=1;}}if(!eC){var eI=ee(em,ef),eH=caml_int64_format(cx(d3,d5,eA,eh),eI);}var ev=eu(ei(em,ef),eH,eA+1|0),eq=1,ez=0;break;default:var ez=1;}if(ez){var eJ=ee(em,ef),eK=caml_format_int(er(110,d3,d5,ec,eh),eJ),ev=eu(ei(em,ef),eK,ec+1|0),eq=1;}break;case 83:case 115:var eL=ee(em,ef);if(115===ep)var eM=eL;else{var eN=[0,0],eO=0,eP=eL.getLen()-1|0;if(!(eP<eO)){var eQ=eO;for(;;){var eR=eL.safeGet(eQ),eS=14<=eR?34===eR?1:92===eR?1:0:11<=eR?13<=eR?1:0:8<=eR?1:0,eT=eS?2:caml_is_printable(eR)?1:4;eN[1]=eN[1]+eT|0;var eU=eQ+1|0;if(eP!==eQ){var eQ=eU;continue;}break;}}if(eN[1]===eL.getLen())var eV=eL;else{var eW=caml_create_string(eN[1]);eN[1]=0;var eX=0,eY=eL.getLen()-1|0;if(!(eY<eX)){var eZ=eX;for(;;){var e0=eL.safeGet(eZ),e1=e0-34|0;if(e1<0||58<e1)if(-20<=e1)var e2=1;else{switch(e1+34|0){case 8:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],98);var e3=1;break;case 9:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],116);var e3=1;break;case 10:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],110);var e3=1;break;case 13:eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],114);var e3=1;break;default:var e2=1,e3=0;}if(e3)var e2=0;}else var e2=(e1-1|0)<0||56<(e1-1|0)?(eW.safeSet(eN[1],92),eN[1]+=1,eW.safeSet(eN[1],e0),0):1;if(e2)if(caml_is_printable(e0))eW.safeSet(eN[1],e0);else{eW.safeSet(eN[1],92);eN[1]+=1;eW.safeSet(eN[1],48+(e0/100|0)|0);eN[1]+=1;eW.safeSet(eN[1],48+((e0/10|0)%10|0)|0);eN[1]+=1;eW.safeSet(eN[1],48+(e0%10|0)|0);}eN[1]+=1;var e4=eZ+1|0;if(eY!==eZ){var eZ=e4;continue;}break;}}var eV=eW;}var eM=aN(ae,aN(eV,af));}if(ec===(d5+1|0))var e5=eM;else{var e6=cx(d3,d5,ec,eh);try {var e7=0,e8=1;for(;;){if(e6.getLen()<=e8)var e9=[0,0,e7];else{var e_=e6.safeGet(e8);if(49<=e_)if(58<=e_)var e$=0;else{var e9=[0,caml_int_of_string(bs(e6,e8,(e6.getLen()-e8|0)-1|0)),e7],e$=1;}else{if(45===e_){var fb=e8+1|0,fa=1,e7=fa,e8=fb;continue;}var e$=0;}if(!e$){var fc=e8+1|0,e8=fc;continue;}}var fd=e9;break;}}catch(fe){if(fe[1]!==a)throw fe;var fd=b8(e6,0,115);}var ff=fd[1],fg=eM.getLen(),fh=0,fl=fd[2],fk=32;if(ff===fg&&0===fh){var fi=eM,fj=1;}else var fj=0;if(!fj)if(ff<=fg)var fi=bs(eM,fh,fg);else{var fm=br(ff,fk);if(fl)bt(eM,fh,fm,0,fg);else bt(eM,fh,fm,ff-fg|0,fg);var fi=fm;}var e5=fi;}var ev=eu(ei(em,ef),e5,ec+1|0),eq=1;break;case 67:case 99:var fn=ee(em,ef);if(99===ep)var fo=br(1,fn);else{if(39===fn)var fp=an;else if(92===fn)var fp=ao;else{if(14<=fn)var fq=0;else switch(fn){case 8:var fp=as,fq=1;break;case 9:var fp=ar,fq=1;break;case 10:var fp=aq,fq=1;break;case 13:var fp=ap,fq=1;break;default:var fq=0;}if(!fq)if(caml_is_printable(fn)){var fr=caml_create_string(1);fr.safeSet(0,fn);var fp=fr;}else{var fs=caml_create_string(4);fs.safeSet(0,92);fs.safeSet(1,48+(fn/100|0)|0);fs.safeSet(2,48+((fn/10|0)%10|0)|0);fs.safeSet(3,48+(fn%10|0)|0);var fp=fs;}}var fo=aN(ac,aN(fp,ad));}var ev=eu(ei(em,ef),fo,ec+1|0),eq=1;break;case 66:case 98:var fu=ec+1|0,ft=ee(em,ef)?av:au,ev=eu(ei(em,ef),ft,fu),eq=1;break;case 40:case 123:var fv=ee(em,ef),fw=cV(ds,ep,d3,ec+1|0);if(123===ep){var fx=bN(fv.getLen()),fB=function(fz,fy){bS(fx,fy);return fz+1|0;};dI(fv,function(fA,fD,fC){if(fA)bT(fx,$);else bS(fx,37);return fB(fD,fC);},fB);var fE=bR(fx),ev=eu(ei(em,ef),fE,fw),eq=1;}else{var fF=ei(em,ef),fI=bY(fG(fv),fF),ev=fK(function(fJ){return fH(fI,fw);},fF,fv,ea),eq=1;}break;case 33:a9(fL,d2);var ev=fH(ef,ec+1|0),eq=1;break;case 37:var ev=eu(ef,ai,ec+1|0),eq=1;break;case 41:var ev=eu(ef,ah,ec+1|0),eq=1;break;case 44:var ev=eu(ef,ag,ec+1|0),eq=1;break;case 70:var fM=ee(em,ef);if(0===eh)var fN=aT(fM);else{var fO=cx(d3,d5,ec,eh);if(70===ep)fO.safeSet(fO.getLen()-1|0,103);var fP=caml_format_float(fO,fM);if(3<=caml_classify_float(fM))var fQ=fP;else{var fR=0,fS=fP.getLen();for(;;){if(fS<=fR)var fT=aN(fP,ab);else{var fU=fP.safeGet(fR)-46|0,fV=fU<0||23<fU?55===fU?1:0:(fU-1|0)<0||21<(fU-1|0)?1:0;if(!fV){var fW=fR+1|0,fR=fW;continue;}var fT=fP;}var fQ=fT;break;}}var fN=fQ;}var ev=eu(ei(em,ef),fN,ec+1|0),eq=1;break;case 97:var fX=ee(em,ef),fY=a9(bZ,d9(em,ef)),fZ=ee(0,fY),f3=ec+1|0,f2=ei(em,fY);if(f0)dp(f1,d2,dp(fX,0,fZ));else dp(fX,d2,fZ);var ev=fH(f2,f3),eq=1;break;case 116:var f4=ee(em,ef),f6=ec+1|0,f5=ei(em,ef);if(f0)dp(f1,d2,a9(f4,0));else a9(f4,d2);var ev=fH(f5,f6),eq=1;break;default:var eq=0;}if(!eq)var ev=c1(d3,ec,ep);return ev;}},f$=d5+1|0,f8=0;return en(d3,function(f_,f7){return ek(f_,f9,f8,f7);},f9,f$);}dp(ga,d2,d8);var gb=d5+1|0,d5=gb;continue;}}function eu(ge,gc,gd){dp(f1,d2,gc);return fH(ge,gd);}return fH(gf,0);}var gh=dp(fK,gg,bX(0)),gi=fG(d0);if(gi<0||6<gi){var gv=function(gj,gp){if(gi<=gj){var gk=caml_make_vect(gi,0),gn=function(gl,gm){return caml_array_set(gk,(gi-gl|0)-1|0,gm);},go=0,gq=gp;for(;;){if(gq){var gr=gq[2],gs=gq[1];if(gr){gn(go,gs);var gt=go+1|0,go=gt,gq=gr;continue;}gn(go,gs);}return dp(gh,d0,gk);}}return function(gu){return gv(gj+1|0,[0,gu,gp]);};},gw=gv(0,0);}else switch(gi){case 1:var gw=function(gy){var gx=caml_make_vect(1,0);caml_array_set(gx,0,gy);return dp(gh,d0,gx);};break;case 2:var gw=function(gA,gB){var gz=caml_make_vect(2,0);caml_array_set(gz,0,gA);caml_array_set(gz,1,gB);return dp(gh,d0,gz);};break;case 3:var gw=function(gD,gE,gF){var gC=caml_make_vect(3,0);caml_array_set(gC,0,gD);caml_array_set(gC,1,gE);caml_array_set(gC,2,gF);return dp(gh,d0,gC);};break;case 4:var gw=function(gH,gI,gJ,gK){var gG=caml_make_vect(4,0);caml_array_set(gG,0,gH);caml_array_set(gG,1,gI);caml_array_set(gG,2,gJ);caml_array_set(gG,3,gK);return dp(gh,d0,gG);};break;case 5:var gw=function(gM,gN,gO,gP,gQ){var gL=caml_make_vect(5,0);caml_array_set(gL,0,gM);caml_array_set(gL,1,gN);caml_array_set(gL,2,gO);caml_array_set(gL,3,gP);caml_array_set(gL,4,gQ);return dp(gh,d0,gL);};break;case 6:var gw=function(gS,gT,gU,gV,gW,gX){var gR=caml_make_vect(6,0);caml_array_set(gR,0,gS);caml_array_set(gR,1,gT);caml_array_set(gR,2,gU);caml_array_set(gR,3,gV);caml_array_set(gR,4,gW);caml_array_set(gR,5,gX);return dp(gh,d0,gR);};break;default:var gw=dp(gh,d0,[0]);}return gw;}function he(gZ){function g1(gY){return 0;}return g3(g2,0,function(g0){return gZ;},a6,a2,be,g1);}function ha(g4){return bN(2*g4.getLen()|0);}function g9(g7,g5){var g6=bR(g5);g5[2]=0;return a9(g7,g6);}function hd(g8){var g$=a9(g9,g8);return g3(g2,1,ha,bS,bT,function(g_){return 0;},g$);}function hf(hc){return dp(hd,function(hb){return hb;},hc);}var hg=[0,0];function hn(hh,hi){var hj=hh[hi+1];return caml_obj_is_block(hj)?caml_obj_tag(hj)===bQ?dp(hf,A,hj):caml_obj_tag(hj)===bP?aT(hj):z:dp(hf,B,hj);}function hm(hk,hl){if(hk.length-1<=hl)return S;var ho=hm(hk,hl+1|0);return cV(hf,R,hn(hk,hl),ho);}32===bu;var hp=[0,w.slice(),0];function hw(hq){if(1073741823<hq||!(0<hq))var hr=0;else for(;;){hp[2]=(hp[2]+1|0)%55|0;var hs=caml_array_get(hp[1],(hp[2]+24|0)%55|0)+(caml_array_get(hp[1],hp[2])^caml_array_get(hp[1],hp[2])>>>25&31)|0;caml_array_set(hp[1],hp[2],hs);var ht=hs&1073741823,hu=caml_mod(ht,hq);if(((1073741823-hq|0)+1|0)<(ht-hu|0))continue;var hv=hu,hr=1;break;}if(!hr)var hv=aC(y);return hv;}function hz(hy){var hx=[];caml_update_dummy(hx,[0,hx,hx]);return hx;}var hA=[0,q],hB=[0,0],iB=42;function hF(hC){var hD=hC[1];{if(3===hD[0]){var hE=hD[1],hG=hF(hE);if(hG!==hE)hC[1]=[3,hG];return hG;}return hC;}}function iC(hH){return hF(hH);}function iv(hJ,hI){try {var hK=a9(hJ,hI);}catch(hM){var hL=hg[1];for(;;){if(hL){var hQ=hL[2],hN=hL[1];try {var hO=a9(hN,hM),hP=hO;}catch(hR){var hP=0;}if(!hP){var hL=hQ;continue;}}else if(hM[1]!==aB&&hM[1]!==az)if(hM[1]===aA){var hS=hM[2],hT=hS[3];g3(hf,d,hS[1],hS[2],hT,hT+5|0,H);}else if(hM[1]===c){var hU=hM[2],hV=hU[3];g3(hf,d,hU[1],hU[2],hV,hV+6|0,G);}else{var hW=hM.length-1,hZ=hM[0+1][0+1];if(hW<0||2<hW){var hX=hm(hM,2),hY=cV(hf,F,hn(hM,1),hX);}else switch(hW){case 1:var hY=D;break;case 2:var hY=dp(hf,C,hn(hM,1));break;default:var hY=E;}aN(hZ,hY);}caml_ml_output_char(aU,10);var h0=caml_get_exception_backtrace(0);if(h0){var h1=h0[1],h2=0,h3=h1.length-1-1|0;if(!(h3<h2)){var h4=h2;for(;;){if(caml_notequal(caml_array_get(h1,h4),Q)){var h5=caml_array_get(h1,h4),h6=0===h5[0]?h5[1]:h5[1],h7=h6?0===h4?N:M:0===h4?L:K,h8=0===h5[0]?g3(hf,J,h7,h5[2],h5[3],h5[4],h5[5]):dp(hf,I,h7);cV(he,aU,P,h8);}var h9=h4+1|0;if(h3!==h4){var h4=h9;continue;}break;}}}else dp(he,aU,O);a1(0);return caml_sys_exit(2);}}return hK;}function ij(ic,h_,ia){var h$=h_,ib=ia;for(;;)if(typeof h$==="number")return id(ic,ib);else switch(h$[0]){case 1:a9(h$[1],ic);return id(ic,ib);case 2:var ie=h$[1],ig=[0,h$[2],ib],h$=ie,ib=ig;continue;default:var ih=h$[1][1];return ih?(a9(ih[1],ic),id(ic,ib)):id(ic,ib);}}function id(ik,ii){return ii?ij(ik,ii[1],ii[2]):0;}function ix(il,io){var im=il,ip=io;for(;;)if(typeof im==="number")return ir(ip);else switch(im[0]){case 1:var iq=im[1];if(iq[4]){iq[4]=0;iq[1][2]=iq[2];iq[2][1]=iq[1];}return ir(ip);case 2:var is=im[1],it=[0,im[2],ip],im=is,ip=it;continue;default:var iu=im[2];hB[1]=im[1];iv(iu,0);return ir(ip);}}function ir(iw){return iw?ix(iw[1],iw[2]):0;}function iD(iz,iy){var iA=1===iy[0]?iy[1][1]===hA?(ix(iz[4],0),1):0:0;iA;return ij(iy,iz[2],0);}var iE=[0,0],iF=[0,0,0];function i2(iI,iG){var iH=[0,iG],iJ=hF(iI),iK=iJ[1];switch(iK[0]){case 1:if(iK[1][1]===hA){var iL=0,iM=1;}else var iM=0;break;case 2:var iN=iK[1];iJ[1]=iH;var iO=hB[1],iP=iE[1]?1:(iE[1]=1,0);iD(iN,iH);if(iP){hB[1]=iO;var iQ=0;}else for(;;){if(0!==iF[1]){if(0===iF[1])throw [0,bO];iF[1]=iF[1]-1|0;var iR=iF[2],iS=iR[2];if(iS===iR)iF[2]=0;else iR[2]=iS[2];var iT=iS[1];iD(iT[1],iT[2]);continue;}iE[1]=0;hB[1]=iO;var iQ=0;break;}var iL=iQ,iM=1;break;default:var iM=0;}if(!iM)var iL=aC(r);return iL;}function i0(iU,iV){return typeof iU==="number"?iV:typeof iV==="number"?iU:[2,iU,iV];}function iX(iW){if(typeof iW!=="number")switch(iW[0]){case 2:var iY=iW[1],iZ=iX(iW[2]);return i0(iX(iY),iZ);case 1:break;default:if(!iW[1][1])return 0;}return iW;}var i4=[0,function(i1){return 0;}],i3=hz(0),i7=[0,0];function jf(i$){var i5=1-(i3[2]===i3?1:0);if(i5){var i6=hz(0);i6[1][2]=i3[2];i3[2][1]=i6[1];i6[1]=i3[1];i3[1][2]=i6;i3[1]=i3;i3[2]=i3;i7[1]=0;var i8=i6[2];for(;;){var i9=i8!==i6?1:0;if(i9){if(i8[4])i2(i8[3],0);var i_=i8[2],i8=i_;continue;}return i9;}}return i5;}var je=null,jd=undefined,jc=false,jb=Array;function jg(ja){return ja instanceof jb?0:[0,new MlWrappedString(ja.toString())];}hg[1]=[0,jg,hg[1]];var jh=o.toString(),ji=this,jj=[0,n];this.HTMLElement===jd;i4[1]=function(jk){return 1===jk?(ji.setTimeout(caml_js_wrap_callback(jf),0),0):0;};var jl=12,jm=20,jn=Math.floor(jm*Math.sqrt(3)/2+0.5),jo=[0,caml_sys_random_seed(0)],jp=caml_equal(jo,[0])?[0,0]:jo,jq=jp.length-1,jr=0,js=54;if(!(js<jr)){var jt=jr;for(;;){caml_array_set(hp[1],jt,jt);var ju=jt+1|0;if(js!==jt){var jt=ju;continue;}break;}}var jv=[0,x],jw=0,jx=55,jy=caml_greaterequal(jx,jq)?jx:jq,jz=54+jy|0;if(!(jz<jw)){var jA=jw;for(;;){var jB=jA%55|0,jC=jv[1],jD=aN(jC,aS(caml_array_get(jp,caml_mod(jA,jq))));jv[1]=caml_md5_string(jD,0,jD.getLen());var jE=jv[1];caml_array_set(hp[1],jB,caml_array_get(hp[1],jB)^(((jE.safeGet(0)+(jE.safeGet(1)<<8)|0)+(jE.safeGet(2)<<16)|0)+(jE.safeGet(3)<<24)|0));var jF=jA+1|0;if(jz!==jA){var jA=jF;continue;}break;}}hp[2]=0;function jR(jQ,jG,jJ,jL){var jH=jG<0?1:0;if(jH)var jI=jH;else{var jK=jJ<0?1:0;if(jK)var jI=jK;else{var jM=jL<0?1:0;if(jM)var jI=jM;else{var jN=jG<jl?1:0;if(jN){var jO=jJ<jl?1:0;if(jO){var jP=jL<jl?1:0,jI=jP?caml_array_get(caml_array_get(caml_array_get(jQ,jG),jJ),jL):jP;}else var jI=jO;}else var jI=jN;}}}return jI;}var jY=j.toString(),j4=i.toString(),j1=h.toString();function kd(jV,jS,jU,jT,jW){jV.save();jV.translate((((jS-jT|0)+jl|0)-1|0)*jn,((jl-1|0)-jU|0)*jm+(jS+jT|0)*jm/2);a9(jW,jV);return jV.restore();}function kI(jX){jX.fillStyle=jY;jX.beginPath();jX.moveTo(jn,0);jX.lineTo(2*jn,jm/2);jX.lineTo(jn,jm);jX.lineTo(0,jm/2);return jX.fill();}function kN(jZ){jZ.beginPath();jZ.moveTo(0,jm/2);jZ.lineTo(jn,0);jZ.lineTo(2*jn,jm/2);return jZ.stroke();}function kH(j0){j0.fillStyle=j1;j0.beginPath();j0.moveTo(jn,jm);j0.lineTo(jn,2*jm);j0.lineTo(2*jn,1.5*jm);j0.lineTo(2*jn,jm/2);return j0.fill();}function kM(j2){j2.beginPath();j2.moveTo(jn,2*jm);j2.lineTo(jn,jm);j2.lineTo(2*jn,jm/2);return j2.stroke();}function kG(j3){j3.fillStyle=j4;j3.beginPath();j3.moveTo(jn,jm);j3.lineTo(jn,2*jm);j3.lineTo(0,1.5*jm);j3.lineTo(0,jm/2);return j3.fill();}function kL(j5){j5.beginPath();j5.moveTo(jn,jm);j5.lineTo(0,jm/2);j5.lineTo(0,1.5*jm);return j5.stroke();}function kJ(kf,kc,j6){var j7=0,j8=jl-1|0,kj=j6[3],ki=j6[2],ke=j6[1];if(!(j8<j7)){var j9=j7;for(;;){var j_=[0,jl-1|0],j$=0,ka=jl-1|0;if(!(ka<j$)){var kb=j$;b:for(;;){for(;;){if(0<=j_[1]&&!caml_array_get(caml_array_get(caml_array_get(kc,j9),j_[1]),kb)){j_[1]+=-1;continue;}kd(kf,j9,j_[1],kb,ke);var kg=kb+1|0;if(ka!==kb){var kb=kg;continue b;}break;}break;}}var kh=j9+1|0;if(j8!==j9){var j9=kh;continue;}break;}}var kk=0,kl=jl-1|0;if(!(kl<kk)){var km=kk;for(;;){var kn=[0,jl-1|0],ko=0,kp=jl-1|0;if(!(kp<ko)){var kq=ko;b:for(;;){for(;;){if(0<=kn[1]&&!caml_array_get(caml_array_get(caml_array_get(kc,kn[1]),km),kq)){kn[1]+=-1;continue;}kd(kf,kn[1],km,kq,ki);var kr=kq+1|0;if(kp!==kq){var kq=kr;continue b;}break;}break;}}var ks=km+1|0;if(kl!==km){var km=ks;continue;}break;}}var kt=0,ku=jl-1|0;if(!(ku<kt)){var kv=kt;for(;;){var kw=[0,jl-1|0],kx=0,ky=jl-1|0;if(!(ky<kx)){var kz=kx;b:for(;;){for(;;){if(0<=kw[1]&&!caml_array_get(caml_array_get(caml_array_get(kc,kv),kz),kw[1])){kw[1]+=-1;continue;}kd(kf,kv,kz,kw[1],kj);var kA=kz+1|0;if(ky!==kz){var kz=kA;continue b;}break;}break;}}var kB=kv+1|0;if(ku!==kv){var kv=kB;continue;}break;}}return 0;}function lL(kD){var kC=ji.document.createElement(p.toString());if(1-(kC.getContext==je?1:0)){kC.width=caml_mul(jl*2|0,jn|0)+1|0;kC.height=caml_mul(jl*2|0,jm|0)+1|0;return kC;}throw [0,jj];}function k2(kO,kE,kK){var kF=kE.getContext(jh);kF.setTransform(1,0,0,1,0,0);kF.clearRect(0,0,kE.width,kE.height);kF.setTransform(1,0,0,1,0.5,0.5);kF.globalCompositeOperation=l.toString();kJ(kF,kK,[0,kI,kH,kG]);kF.globalCompositeOperation=k.toString();kJ(kF,kK,[0,kN,kM,kL]);kF.beginPath();kF.moveTo(0,jl*1.5*jm);kF.lineTo(jl*jn,jl*2*jm);kF.lineTo(jl*2*jn,jl*1.5*jm);kF.lineTo(jl*2*jn,jl*0.5*jm);kF.stroke();return kO.drawImage(kE,0,0);}function k5(k4,k3,kW){function k7(k6){var kP=[0,0],kQ=0,kR=99;if(!(kR<kQ)){var kS=kQ;for(;;){var kT=hw(jl),kU=hw(jl),kV=hw(jl);if(caml_array_get(caml_array_get(caml_array_get(kW,kT),kU),kV)){if(jR(kW,kT+1|0,kU,kV)||jR(kW,kT,kU+1|0,kV)||jR(kW,kT,kU,kV+1|0))var kX=0;else{caml_array_set(caml_array_get(caml_array_get(kW,kT),kU),kV,0);var kY=1,kX=1;}if(!kX)var kY=0;}else{if(jR(kW,kT-1|0,kU,kV)&&jR(kW,kT,kU-1|0,kV)&&jR(kW,kT,kU,kV-1|0)){caml_array_set(caml_array_get(caml_array_get(kW,kT),kU),kV,1);var kY=1,kZ=1;}else var kZ=0;if(!kZ)var kY=0;}var k0=kY?kY:kP[1];kP[1]=k0;var k1=kS+1|0;if(kR!==kS){var kS=k1;continue;}break;}}if(kP[1])k2(k4,k3,kW);return k5(k4,k3,kW);}var k8=[0,[2,[0,1,0,0,0]]],k_=0.2*1000,k$=ji.setTimeout(caml_js_wrap_callback(function(k9){return i2(k8,0);}),k_);function lb(la){return ji.clearTimeout(k$);}var lc=iC(k8)[1];switch(lc[0]){case 1:var ld=lc[1][1]===hA?(iv(lb,0),1):0;break;case 2:var le=lc[1],lf=[0,hB[1],lb],lg=le[4],lh=typeof lg==="number"?lf:[2,lf,lg];le[4]=lh;var ld=1;break;default:var ld=0;}ld;var li=iC(k8),lj=li[1];switch(lj[0]){case 1:var lk=[0,lj];break;case 2:var ll=lj[1],lm=[0,[2,[0,[0,[0,li]],0,0,0]]],lo=hB[1],lI=[1,function(ln){switch(ln[0]){case 0:var lp=ln[1];hB[1]=lo;try {var lq=k7(lp),lr=lq;}catch(ls){var lr=[0,[1,ls]];}var lt=iC(lm),lu=iC(lr),lv=lt[1];{if(2===lv[0]){var lw=lv[1];if(lt===lu)var lx=0;else{var ly=lu[1];if(2===ly[0]){var lz=ly[1];lu[1]=[3,lt];lw[1]=lz[1];var lA=i0(lw[2],lz[2]),lB=lw[3]+lz[3]|0;if(iB<lB){lw[3]=0;lw[2]=iX(lA);}else{lw[3]=lB;lw[2]=lA;}var lC=lz[4],lD=lw[4],lE=typeof lD==="number"?lC:typeof lC==="number"?lD:[2,lD,lC];lw[4]=lE;var lx=0;}else{lt[1]=ly;var lx=iD(lw,ly);}}return lx;}throw [0,c,s];}case 1:var lF=iC(lm),lG=lF[1];{if(2===lG[0]){var lH=lG[1];lF[1]=ln;return iD(lH,ln);}throw [0,c,t];}default:throw [0,c,v];}}],lJ=ll[2],lK=typeof lJ==="number"?lI:[2,lI,lJ];ll[2]=lK;var lk=lm;break;case 3:throw [0,c,u];default:var lk=k7(lj[1]);}return lk;}function lU(lT){var lM=lL(0),lN=lL(0);ji.document.body.appendChild(lM);var lO=lM.getContext(jh);lO.globalCompositeOperation=m.toString();var lP=1,lS=bd(jl,function(lR){return bd(jl,function(lQ){return caml_make_vect(jl,lP);});});k2(lO,lN,lS);k5(lO,lN,lS);return jc;}ji.onload=caml_js_wrap_callback(function(lV){if(lV){var lW=lU(lV);if(!(lW|0))lV.preventDefault();return lW;}var lX=event,lY=lU(lX);lX.returnValue=lY;return lY;});a1(0);return;}());
