// This program was compiled from OCaml by js_of_ocaml 1.3
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_get_exception_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_get_exception_backtrace' not implemented");
}
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_call(f, o, args) { return f.apply(o, args.slice(1)); }
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32, 0];
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _hF_(_qT_,_qU_,_qV_,_qW_,_qX_,_qY_,_qZ_)
     {return _qT_.length==6
              ?_qT_(_qU_,_qV_,_qW_,_qX_,_qY_,_qZ_)
              :caml_call_gen(_qT_,[_qU_,_qV_,_qW_,_qX_,_qY_,_qZ_]);}
    function _dy_(_qP_,_qQ_,_qR_,_qS_)
     {return _qP_.length==3
              ?_qP_(_qQ_,_qR_,_qS_)
              :caml_call_gen(_qP_,[_qQ_,_qR_,_qS_]);}
    function _d3_(_qM_,_qN_,_qO_)
     {return _qM_.length==2?_qM_(_qN_,_qO_):caml_call_gen(_qM_,[_qN_,_qO_]);}
    function _bM_(_qK_,_qL_)
     {return _qK_.length==1?_qK_(_qL_):caml_call_gen(_qK_,[_qL_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Assert_failure")],
     _d_=new MlString("File \"%s\", line %d, characters %d-%d: %s");
    caml_register_global(6,[0,new MlString("Not_found")]);
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _bd_=[0,new MlString("Out_of_memory")],
     _bc_=[0,new MlString("Match_failure")],
     _bb_=[0,new MlString("Stack_overflow")],
     _ba_=new MlString("%.12g"),
     _a$_=new MlString("."),
     _a__=new MlString("%d"),
     _a9_=new MlString("true"),
     _a8_=new MlString("false"),
     _a7_=new MlString("Pervasives.do_at_exit"),
     _a6_=new MlString("\\b"),
     _a5_=new MlString("\\t"),
     _a4_=new MlString("\\n"),
     _a3_=new MlString("\\r"),
     _a2_=new MlString("\\\\"),
     _a1_=new MlString("\\'"),
     _a0_=new MlString("String.blit"),
     _aZ_=new MlString("String.sub"),
     _aY_=new MlString("Queue.Empty"),
     _aX_=new MlString("Buffer.add: cannot grow buffer"),
     _aW_=new MlString("%"),
     _aV_=new MlString(""),
     _aU_=new MlString(""),
     _aT_=new MlString("\""),
     _aS_=new MlString("\""),
     _aR_=new MlString("'"),
     _aQ_=new MlString("'"),
     _aP_=new MlString("."),
     _aO_=new MlString("printf: bad positional specification (0)."),
     _aN_=new MlString("%_"),
     _aM_=[0,new MlString("printf.ml"),144,8],
     _aL_=new MlString("''"),
     _aK_=new MlString("Printf: premature end of format string ``"),
     _aJ_=new MlString("''"),
     _aI_=new MlString(" in format string ``"),
     _aH_=new MlString(", at char number "),
     _aG_=new MlString("Printf: bad conversion %"),
     _aF_=new MlString("Sformat.index_of_int: negative argument "),
     _aE_=new MlString(""),
     _aD_=new MlString(", %s%s"),
     _aC_=[1,1],
     _aB_=new MlString("%s\n"),
     _aA_=
      new
       MlString
       ("(Program not linked with -g, cannot print stack backtrace)\n"),
     _az_=new MlString("Raised at"),
     _ay_=new MlString("Re-raised at"),
     _ax_=new MlString("Raised by primitive operation at"),
     _aw_=new MlString("Called from"),
     _av_=new MlString("%s file \"%s\", line %d, characters %d-%d"),
     _au_=new MlString("%s unknown location"),
     _at_=new MlString("Pattern matching failed"),
     _as_=new MlString("Assertion failed"),
     _ar_=new MlString("(%s%s)"),
     _aq_=new MlString(""),
     _ap_=new MlString(""),
     _ao_=new MlString("(%s)"),
     _an_=new MlString("%d"),
     _am_=new MlString("%S"),
     _al_=new MlString("_"),
     _ak_=[0,new MlString("src/core/lwt.ml"),814,20],
     _aj_=[0,new MlString("src/core/lwt.ml"),816,8],
     _ai_=[0,new MlString("src/core/lwt.ml"),648,20],
     _ah_=[0,new MlString("src/core/lwt.ml"),651,8],
     _ag_=[0,new MlString("src/core/lwt.ml"),498,8],
     _af_=[0,new MlString("src/core/lwt.ml"),487,9],
     _ae_=new MlString("Lwt.wakeup_result"),
     _ad_=new MlString("Lwt.Canceled"),
     _ac_=new MlString("on"),
     _ab_=new MlString("\""),
     _aa_=new MlString(" name=\""),
     _$_=new MlString("\""),
     ___=new MlString(" type=\""),
     _Z_=new MlString("<"),
     _Y_=new MlString(">"),
     _X_=new MlString(""),
     _W_=new MlString("<input name=\"x\">"),
     _V_=new MlString("input"),
     _U_=new MlString("x"),
     _T_=new MlString("canvas"),
     _S_=new MlString("img"),
     _R_=new MlString("br"),
     _Q_=new MlString("p"),
     _P_=new MlString("div"),
     _O_=new MlString("label"),
     _N_=new MlString("input"),
     _M_=new MlString("select"),
     _L_=new MlString("option"),
     _K_=new MlString("mouseup"),
     _J_=new MlString("mousemove"),
     _I_=new MlString("2d"),
     _H_=new MlString("Dom_html.Canvas_not_available"),
     _G_=new MlString("lighter"),
     _F_=new MlString("copy"),
     _E_=new MlString("% 2.f"),
     _D_=new MlString(""),
     _C_=new MlString("controls"),
     _B_=new MlString("Click and drag mouse to rotate."),
     _A_=new MlString("Resume"),
     _z_=new MlString("Pause"),
     _y_=new MlString("Fixed position"),
     _x_=new MlString("Follow rotation"),
     _w_=new MlString("Reset orientation"),
     _v_=new MlString("Date:"),
     _u_=
      [0,
       new MlString("December solstice"),
       [0,new MlString("Equinox"),[0,new MlString("June solstice"),0]]],
     _t_=new MlString("Lighting"),
     _s_=new MlString("Clip"),
     _r_=new MlString("Frames per second: "),
     _q_=
      new
       MlString
       ("Credit: <a href='http://visibleearth.nasa.gov/'>Visual Earth</a>, Nasa"),
     _p_=[0,new MlString("planet.ml"),415,0],
     _o_=[0,new MlString("planet.ml"),416,0],
     _n_=[0,new MlString("planet.ml"),417,0],
     _m_=[0,new MlString("planet.ml"),418,0],
     _l_=new MlString("copy"),
     _k_=new MlString("checkbox"),
     _j_=new MlString("button"),
     v_i_=[254,0,0,1],
     _h_=new MlString("../planet/texture.jpg");
    function _g_(s_e_){throw [0,_a_,s_e_];}
    function _be_(s_f_){throw [0,_b_,s_f_];}
    function _bp_(s1_bf_,s2_bh_)
     {var
       l1_bg_=s1_bf_.getLen(),
       l2_bi_=s2_bh_.getLen(),
       s_bj_=caml_create_string(l1_bg_+l2_bi_|0);
      caml_blit_string(s1_bf_,0,s_bj_,0,l1_bg_);
      caml_blit_string(s2_bh_,0,s_bj_,l1_bg_,l2_bi_);
      return s_bj_;}
    function string_of_int_bu_(n_bk_){return caml_format_int(_a__,n_bk_);}
    function string_of_float_bv_(f_bl_)
     {var _bm_=caml_format_float(_ba_,f_bl_),i_bn_=0,l_bo_=_bm_.getLen();
      for(;;)
       {if(l_bo_<=i_bn_)
         var _bq_=_bp_(_bm_,_a$_);
        else
         {var
           _br_=_bm_.safeGet(i_bn_),
           _bs_=48<=_br_?58<=_br_?0:1:45===_br_?1:0;
          if(_bs_){var _bt_=i_bn_+1|0,i_bn_=_bt_;continue;}
          var _bq_=_bm_;}
        return _bq_;}}
    var stderr_bw_=caml_ml_open_descriptor_out(2);
    function output_string_bE_(oc_by_,s_bx_)
     {return caml_ml_output(oc_by_,s_bx_,0,s_bx_.getLen());}
    function do_at_exit_bD_(param_bC_)
     {var param_bz_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_bz_)
         {var l_bA_=param_bz_[2];
          try {}catch(_bB_){}
          var param_bz_=l_bA_;
          continue;}
        return 0;}}
    caml_register_named_value(_a7_,do_at_exit_bD_);
    function _bI_(_bG_,_bF_){return caml_ml_output_char(_bG_,_bF_);}
    function _bT_(_bH_){return caml_ml_flush(_bH_);}
    function _bS_(f_bL_,a_bJ_)
     {var l_bK_=a_bJ_.length-1;
      if(0===l_bK_)return [0];
      var
       r_bN_=caml_make_vect(l_bK_,_bM_(f_bL_,a_bJ_[0+1])),
       _bO_=1,
       _bP_=l_bK_-1|0;
      if(!(_bP_<_bO_))
       {var i_bQ_=_bO_;
        for(;;)
         {r_bN_[i_bQ_+1]=_bM_(f_bL_,a_bJ_[i_bQ_+1]);
          var _bR_=i_bQ_+1|0;
          if(_bP_!==i_bQ_){var i_bQ_=_bR_;continue;}
          break;}}
      return r_bN_;}
    function _b6_(n_bU_,c_bW_)
     {var s_bV_=caml_create_string(n_bU_);
      caml_fill_string(s_bV_,0,n_bU_,c_bW_);
      return s_bV_;}
    function _b7_(s_bZ_,ofs_bX_,len_bY_)
     {if(0<=ofs_bX_&&0<=len_bY_&&!((s_bZ_.getLen()-len_bY_|0)<ofs_bX_))
       {var r_b0_=caml_create_string(len_bY_);
        caml_blit_string(s_bZ_,ofs_bX_,r_b0_,0,len_bY_);
        return r_b0_;}
      return _be_(_aZ_);}
    function _b8_(s1_b3_,ofs1_b2_,s2_b5_,ofs2_b4_,len_b1_)
     {if
       (0<=
        len_b1_&&
        0<=
        ofs1_b2_&&
        !((s1_b3_.getLen()-len_b1_|0)<ofs1_b2_)&&
        0<=
        ofs2_b4_&&
        !((s2_b5_.getLen()-len_b1_|0)<ofs2_b4_))
       return caml_blit_string(s1_b3_,ofs1_b2_,s2_b5_,ofs2_b4_,len_b1_);
      return _be_(_a0_);}
    var
     _b9_=caml_sys_get_config(0)[2],
     _b__=caml_mul(_b9_/8|0,(1<<(_b9_-10|0))-1|0)-1|0,
     _ct_=252,
     _cs_=253,
     _cr_=[0,_aY_];
    function _cq_(n_b$_)
     {var
       n_ca_=1<=n_b$_?n_b$_:1,
       n_cb_=_b__<n_ca_?_b__:n_ca_,
       s_cc_=caml_create_string(n_cb_);
      return [0,s_cc_,0,n_cb_,s_cc_];}
    function _cu_(b_cd_){return _b7_(b_cd_[1],0,b_cd_[2]);}
    function _ck_(b_ce_,more_cg_)
     {var new_len_cf_=[0,b_ce_[3]];
      for(;;)
       {if(new_len_cf_[1]<(b_ce_[2]+more_cg_|0))
         {new_len_cf_[1]=2*new_len_cf_[1]|0;continue;}
        if(_b__<new_len_cf_[1])
         if((b_ce_[2]+more_cg_|0)<=_b__)new_len_cf_[1]=_b__;else _g_(_aX_);
        var new_buffer_ch_=caml_create_string(new_len_cf_[1]);
        _b8_(b_ce_[1],0,new_buffer_ch_,0,b_ce_[2]);
        b_ce_[1]=new_buffer_ch_;
        b_ce_[3]=new_len_cf_[1];
        return 0;}}
    function _cv_(b_ci_,c_cl_)
     {var pos_cj_=b_ci_[2];
      if(b_ci_[3]<=pos_cj_)_ck_(b_ci_,1);
      b_ci_[1].safeSet(pos_cj_,c_cl_);
      b_ci_[2]=pos_cj_+1|0;
      return 0;}
    function _cw_(b_co_,s_cm_)
     {var len_cn_=s_cm_.getLen(),new_position_cp_=b_co_[2]+len_cn_|0;
      if(b_co_[3]<new_position_cp_)_ck_(b_co_,len_cn_);
      _b8_(s_cm_,0,b_co_[1],b_co_[2],len_cn_);
      b_co_[2]=new_position_cp_;
      return 0;}
    function index_of_int_cA_(i_cx_)
     {return 0<=i_cx_?i_cx_:_g_(_bp_(_aF_,string_of_int_bu_(i_cx_)));}
    function add_int_index_cB_(i_cy_,idx_cz_)
     {return index_of_int_cA_(i_cy_+idx_cz_|0);}
    var _cC_=_bM_(add_int_index_cB_,1);
    function _cJ_(fmt_cD_){return _b7_(fmt_cD_,0,fmt_cD_.getLen());}
    function bad_conversion_cL_(sfmt_cE_,i_cF_,c_cH_)
     {var
       _cG_=_bp_(_aI_,_bp_(sfmt_cE_,_aJ_)),
       _cI_=_bp_(_aH_,_bp_(string_of_int_bu_(i_cF_),_cG_));
      return _be_(_bp_(_aG_,_bp_(_b6_(1,c_cH_),_cI_)));}
    function bad_conversion_format_dE_(fmt_cK_,i_cN_,c_cM_)
     {return bad_conversion_cL_(_cJ_(fmt_cK_),i_cN_,c_cM_);}
    function incomplete_format_dF_(fmt_cO_)
     {return _be_(_bp_(_aK_,_bp_(_cJ_(fmt_cO_),_aL_)));}
    function extract_format_da_(fmt_cP_,start_cX_,stop_cZ_,widths_c1_)
     {function skip_positional_spec_cW_(start_cQ_)
       {if
         ((fmt_cP_.safeGet(start_cQ_)-48|0)<
          0||
          9<
          (fmt_cP_.safeGet(start_cQ_)-48|0))
         return start_cQ_;
        var i_cR_=start_cQ_+1|0;
        for(;;)
         {var _cS_=fmt_cP_.safeGet(i_cR_);
          if(48<=_cS_)
           {if(!(58<=_cS_)){var _cU_=i_cR_+1|0,i_cR_=_cU_;continue;}
            var _cT_=0;}
          else
           if(36===_cS_){var _cV_=i_cR_+1|0,_cT_=1;}else var _cT_=0;
          if(!_cT_)var _cV_=start_cQ_;
          return _cV_;}}
      var
       start_cY_=skip_positional_spec_cW_(start_cX_+1|0),
       b_c0_=_cq_((stop_cZ_-start_cY_|0)+10|0);
      _cv_(b_c0_,37);
      var l1_c2_=widths_c1_,l2_c3_=0;
      for(;;)
       {if(l1_c2_)
         {var
           l_c4_=l1_c2_[2],
           _c5_=[0,l1_c2_[1],l2_c3_],
           l1_c2_=l_c4_,
           l2_c3_=_c5_;
          continue;}
        var i_c6_=start_cY_,widths_c7_=l2_c3_;
        for(;;)
         {if(i_c6_<=stop_cZ_)
           {var _c8_=fmt_cP_.safeGet(i_c6_);
            if(42===_c8_)
             {if(widths_c7_)
               {var t_c9_=widths_c7_[2];
                _cw_(b_c0_,string_of_int_bu_(widths_c7_[1]));
                var
                 i_c__=skip_positional_spec_cW_(i_c6_+1|0),
                 i_c6_=i_c__,
                 widths_c7_=t_c9_;
                continue;}
              throw [0,_c_,_aM_];}
            _cv_(b_c0_,_c8_);
            var _c$_=i_c6_+1|0,i_c6_=_c$_;
            continue;}
          return _cu_(b_c0_);}}}
    function extract_format_int_e5_
     (conv_dg_,fmt_de_,start_dd_,stop_dc_,widths_db_)
     {var sfmt_df_=extract_format_da_(fmt_de_,start_dd_,stop_dc_,widths_db_);
      if(78!==conv_dg_&&110!==conv_dg_)return sfmt_df_;
      sfmt_df_.safeSet(sfmt_df_.getLen()-1|0,117);
      return sfmt_df_;}
    function sub_format_dG_
     (incomplete_format_dn_,bad_conversion_format_dx_,conv_dC_,fmt_dh_,i_dB_)
     {var len_di_=fmt_dh_.getLen();
      function sub_fmt_dz_(c_dj_,i_dw_)
       {var close_dk_=40===c_dj_?41:125;
        function sub_dv_(j_dl_)
         {var j_dm_=j_dl_;
          for(;;)
           {if(len_di_<=j_dm_)return _bM_(incomplete_format_dn_,fmt_dh_);
            if(37===fmt_dh_.safeGet(j_dm_))
             {var _do_=j_dm_+1|0;
              if(len_di_<=_do_)
               var _dp_=_bM_(incomplete_format_dn_,fmt_dh_);
              else
               {var _dq_=fmt_dh_.safeGet(_do_),_dr_=_dq_-40|0;
                if(_dr_<0||1<_dr_)
                 {var _ds_=_dr_-83|0;
                  if(_ds_<0||2<_ds_)
                   var _dt_=1;
                  else
                   switch(_ds_)
                    {case 1:var _dt_=1;break;
                     case 2:var _du_=1,_dt_=0;break;
                     default:var _du_=0,_dt_=0;}
                  if(_dt_){var _dp_=sub_dv_(_do_+1|0),_du_=2;}}
                else
                 var _du_=0===_dr_?0:1;
                switch(_du_)
                 {case 1:
                   var
                    _dp_=
                     _dq_===close_dk_
                      ?_do_+1|0
                      :_dy_(bad_conversion_format_dx_,fmt_dh_,i_dw_,_dq_);
                   break;
                  case 2:break;
                  default:var _dp_=sub_dv_(sub_fmt_dz_(_dq_,_do_+1|0)+1|0);}}
              return _dp_;}
            var _dA_=j_dm_+1|0,j_dm_=_dA_;
            continue;}}
        return sub_dv_(i_dw_);}
      return sub_fmt_dz_(conv_dC_,i_dB_);}
    function sub_format_for_printf_d6_(conv_dD_)
     {return _dy_
              (sub_format_dG_,
               incomplete_format_dF_,
               bad_conversion_format_dE_,
               conv_dD_);}
    function iter_on_format_args_ek_(fmt_dH_,add_conv_dS_,add_char_d2_)
     {var lim_dI_=fmt_dH_.getLen()-1|0;
      function scan_fmt_d4_(i_dJ_)
       {var i_dK_=i_dJ_;
        a:
        for(;;)
         {if(i_dK_<lim_dI_)
           {if(37===fmt_dH_.safeGet(i_dK_))
             {var skip_dL_=0,i_dM_=i_dK_+1|0;
              for(;;)
               {if(lim_dI_<i_dM_)
                 var _dN_=incomplete_format_dF_(fmt_dH_);
                else
                 {var _dO_=fmt_dH_.safeGet(i_dM_);
                  if(58<=_dO_)
                   {if(95===_dO_)
                     {var _dQ_=i_dM_+1|0,_dP_=1,skip_dL_=_dP_,i_dM_=_dQ_;
                      continue;}}
                  else
                   if(32<=_dO_)
                    switch(_dO_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _dR_=i_dM_+1|0,i_dM_=_dR_;continue;
                      case 10:
                       var _dT_=_dy_(add_conv_dS_,skip_dL_,i_dM_,105),i_dM_=_dT_;
                       continue;
                      default:var _dU_=i_dM_+1|0,i_dM_=_dU_;continue;}
                  var i_dV_=i_dM_;
                  c:
                  for(;;)
                   {if(lim_dI_<i_dV_)
                     var _dW_=incomplete_format_dF_(fmt_dH_);
                    else
                     {var _dX_=fmt_dH_.safeGet(i_dV_);
                      if(126<=_dX_)
                       var _dY_=0;
                      else
                       switch(_dX_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,105),_dY_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,102),_dY_=1;break;
                         case 33:
                         case 37:
                         case 44:var _dW_=i_dV_+1|0,_dY_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,115),_dY_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,_dX_),_dY_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_dZ_=i_dV_+1|0;
                          if(lim_dI_<j_dZ_)
                           {var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,105),_dY_=1;}
                          else
                           {var _d0_=fmt_dH_.safeGet(j_dZ_)-88|0;
                            if(_d0_<0||32<_d0_)
                             var _d1_=1;
                            else
                             switch(_d0_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _dW_=
                                  _d3_
                                   (add_char_d2_,_dy_(add_conv_dS_,skip_dL_,i_dV_,_dX_),105),
                                 _dY_=1,
                                 _d1_=0;
                                break;
                               default:var _d1_=1;}
                            if(_d1_)
                             {var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,105),_dY_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,99),_dY_=1;break;
                         case 66:
                         case 98:
                          var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,66),_dY_=1;break;
                         case 41:
                         case 125:
                          var _dW_=_dy_(add_conv_dS_,skip_dL_,i_dV_,_dX_),_dY_=1;
                          break;
                         case 40:
                          var
                           _dW_=scan_fmt_d4_(_dy_(add_conv_dS_,skip_dL_,i_dV_,_dX_)),
                           _dY_=1;
                          break;
                         case 123:
                          var
                           i_d5_=_dy_(add_conv_dS_,skip_dL_,i_dV_,_dX_),
                           j_d7_=_dy_(sub_format_for_printf_d6_,_dX_,fmt_dH_,i_d5_),
                           i_d8_=i_d5_;
                          for(;;)
                           {if(i_d8_<(j_d7_-2|0))
                             {var
                               _d9_=_d3_(add_char_d2_,i_d8_,fmt_dH_.safeGet(i_d8_)),
                               i_d8_=_d9_;
                              continue;}
                            var _d__=j_d7_-1|0,i_dV_=_d__;
                            continue c;}
                         default:var _dY_=0;}
                      if(!_dY_)
                       var _dW_=bad_conversion_format_dE_(fmt_dH_,i_dV_,_dX_);}
                    var _dN_=_dW_;
                    break;}}
                var i_dK_=_dN_;
                continue a;}}
            var _d$_=i_dK_+1|0,i_dK_=_d$_;
            continue;}
          return i_dK_;}}
      scan_fmt_d4_(0);
      return 0;}
    function count_arguments_of_format_gi_(fmt_el_)
     {var ac_ea_=[0,0,0,0];
      function add_conv_ej_(skip_ef_,i_eg_,c_eb_)
       {var _ec_=41!==c_eb_?1:0,_ed_=_ec_?125!==c_eb_?1:0:_ec_;
        if(_ed_)
         {var inc_ee_=97===c_eb_?2:1;
          if(114===c_eb_)ac_ea_[3]=ac_ea_[3]+1|0;
          if(skip_ef_)
           ac_ea_[2]=ac_ea_[2]+inc_ee_|0;
          else
           ac_ea_[1]=ac_ea_[1]+inc_ee_|0;}
        return i_eg_+1|0;}
      iter_on_format_args_ek_
       (fmt_el_,add_conv_ej_,function(i_eh_,c_ei_){return i_eh_+1|0;});
      return ac_ea_[1];}
    function scan_positional_spec_e1_(fmt_em_,got_spec_ep_,n_ex_,i_en_)
     {var _eo_=fmt_em_.safeGet(i_en_);
      if((_eo_-48|0)<0||9<(_eo_-48|0))return _d3_(got_spec_ep_,0,i_en_);
      var accu_eq_=_eo_-48|0,j_er_=i_en_+1|0;
      for(;;)
       {var _es_=fmt_em_.safeGet(j_er_);
        if(48<=_es_)
         {if(!(58<=_es_))
           {var
             _ev_=j_er_+1|0,
             _eu_=(10*accu_eq_|0)+(_es_-48|0)|0,
             accu_eq_=_eu_,
             j_er_=_ev_;
            continue;}
          var _et_=0;}
        else
         if(36===_es_)
          if(0===accu_eq_)
           {var _ew_=_g_(_aO_),_et_=1;}
          else
           {var
             _ew_=
              _d3_(got_spec_ep_,[0,index_of_int_cA_(accu_eq_-1|0)],j_er_+1|0),
             _et_=1;}
         else
          var _et_=0;
        if(!_et_)var _ew_=_d3_(got_spec_ep_,0,i_en_);
        return _ew_;}}
    function next_index_eW_(spec_ey_,n_ez_)
     {return spec_ey_?n_ez_:_bM_(_cC_,n_ez_);}
    function get_index_eL_(spec_eA_,n_eB_){return spec_eA_?spec_eA_[1]:n_eB_;}
    function _hE_
     (to_s_gC_,get_out_eD_,outc_gO_,outs_gD_,flush_gn_,k_gU_,fmt_eC_)
     {var out_eE_=_bM_(get_out_eD_,fmt_eC_);
      function pr_gm_(k_eJ_,n_gT_,fmt_eF_,v_eO_)
       {var len_eI_=fmt_eF_.getLen();
        function doprn_gj_(n_gL_,i_eG_)
         {var i_eH_=i_eG_;
          for(;;)
           {if(len_eI_<=i_eH_)return _bM_(k_eJ_,out_eE_);
            var _eK_=fmt_eF_.safeGet(i_eH_);
            if(37===_eK_)
             {var
               get_arg_eS_=
                function(spec_eN_,n_eM_)
                 {return caml_array_get(v_eO_,get_index_eL_(spec_eN_,n_eM_));},
               scan_flags_eY_=
                function(spec_e0_,n_eT_,widths_eV_,i_eP_)
                 {var i_eQ_=i_eP_;
                  for(;;)
                   {var _eR_=fmt_eF_.safeGet(i_eQ_)-32|0;
                    if(!(_eR_<0||25<_eR_))
                     switch(_eR_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_e1_
                                (fmt_eF_,
                                 function(wspec_eU_,i_eZ_)
                                  {var _eX_=[0,get_arg_eS_(wspec_eU_,n_eT_),widths_eV_];
                                   return scan_flags_eY_
                                           (spec_e0_,next_index_eW_(wspec_eU_,n_eT_),_eX_,i_eZ_);},
                                 n_eT_,
                                 i_eQ_+1|0);
                       default:var _e2_=i_eQ_+1|0,i_eQ_=_e2_;continue;}
                    var _e3_=fmt_eF_.safeGet(i_eQ_);
                    if(124<=_e3_)
                     var _e4_=0;
                    else
                     switch(_e3_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_e6_=get_arg_eS_(spec_e0_,n_eT_),
                         s_e7_=
                          caml_format_int
                           (extract_format_int_e5_(_e3_,fmt_eF_,i_eH_,i_eQ_,widths_eV_),
                            x_e6_),
                         _e9_=
                          cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),s_e7_,i_eQ_+1|0),
                         _e4_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_e__=get_arg_eS_(spec_e0_,n_eT_),
                         s_e$_=
                          caml_format_float
                           (extract_format_da_(fmt_eF_,i_eH_,i_eQ_,widths_eV_),x_e__),
                         _e9_=
                          cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),s_e$_,i_eQ_+1|0),
                         _e4_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _fa_=fmt_eF_.safeGet(i_eQ_+1|0)-88|0;
                        if(_fa_<0||32<_fa_)
                         var _fb_=1;
                        else
                         switch(_fa_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_fc_=i_eQ_+1|0,_fd_=_e3_-108|0;
                            if(_fd_<0||2<_fd_)
                             var _fe_=0;
                            else
                             {switch(_fd_)
                               {case 1:var _fe_=0,_ff_=0;break;
                                case 2:
                                 var
                                  x_fg_=get_arg_eS_(spec_e0_,n_eT_),
                                  _fh_=
                                   caml_format_int
                                    (extract_format_da_(fmt_eF_,i_eH_,i_fc_,widths_eV_),x_fg_),
                                  _ff_=1;
                                 break;
                                default:
                                 var
                                  x_fi_=get_arg_eS_(spec_e0_,n_eT_),
                                  _fh_=
                                   caml_format_int
                                    (extract_format_da_(fmt_eF_,i_eH_,i_fc_,widths_eV_),x_fi_),
                                  _ff_=1;}
                              if(_ff_){var s_fj_=_fh_,_fe_=1;}}
                            if(!_fe_)
                             {var
                               x_fk_=get_arg_eS_(spec_e0_,n_eT_),
                               s_fj_=
                                caml_int64_format
                                 (extract_format_da_(fmt_eF_,i_eH_,i_fc_,widths_eV_),x_fk_);}
                            var
                             _e9_=
                              cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),s_fj_,i_fc_+1|0),
                             _e4_=1,
                             _fb_=0;
                            break;
                           default:var _fb_=1;}
                        if(_fb_)
                         {var
                           x_fl_=get_arg_eS_(spec_e0_,n_eT_),
                           s_fm_=
                            caml_format_int
                             (extract_format_int_e5_(110,fmt_eF_,i_eH_,i_eQ_,widths_eV_),
                              x_fl_),
                           _e9_=
                            cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),s_fm_,i_eQ_+1|0),
                           _e4_=1;}
                        break;
                       case 83:
                       case 115:
                        var x_fn_=get_arg_eS_(spec_e0_,n_eT_);
                        if(115===_e3_)
                         var x_fo_=x_fn_;
                        else
                         {var n_fp_=[0,0],_fq_=0,_fr_=x_fn_.getLen()-1|0;
                          if(!(_fr_<_fq_))
                           {var i_fs_=_fq_;
                            for(;;)
                             {var
                               _ft_=x_fn_.safeGet(i_fs_),
                               _fu_=
                                14<=_ft_
                                 ?34===_ft_?1:92===_ft_?1:0
                                 :11<=_ft_?13<=_ft_?1:0:8<=_ft_?1:0,
                               _fv_=_fu_?2:caml_is_printable(_ft_)?1:4;
                              n_fp_[1]=n_fp_[1]+_fv_|0;
                              var _fw_=i_fs_+1|0;
                              if(_fr_!==i_fs_){var i_fs_=_fw_;continue;}
                              break;}}
                          if(n_fp_[1]===x_fn_.getLen())
                           var _fx_=x_fn_;
                          else
                           {var s__fy_=caml_create_string(n_fp_[1]);
                            n_fp_[1]=0;
                            var _fz_=0,_fA_=x_fn_.getLen()-1|0;
                            if(!(_fA_<_fz_))
                             {var i_fB_=_fz_;
                              for(;;)
                               {var _fC_=x_fn_.safeGet(i_fB_),_fD_=_fC_-34|0;
                                if(_fD_<0||58<_fD_)
                                 if(-20<=_fD_)
                                  var _fE_=1;
                                 else
                                  {switch(_fD_+34|0)
                                    {case 8:
                                      s__fy_.safeSet(n_fp_[1],92);
                                      n_fp_[1]+=1;
                                      s__fy_.safeSet(n_fp_[1],98);
                                      var _fF_=1;
                                      break;
                                     case 9:
                                      s__fy_.safeSet(n_fp_[1],92);
                                      n_fp_[1]+=1;
                                      s__fy_.safeSet(n_fp_[1],116);
                                      var _fF_=1;
                                      break;
                                     case 10:
                                      s__fy_.safeSet(n_fp_[1],92);
                                      n_fp_[1]+=1;
                                      s__fy_.safeSet(n_fp_[1],110);
                                      var _fF_=1;
                                      break;
                                     case 13:
                                      s__fy_.safeSet(n_fp_[1],92);
                                      n_fp_[1]+=1;
                                      s__fy_.safeSet(n_fp_[1],114);
                                      var _fF_=1;
                                      break;
                                     default:var _fE_=1,_fF_=0;}
                                   if(_fF_)var _fE_=0;}
                                else
                                 var
                                  _fE_=
                                   (_fD_-1|0)<0||56<(_fD_-1|0)
                                    ?(s__fy_.safeSet(n_fp_[1],92),
                                      n_fp_[1]+=
                                      1,
                                      s__fy_.safeSet(n_fp_[1],_fC_),
                                      0)
                                    :1;
                                if(_fE_)
                                 if(caml_is_printable(_fC_))
                                  s__fy_.safeSet(n_fp_[1],_fC_);
                                 else
                                  {s__fy_.safeSet(n_fp_[1],92);
                                   n_fp_[1]+=1;
                                   s__fy_.safeSet(n_fp_[1],48+(_fC_/100|0)|0);
                                   n_fp_[1]+=1;
                                   s__fy_.safeSet(n_fp_[1],48+((_fC_/10|0)%10|0)|0);
                                   n_fp_[1]+=1;
                                   s__fy_.safeSet(n_fp_[1],48+(_fC_%10|0)|0);}
                                n_fp_[1]+=1;
                                var _fG_=i_fB_+1|0;
                                if(_fA_!==i_fB_){var i_fB_=_fG_;continue;}
                                break;}}
                            var _fx_=s__fy_;}
                          var x_fo_=_bp_(_aS_,_bp_(_fx_,_aT_));}
                        if(i_eQ_===(i_eH_+1|0))
                         var s_fH_=x_fo_;
                        else
                         {var
                           _fI_=
                            extract_format_da_(fmt_eF_,i_eH_,i_eQ_,widths_eV_);
                          try
                           {var neg_fJ_=0,i_fK_=1;
                            for(;;)
                             {if(_fI_.getLen()<=i_fK_)
                               var _fL_=[0,0,neg_fJ_];
                              else
                               {var _fM_=_fI_.safeGet(i_fK_);
                                if(49<=_fM_)
                                 if(58<=_fM_)
                                  var _fN_=0;
                                 else
                                  {var
                                    _fL_=
                                     [0,
                                      caml_int_of_string
                                       (_b7_(_fI_,i_fK_,(_fI_.getLen()-i_fK_|0)-1|0)),
                                      neg_fJ_],
                                    _fN_=1;}
                                else
                                 {if(45===_fM_)
                                   {var _fP_=i_fK_+1|0,_fO_=1,neg_fJ_=_fO_,i_fK_=_fP_;
                                    continue;}
                                  var _fN_=0;}
                                if(!_fN_){var _fQ_=i_fK_+1|0,i_fK_=_fQ_;continue;}}
                              var match_fR_=_fL_;
                              break;}}
                          catch(_fS_)
                           {if(_fS_[1]!==_a_)throw _fS_;
                            var match_fR_=bad_conversion_cL_(_fI_,0,115);}
                          var
                           p_fT_=match_fR_[1],
                           _fU_=x_fo_.getLen(),
                           _fV_=0,
                           neg_fZ_=match_fR_[2],
                           _fY_=32;
                          if(p_fT_===_fU_&&0===_fV_)
                           {var _fW_=x_fo_,_fX_=1;}
                          else
                           var _fX_=0;
                          if(!_fX_)
                           if(p_fT_<=_fU_)
                            var _fW_=_b7_(x_fo_,_fV_,_fU_);
                           else
                            {var res_f0_=_b6_(p_fT_,_fY_);
                             if(neg_fZ_)
                              _b8_(x_fo_,_fV_,res_f0_,0,_fU_);
                             else
                              _b8_(x_fo_,_fV_,res_f0_,p_fT_-_fU_|0,_fU_);
                             var _fW_=res_f0_;}
                          var s_fH_=_fW_;}
                        var
                         _e9_=
                          cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),s_fH_,i_eQ_+1|0),
                         _e4_=1;
                        break;
                       case 67:
                       case 99:
                        var x_f1_=get_arg_eS_(spec_e0_,n_eT_);
                        if(99===_e3_)
                         var s_f2_=_b6_(1,x_f1_);
                        else
                         {if(39===x_f1_)
                           var _f3_=_a1_;
                          else
                           if(92===x_f1_)
                            var _f3_=_a2_;
                           else
                            {if(14<=x_f1_)
                              var _f4_=0;
                             else
                              switch(x_f1_)
                               {case 8:var _f3_=_a6_,_f4_=1;break;
                                case 9:var _f3_=_a5_,_f4_=1;break;
                                case 10:var _f3_=_a4_,_f4_=1;break;
                                case 13:var _f3_=_a3_,_f4_=1;break;
                                default:var _f4_=0;}
                             if(!_f4_)
                              if(caml_is_printable(x_f1_))
                               {var s_f5_=caml_create_string(1);
                                s_f5_.safeSet(0,x_f1_);
                                var _f3_=s_f5_;}
                              else
                               {var s_f6_=caml_create_string(4);
                                s_f6_.safeSet(0,92);
                                s_f6_.safeSet(1,48+(x_f1_/100|0)|0);
                                s_f6_.safeSet(2,48+((x_f1_/10|0)%10|0)|0);
                                s_f6_.safeSet(3,48+(x_f1_%10|0)|0);
                                var _f3_=s_f6_;}}
                          var s_f2_=_bp_(_aQ_,_bp_(_f3_,_aR_));}
                        var
                         _e9_=
                          cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),s_f2_,i_eQ_+1|0),
                         _e4_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _f8_=i_eQ_+1|0,
                         _f7_=get_arg_eS_(spec_e0_,n_eT_)?_a9_:_a8_,
                         _e9_=cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),_f7_,_f8_),
                         _e4_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_f9_=get_arg_eS_(spec_e0_,n_eT_),
                         j_f__=_dy_(sub_format_for_printf_d6_,_e3_,fmt_eF_,i_eQ_+1|0);
                        if(123===_e3_)
                         {var
                           b_f$_=_cq_(xf_f9_.getLen()),
                           add_char_gd_=
                            function(i_gb_,c_ga_){_cv_(b_f$_,c_ga_);return i_gb_+1|0;};
                          iter_on_format_args_ek_
                           (xf_f9_,
                            function(skip_gc_,i_gf_,c_ge_)
                             {if(skip_gc_)_cw_(b_f$_,_aN_);else _cv_(b_f$_,37);
                              return add_char_gd_(i_gf_,c_ge_);},
                            add_char_gd_);
                          var
                           _gg_=_cu_(b_f$_),
                           _e9_=cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),_gg_,j_f__),
                           _e4_=1;}
                        else
                         {var
                           _gh_=next_index_eW_(spec_e0_,n_eT_),
                           m_gk_=
                            add_int_index_cB_
                             (count_arguments_of_format_gi_(xf_f9_),_gh_),
                           _e9_=
                            pr_gm_
                             (function(param_gl_){return doprn_gj_(m_gk_,j_f__);},
                              _gh_,
                              xf_f9_,
                              v_eO_),
                           _e4_=1;}
                        break;
                       case 33:
                        _bM_(flush_gn_,out_eE_);
                        var _e9_=doprn_gj_(n_eT_,i_eQ_+1|0),_e4_=1;
                        break;
                       case 37:
                        var _e9_=cont_s_e8_(n_eT_,_aW_,i_eQ_+1|0),_e4_=1;break;
                       case 41:
                        var _e9_=cont_s_e8_(n_eT_,_aV_,i_eQ_+1|0),_e4_=1;break;
                       case 44:
                        var _e9_=cont_s_e8_(n_eT_,_aU_,i_eQ_+1|0),_e4_=1;break;
                       case 70:
                        var x_go_=get_arg_eS_(spec_e0_,n_eT_);
                        if(0===widths_eV_)
                         var s_gp_=string_of_float_bv_(x_go_);
                        else
                         {var
                           sfmt_gq_=
                            extract_format_da_(fmt_eF_,i_eH_,i_eQ_,widths_eV_);
                          if(70===_e3_)sfmt_gq_.safeSet(sfmt_gq_.getLen()-1|0,103);
                          var s_gr_=caml_format_float(sfmt_gq_,x_go_);
                          if(3<=caml_classify_float(x_go_))
                           var _gs_=s_gr_;
                          else
                           {var i_gt_=0,l_gu_=s_gr_.getLen();
                            for(;;)
                             {if(l_gu_<=i_gt_)
                               var _gv_=_bp_(s_gr_,_aP_);
                              else
                               {var
                                 _gw_=s_gr_.safeGet(i_gt_)-46|0,
                                 _gx_=
                                  _gw_<0||23<_gw_
                                   ?55===_gw_?1:0
                                   :(_gw_-1|0)<0||21<(_gw_-1|0)?1:0;
                                if(!_gx_){var _gy_=i_gt_+1|0,i_gt_=_gy_;continue;}
                                var _gv_=s_gr_;}
                              var _gs_=_gv_;
                              break;}}
                          var s_gp_=_gs_;}
                        var
                         _e9_=
                          cont_s_e8_(next_index_eW_(spec_e0_,n_eT_),s_gp_,i_eQ_+1|0),
                         _e4_=1;
                        break;
                       case 97:
                        var
                         printer_gz_=get_arg_eS_(spec_e0_,n_eT_),
                         n_gA_=_bM_(_cC_,get_index_eL_(spec_e0_,n_eT_)),
                         arg_gB_=get_arg_eS_(0,n_gA_),
                         _gF_=i_eQ_+1|0,
                         _gE_=next_index_eW_(spec_e0_,n_gA_);
                        if(to_s_gC_)
                         _d3_(outs_gD_,out_eE_,_d3_(printer_gz_,0,arg_gB_));
                        else
                         _d3_(printer_gz_,out_eE_,arg_gB_);
                        var _e9_=doprn_gj_(_gE_,_gF_),_e4_=1;
                        break;
                       case 116:
                        var
                         printer_gG_=get_arg_eS_(spec_e0_,n_eT_),
                         _gI_=i_eQ_+1|0,
                         _gH_=next_index_eW_(spec_e0_,n_eT_);
                        if(to_s_gC_)
                         _d3_(outs_gD_,out_eE_,_bM_(printer_gG_,0));
                        else
                         _bM_(printer_gG_,out_eE_);
                        var _e9_=doprn_gj_(_gH_,_gI_),_e4_=1;
                        break;
                       default:var _e4_=0;}
                    if(!_e4_)
                     var _e9_=bad_conversion_format_dE_(fmt_eF_,i_eQ_,_e3_);
                    return _e9_;}},
               _gN_=i_eH_+1|0,
               _gK_=0;
              return scan_positional_spec_e1_
                      (fmt_eF_,
                       function(spec_gM_,i_gJ_)
                        {return scan_flags_eY_(spec_gM_,n_gL_,_gK_,i_gJ_);},
                       n_gL_,
                       _gN_);}
            _d3_(outc_gO_,out_eE_,_eK_);
            var _gP_=i_eH_+1|0,i_eH_=_gP_;
            continue;}}
        function cont_s_e8_(n_gS_,s_gQ_,i_gR_)
         {_d3_(outs_gD_,out_eE_,s_gQ_);return doprn_gj_(n_gS_,i_gR_);}
        return doprn_gj_(n_gT_,0);}
      var
       kpr_gV_=_d3_(pr_gm_,k_gU_,index_of_int_cA_(0)),
       _gW_=count_arguments_of_format_gi_(fmt_eC_);
      if(_gW_<0||6<_gW_)
       {var
         loop_g9_=
          function(i_gX_,args_g3_)
           {if(_gW_<=i_gX_)
             {var
               a_gY_=caml_make_vect(_gW_,0),
               _g1_=
                function(i_gZ_,arg_g0_)
                 {return caml_array_set(a_gY_,(_gW_-i_gZ_|0)-1|0,arg_g0_);},
               i_g2_=0,
               param_g4_=args_g3_;
              for(;;)
               {if(param_g4_)
                 {var _g5_=param_g4_[2],_g6_=param_g4_[1];
                  if(_g5_)
                   {_g1_(i_g2_,_g6_);
                    var _g7_=i_g2_+1|0,i_g2_=_g7_,param_g4_=_g5_;
                    continue;}
                  _g1_(i_g2_,_g6_);}
                return _d3_(kpr_gV_,fmt_eC_,a_gY_);}}
            return function(x_g8_)
             {return loop_g9_(i_gX_+1|0,[0,x_g8_,args_g3_]);};},
         _g__=loop_g9_(0,0);}
      else
       switch(_gW_)
        {case 1:
          var
           _g__=
            function(x_ha_)
             {var a_g$_=caml_make_vect(1,0);
              caml_array_set(a_g$_,0,x_ha_);
              return _d3_(kpr_gV_,fmt_eC_,a_g$_);};
          break;
         case 2:
          var
           _g__=
            function(x_hc_,y_hd_)
             {var a_hb_=caml_make_vect(2,0);
              caml_array_set(a_hb_,0,x_hc_);
              caml_array_set(a_hb_,1,y_hd_);
              return _d3_(kpr_gV_,fmt_eC_,a_hb_);};
          break;
         case 3:
          var
           _g__=
            function(x_hf_,y_hg_,z_hh_)
             {var a_he_=caml_make_vect(3,0);
              caml_array_set(a_he_,0,x_hf_);
              caml_array_set(a_he_,1,y_hg_);
              caml_array_set(a_he_,2,z_hh_);
              return _d3_(kpr_gV_,fmt_eC_,a_he_);};
          break;
         case 4:
          var
           _g__=
            function(x_hj_,y_hk_,z_hl_,t_hm_)
             {var a_hi_=caml_make_vect(4,0);
              caml_array_set(a_hi_,0,x_hj_);
              caml_array_set(a_hi_,1,y_hk_);
              caml_array_set(a_hi_,2,z_hl_);
              caml_array_set(a_hi_,3,t_hm_);
              return _d3_(kpr_gV_,fmt_eC_,a_hi_);};
          break;
         case 5:
          var
           _g__=
            function(x_ho_,y_hp_,z_hq_,t_hr_,u_hs_)
             {var a_hn_=caml_make_vect(5,0);
              caml_array_set(a_hn_,0,x_ho_);
              caml_array_set(a_hn_,1,y_hp_);
              caml_array_set(a_hn_,2,z_hq_);
              caml_array_set(a_hn_,3,t_hr_);
              caml_array_set(a_hn_,4,u_hs_);
              return _d3_(kpr_gV_,fmt_eC_,a_hn_);};
          break;
         case 6:
          var
           _g__=
            function(x_hu_,y_hv_,z_hw_,t_hx_,u_hy_,v_hz_)
             {var a_ht_=caml_make_vect(6,0);
              caml_array_set(a_ht_,0,x_hu_);
              caml_array_set(a_ht_,1,y_hv_);
              caml_array_set(a_ht_,2,z_hw_);
              caml_array_set(a_ht_,3,t_hx_);
              caml_array_set(a_ht_,4,u_hy_);
              caml_array_set(a_ht_,5,v_hz_);
              return _d3_(kpr_gV_,fmt_eC_,a_ht_);};
          break;
         default:var _g__=_d3_(kpr_gV_,fmt_eC_,[0]);}
      return _g__;}
    function _hS_(oc_hB_)
     {function _hD_(_hA_){return 0;}
      return _hF_
              (_hE_,
               0,
               function(param_hC_){return oc_hB_;},
               _bI_,
               output_string_bE_,
               _bT_,
               _hD_);}
    function _hO_(fmt_hG_){return _cq_(2*fmt_hG_.getLen()|0);}
    function _hL_(k_hJ_,b_hH_)
     {var s_hI_=_cu_(b_hH_);b_hH_[2]=0;return _bM_(k_hJ_,s_hI_);}
    function _hR_(k_hK_)
     {var _hN_=_bM_(_hL_,k_hK_);
      return _hF_(_hE_,1,_hO_,_cv_,_cw_,function(_hM_){return 0;},_hN_);}
    function _hT_(fmt_hQ_)
     {return _d3_(_hR_,function(s_hP_){return s_hP_;},fmt_hQ_);}
    var _hU_=[0,0];
    function _h1_(x_hV_,i_hW_)
     {var f_hX_=x_hV_[i_hW_+1];
      return caml_obj_is_block(f_hX_)
              ?caml_obj_tag(f_hX_)===_ct_
                ?_d3_(_hT_,_am_,f_hX_)
                :caml_obj_tag(f_hX_)===_cs_?string_of_float_bv_(f_hX_):_al_
              :_d3_(_hT_,_an_,f_hX_);}
    function _h0_(x_hY_,i_hZ_)
     {if(x_hY_.length-1<=i_hZ_)return _aE_;
      var _h2_=_h0_(x_hY_,i_hZ_+1|0);
      return _dy_(_hT_,_aD_,_h1_(x_hY_,i_hZ_),_h2_);}
    32===_b9_;
    function _h5_(param_h4_)
     {var seq_h3_=[];
      caml_update_dummy(seq_h3_,[0,seq_h3_,seq_h3_]);
      return seq_h3_;}
    var Canceled_h6_=[0,_ad_],current_data_h7_=[0,0],max_removed_i7_=42;
    function repr_rec_h$_(t_h8_)
     {var _h9_=t_h8_[1];
      {if(3===_h9_[0])
        {var t__h__=_h9_[1],t___ia_=repr_rec_h$_(t__h__);
         if(t___ia_!==t__h__)t_h8_[1]=[3,t___ia_];
         return t___ia_;}
       return t_h8_;}}
    function repr_i8_(t_ib_){return repr_rec_h$_(t_ib_);}
    function _iE_(exn_id_)
     {var param_ic_=_hU_[1];
      for(;;)
       {if(param_ic_)
         {var tl_ih_=param_ic_[2],hd_ie_=param_ic_[1];
          try
           {var _if_=_bM_(hd_ie_,exn_id_),_ig_=_if_;}
          catch(_ii_){var _ig_=0;}
          if(!_ig_){var param_ic_=tl_ih_;continue;}}
        else
         if(exn_id_[1]!==_bd_&&exn_id_[1]!==_bb_)
          if(exn_id_[1]===_bc_)
           {var match_ij_=exn_id_[2],char_ik_=match_ij_[3];
            _hF_
             (_hT_,_d_,match_ij_[1],match_ij_[2],char_ik_,char_ik_+5|0,_at_);}
          else
           if(exn_id_[1]===_c_)
            {var match_il_=exn_id_[2],char_im_=match_il_[3];
             _hF_
              (_hT_,_d_,match_il_[1],match_il_[2],char_im_,char_im_+6|0,_as_);}
           else
            {var _in_=exn_id_.length-1,constructor_iq_=exn_id_[0+1][0+1];
             if(_in_<0||2<_in_)
              {var
                _io_=_h0_(exn_id_,2),
                _ip_=_dy_(_hT_,_ar_,_h1_(exn_id_,1),_io_);}
             else
              switch(_in_)
               {case 1:var _ip_=_ap_;break;
                case 2:var _ip_=_d3_(_hT_,_ao_,_h1_(exn_id_,1));break;
                default:var _ip_=_aq_;}
             _bp_(constructor_iq_,_ip_);}
        caml_ml_output_char(stderr_bw_,10);
        var _ir_=caml_get_exception_backtrace(0);
        if(_ir_)
         {var a_is_=_ir_[1],_it_=0,_iu_=a_is_.length-1-1|0;
          if(!(_iu_<_it_))
           {var i_iv_=_it_;
            for(;;)
             {if(caml_notequal(caml_array_get(a_is_,i_iv_),_aC_))
               {var
                 _iw_=caml_array_get(a_is_,i_iv_),
                 is_raise_ix_=0===_iw_[0]?_iw_[1]:_iw_[1],
                 info_iy_=is_raise_ix_?0===i_iv_?_az_:_ay_:0===i_iv_?_ax_:_aw_,
                 _iz_=
                  0===_iw_[0]
                   ?_hF_(_hT_,_av_,info_iy_,_iw_[2],_iw_[3],_iw_[4],_iw_[5])
                   :_d3_(_hT_,_au_,info_iy_);
                _dy_(_hS_,stderr_bw_,_aB_,_iz_);}
              var _iA_=i_iv_+1|0;
              if(_iu_!==i_iv_){var i_iv_=_iA_;continue;}
              break;}}}
        else
         _d3_(_hS_,stderr_bw_,_aA_);
        do_at_exit_bD_(0);
        return caml_sys_exit(2);}}
    function call_unsafe_i1_(f_iC_,x_iB_)
     {try {var _iD_=_bM_(f_iC_,x_iB_);}catch(_iF_){return _iE_(_iF_);}
      return _iD_;}
    function run_waiters_rec_iQ_(state_iK_,ws_iG_,rem_iI_)
     {var ws_iH_=ws_iG_,rem_iJ_=rem_iI_;
      for(;;)
       if(typeof ws_iH_==="number")
        return run_waiters_rec_next_iL_(state_iK_,rem_iJ_);
       else
        switch(ws_iH_[0])
         {case 1:
           _bM_(ws_iH_[1],state_iK_);
           return run_waiters_rec_next_iL_(state_iK_,rem_iJ_);
          case 2:
           var
            ws1_iM_=ws_iH_[1],
            _iN_=[0,ws_iH_[2],rem_iJ_],
            ws_iH_=ws1_iM_,
            rem_iJ_=_iN_;
           continue;
          default:
           var _iO_=ws_iH_[1][1];
           return _iO_
                   ?(_bM_(_iO_[1],state_iK_),
                     run_waiters_rec_next_iL_(state_iK_,rem_iJ_))
                   :run_waiters_rec_next_iL_(state_iK_,rem_iJ_);}}
    function run_waiters_rec_next_iL_(state_iR_,rem_iP_)
     {return rem_iP_?run_waiters_rec_iQ_(state_iR_,rem_iP_[1],rem_iP_[2]):0;}
    function run_cancel_handlers_rec_i3_(chs_iS_,rem_iU_)
     {var chs_iT_=chs_iS_,rem_iV_=rem_iU_;
      for(;;)
       if(typeof chs_iT_==="number")
        return run_cancel_handlers_rec_next_iX_(rem_iV_);
       else
        switch(chs_iT_[0])
         {case 1:
           var n_iW_=chs_iT_[1];
           if(n_iW_[4]){n_iW_[4]=0;n_iW_[1][2]=n_iW_[2];n_iW_[2][1]=n_iW_[1];}
           return run_cancel_handlers_rec_next_iX_(rem_iV_);
          case 2:
           var
            chs1_iY_=chs_iT_[1],
            _iZ_=[0,chs_iT_[2],rem_iV_],
            chs_iT_=chs1_iY_,
            rem_iV_=_iZ_;
           continue;
          default:
           var f_i0_=chs_iT_[2];
           current_data_h7_[1]=chs_iT_[1];
           call_unsafe_i1_(f_i0_,0);
           return run_cancel_handlers_rec_next_iX_(rem_iV_);}}
    function run_cancel_handlers_rec_next_iX_(rem_i2_)
     {return rem_i2_?run_cancel_handlers_rec_i3_(rem_i2_[1],rem_i2_[2]):0;}
    function unsafe_run_waiters_i9_(sleeper_i5_,state_i4_)
     {var
       _i6_=
        1===state_i4_[0]
         ?state_i4_[1][1]===Canceled_h6_
           ?(run_cancel_handlers_rec_i3_(sleeper_i5_[4],0),1)
           :0
         :0;
      _i6_;
      return run_waiters_rec_iQ_(state_i4_,sleeper_i5_[2],0);}
    var wakening_i__=[0,0],_i$_=[0,0,0];
    function wakeup_j5_(t_jc_,v_ja_)
     {var _jb_=[0,v_ja_],t_jd_=repr_rec_h$_(t_jc_),_je_=t_jd_[1];
      switch(_je_[0])
       {case 1:
         if(_je_[1][1]===Canceled_h6_){var _jf_=0,_jg_=1;}else var _jg_=0;
         break;
        case 2:
         var sleeper_jh_=_je_[1];
         t_jd_[1]=_jb_;
         var
          snapshot_ji_=current_data_h7_[1],
          already_wakening_jj_=wakening_i__[1]?1:(wakening_i__[1]=1,0);
         unsafe_run_waiters_i9_(sleeper_jh_,_jb_);
         if(already_wakening_jj_)
          {current_data_h7_[1]=snapshot_ji_;var _jk_=0;}
         else
          for(;;)
           {if(0!==_i$_[1])
             {if(0===_i$_[1])throw [0,_cr_];
              _i$_[1]=_i$_[1]-1|0;
              var tail_jl_=_i$_[2],head_jm_=tail_jl_[2];
              if(head_jm_===tail_jl_)_i$_[2]=0;else tail_jl_[2]=head_jm_[2];
              var _jn_=head_jm_[1];
              unsafe_run_waiters_i9_(_jn_[1],_jn_[2]);
              continue;}
            wakening_i__[1]=0;
            current_data_h7_[1]=snapshot_ji_;
            var _jk_=0;
            break;}
         var _jf_=_jk_,_jg_=1;
         break;
        default:var _jg_=0;}
      if(!_jg_)var _jf_=_be_(_ae_);
      return _jf_;}
    function append_ju_(l1_jo_,l2_jp_)
     {return typeof l1_jo_==="number"
              ?l2_jp_
              :typeof l2_jp_==="number"?l1_jo_:[2,l1_jo_,l2_jp_];}
    function cleanup_jr_(ws_jq_)
     {if(typeof ws_jq_!=="number")
       switch(ws_jq_[0])
        {case 2:
          var l1_js_=ws_jq_[1],_jt_=cleanup_jr_(ws_jq_[2]);
          return append_ju_(cleanup_jr_(l1_js_),_jt_);
         case 1:break;
         default:if(!ws_jq_[1][1])return 0;}
      return ws_jq_;}
    function task_j6_(param_jw_)
     {var _jv_=[0,[2,[0,1,0,0,0]]];return [0,_jv_,_jv_];}
    function add_immutable_waiter_j3_(sleeper_jz_,waiter_jx_)
     {var
       _jy_=[1,waiter_jx_],
       _jA_=sleeper_jz_[2],
       _jB_=typeof _jA_==="number"?_jy_:[2,_jy_,_jA_];
      sleeper_jz_[2]=_jB_;
      return 0;}
    function bind_j7_(t_jC_,f_jJ_)
     {var t_jD_=repr_i8_(t_jC_),_jE_=t_jD_[1];
      switch(_jE_[0])
       {case 1:return [0,_jE_];
        case 2:
         var
          _jF_=[0,[2,[0,[0,[0,t_jD_]],0,0,0]]],
          sleeper_j2_=_jE_[1],
          data_jH_=current_data_h7_[1];
         add_immutable_waiter_j3_
          (sleeper_j2_,
           function(state_jG_)
            {switch(state_jG_[0])
              {case 0:
                var v_jI_=state_jG_[1];
                current_data_h7_[1]=data_jH_;
                try
                 {var _jK_=_bM_(f_jJ_,v_jI_),_jL_=_jK_;}
                catch(_jM_){var _jL_=[0,[1,_jM_]];}
                var
                 t1_jN_=repr_i8_(_jF_),
                 t2_jO_=repr_i8_(_jL_),
                 _jP_=t1_jN_[1];
                {if(2===_jP_[0])
                  {var sleeper1_jQ_=_jP_[1];
                   if(t1_jN_===t2_jO_)
                    var _jR_=0;
                   else
                    {var _jS_=t2_jO_[1];
                     if(2===_jS_[0])
                      {var sleeper2_jT_=_jS_[1];
                       t2_jO_[1]=[3,t1_jN_];
                       sleeper1_jQ_[1]=sleeper2_jT_[1];
                       var
                        waiters_jU_=append_ju_(sleeper1_jQ_[2],sleeper2_jT_[2]),
                        removed_jV_=sleeper1_jQ_[3]+sleeper2_jT_[3]|0;
                       if(max_removed_i7_<removed_jV_)
                        {sleeper1_jQ_[3]=0;
                         sleeper1_jQ_[2]=cleanup_jr_(waiters_jU_);}
                       else
                        {sleeper1_jQ_[3]=removed_jV_;sleeper1_jQ_[2]=waiters_jU_;}
                       var
                        _jW_=sleeper2_jT_[4],
                        _jX_=sleeper1_jQ_[4],
                        _jY_=
                         typeof _jX_==="number"
                          ?_jW_
                          :typeof _jW_==="number"?_jX_:[2,_jX_,_jW_];
                       sleeper1_jQ_[4]=_jY_;
                       var _jR_=0;}
                     else
                      {t1_jN_[1]=_jS_;
                       var _jR_=unsafe_run_waiters_i9_(sleeper1_jQ_,_jS_);}}
                   return _jR_;}
                 throw [0,_c_,_af_];}
               case 1:
                var t_jZ_=repr_i8_(_jF_),_j0_=t_jZ_[1];
                {if(2===_j0_[0])
                  {var sleeper_j1_=_j0_[1];
                   t_jZ_[1]=state_jG_;
                   return unsafe_run_waiters_i9_(sleeper_j1_,state_jG_);}
                 throw [0,_c_,_ag_];}
               default:throw [0,_c_,_ai_];}});
         return _jF_;
        case 3:throw [0,_c_,_ah_];
        default:return _bM_(f_jJ_,_jE_[1]);}}
    var
     pause_hook_j9_=[0,function(_j4_){return 0;}],
     _j8_=_h5_(0),
     _ka_=[0,0],
     null_kf_=null,
     undefined_kg_=undefined,
     _true_kh_=true,
     _false_ki_=false,
     array_constructor_kj_=Array,
     date_constr_kk_=Date;
    function _km_(param_ke_)
     {var _j__=1-(_j8_[2]===_j8_?1:0);
      if(_j__)
       {var tmp_j$_=_h5_(0);
        tmp_j$_[1][2]=_j8_[2];
        _j8_[2][1]=tmp_j$_[1];
        tmp_j$_[1]=_j8_[1];
        _j8_[1][2]=tmp_j$_;
        _j8_[1]=_j8_;
        _j8_[2]=_j8_;
        _ka_[1]=0;
        var curr_kb_=tmp_j$_[2];
        for(;;)
         {var _kc_=curr_kb_!==tmp_j$_?1:0;
          if(_kc_)
           {if(curr_kb_[4])wakeup_j5_(curr_kb_[3],0);
            var _kd_=curr_kb_[2],curr_kb_=_kd_;
            continue;}
          return _kc_;}}
      return _j__;}
    function _kn_(e_kl_)
     {return e_kl_ instanceof array_constructor_kj_
              ?0
              :[0,new MlWrappedString(e_kl_.toString())];}
    _hU_[1]=[0,_kn_,_hU_[1]];
    function _kp_(_ko_){return _ko_;}
    function _kM_(p_kq_,n_kr_){p_kq_.appendChild(n_kr_);return 0;}
    function _kN_(f_kt_)
     {return _kp_
              (caml_js_wrap_callback
                (function(e_ks_)
                  {if(e_ks_)
                    {var res_ku_=_bM_(f_kt_,e_ks_);
                     if(!(res_ku_|0))e_ks_.preventDefault();
                     return res_ku_;}
                   var _kv_=event,res_kw_=_bM_(f_kt_,_kv_);
                   _kv_.returnValue=res_kw_;
                   return res_kw_;}));}
    function _kO_(s_kx_){return s_kx_.toString();}
    function _kP_(e_ky_,typ_kz_,h_kC_,capt_kJ_)
     {if(e_ky_.addEventListener===undefined_kg_)
       {var
         ev_kA_=_ac_.toString().concat(typ_kz_),
         callback_kH_=
          function(e_kB_)
           {var _kG_=[0,h_kC_,e_kB_,[0]];
            return _bM_
                    (function(_kF_,_kE_,_kD_)
                      {return caml_js_call(_kF_,_kE_,_kD_);},
                     _kG_);};
        e_ky_.attachEvent(ev_kA_,callback_kH_);
        return function(param_kI_)
         {return e_ky_.detachEvent(ev_kA_,callback_kH_);};}
      e_ky_.addEventListener(typ_kz_,h_kC_,capt_kJ_);
      return function(param_kK_)
       {return e_ky_.removeEventListener(typ_kz_,h_kC_,capt_kJ_);};}
    function _kQ_(id_kL_){return _bM_(id_kL_,0);}
    var
     mouseup_kR_=_kO_(_K_),
     mousemove_kT_=_kO_(_J_),
     _2d__kS_=_I_.toString(),
     window_kU_=this,
     document_kV_=window_kU_.document;
    function opt_iter_k3_(x_kW_,f_kX_){return x_kW_?_bM_(f_kX_,x_kW_[1]):0;}
    function createElement_k0_(doc_kZ_,name_kY_)
     {return doc_kZ_.createElement(name_kY_.toString());}
    function unsafeCreateElement_k4_(doc_k2_,name_k1_)
     {return createElement_k0_(doc_k2_,name_k1_);}
    var createElementSyntax_k5_=[0,785140586];
    function unsafeCreateElementEx_lm_(_type_k6_,name_k7_,doc_k9_,elt_k8_)
     {for(;;)
       {if(0===_type_k6_&&0===name_k7_)
         return createElement_k0_(doc_k9_,elt_k8_);
        var _k__=createElementSyntax_k5_[1];
        if(785140586===_k__)
         {try
           {var
             el_k$_=document_kV_.createElement(_W_.toString()),
             _la_=_V_.toString(),
             _lb_=el_k$_.tagName.toLowerCase()===_la_?1:0,
             _lc_=_lb_?el_k$_.name===_U_.toString()?1:0:_lb_,
             _ld_=_lc_;}
          catch(_lf_){var _ld_=0;}
          var _le_=_ld_?982028505:-1003883683;
          createElementSyntax_k5_[1]=_le_;
          continue;}
        if(982028505<=_k__)
         {var a_lg_=new array_constructor_kj_();
          a_lg_.push(_Z_.toString(),elt_k8_.toString());
          opt_iter_k3_
           (_type_k6_,
            function(t_lh_)
             {a_lg_.push
               (___.toString(),caml_js_html_escape(t_lh_),_$_.toString());
              return 0;});
          opt_iter_k3_
           (name_k7_,
            function(n_li_)
             {a_lg_.push
               (_aa_.toString(),caml_js_html_escape(n_li_),_ab_.toString());
              return 0;});
          a_lg_.push(_Y_.toString());
          return doc_k9_.createElement(a_lg_.join(_X_.toString()));}
        var res_lj_=createElement_k0_(doc_k9_,elt_k8_);
        opt_iter_k3_(_type_k6_,function(t_lk_){return res_lj_.type=t_lk_;});
        opt_iter_k3_(name_k7_,function(n_ll_){return res_lj_.name=n_ll_;});
        return res_lj_;}}
    function createInput_ls_(_type_lp_,name_lo_,doc_ln_)
     {return unsafeCreateElementEx_lm_(_type_lp_,name_lo_,doc_ln_,_N_);}
    function createLabel_lt_(doc_lq_)
     {return unsafeCreateElement_k4_(doc_lq_,_O_);}
    function createDiv_lu_(doc_lr_)
     {return unsafeCreateElement_k4_(doc_lr_,_P_);}
    var Canvas_not_available_lv_=[0,_H_];
    this.HTMLElement===undefined_kg_;
    pause_hook_j9_[1]=
    function(param_lw_)
     {return 1===param_lw_
              ?(window_kU_.setTimeout(caml_js_wrap_callback(_km_),0),0)
              :0;};
    var
     width_lx_=600,
     pi_ly_=4*Math.atan(1),
     obliquity_lz_=23.5*pi_ly_/180,
     gamma_lA_=2,
     dark_lB_=Math.pow(0.2,gamma_lA_),
     button_type_lC_=_j_.toString();
    function toggle_button_mp_(txt1_lE_,txt2_lG_,action_lK_)
     {var
       state_lD_=[0,0],
       txt1_lF_=txt1_lE_.toString(),
       txt2_lI_=txt2_lG_.toString(),
       b_lH_=createInput_ls_([0,button_type_lC_],0,document_kV_);
      b_lH_.value=txt1_lF_;
      b_lH_.onclick=
      _kN_
       (function(param_lL_)
         {state_lD_[1]=1-state_lD_[1];
          var _lJ_=state_lD_[1]?txt2_lI_:txt1_lF_;
          b_lH_.value=_lJ_;
          _bM_(action_lK_,state_lD_[1]);
          return _true_kh_;});
      return b_lH_;}
    function checkbox_mq_(txt_lR_,checked_lN_,action_lO_)
     {var b_lM_=createInput_ls_([0,_k_.toString()],0,document_kV_);
      b_lM_.checked=!!checked_lN_;
      b_lM_.onclick=
      _kN_
       (function(param_lP_)
         {_bM_(action_lO_,b_lM_.checked|0);return _true_kh_;});
      var lab_lQ_=createLabel_lt_(document_kV_);
      _kM_(lab_lQ_,b_lM_);
      _kM_(lab_lQ_,document_kV_.createTextNode(txt_lR_.toString()));
      return lab_lQ_;}
    function vertex_mh_(x_lU_,y_lT_,z_lS_){return [254,x_lU_,y_lT_,z_lS_];}
    function vect_mr_(param_lW_,_lV_)
     {return [254,
              _lV_[1]-param_lW_[1],
              _lV_[2]-param_lW_[2],
              _lV_[3]-param_lW_[3]];}
    function matrix_vect_mul_mb_(m_l1_,param_lX_)
     {var
       z_lY_=param_lX_[3],
       y_lZ_=param_lX_[2],
       x_l0_=param_lX_[1],
       r3_l2_=m_l1_[3],
       r2_l3_=m_l1_[2],
       r1_l4_=m_l1_[1];
      return [254,
              x_l0_*r1_l4_[1]+y_lZ_*r1_l4_[2]+z_lY_*r1_l4_[3],
              x_l0_*r2_l3_[1]+y_lZ_*r2_l3_[2]+z_lY_*r2_l3_[3],
              x_l0_*r3_l2_[1]+y_lZ_*r3_l2_[2]+z_lY_*r3_l2_[3]];}
    function matrix_transp_l9_(m_l5_)
     {var r3_l6_=m_l5_[3],r2_l7_=m_l5_[2],r1_l8_=m_l5_[1];
      return [0,
              [254,r1_l8_[1],r2_l7_[1],r3_l6_[1]],
              [254,r1_l8_[2],r2_l7_[2],r3_l6_[2]],
              [254,r1_l8_[3],r2_l7_[3],r3_l6_[3]]];}
    function matrix_mul_ms_(m_ma_,m__l__)
     {var
       m__l$_=matrix_transp_l9_(m__l__),
       _mc_=matrix_vect_mul_mb_(m__l$_,m_ma_[3]),
       _md_=matrix_vect_mul_mb_(m__l$_,m_ma_[2]);
      return [0,matrix_vect_mul_mb_(m__l$_,m_ma_[1]),_md_,_mc_];}
    function xz_rotation_mt_(phi_me_)
     {var
       cos_phi_mf_=Math.cos(phi_me_),
       sin_phi_mg_=Math.sin(phi_me_),
       _mi_=vertex_mh_(-sin_phi_mg_,0,cos_phi_mf_),
       _mj_=vertex_mh_(0,1,0);
      return [0,vertex_mh_(cos_phi_mf_,0,sin_phi_mg_),_mj_,_mi_];}
    function xy_rotation_mu_(phi_mk_)
     {var
       cos_phi_ml_=Math.cos(phi_mk_),
       sin_phi_mm_=Math.sin(phi_mk_),
       _mn_=vertex_mh_(0,0,1),
       _mo_=vertex_mh_(-sin_phi_mm_,cos_phi_ml_,0);
      return [0,vertex_mh_(cos_phi_ml_,sin_phi_mm_,0),_mo_,_mn_];}
    var matrix_identity_mv_=xz_rotation_mt_(0);
    function face_mG_(v1_my_,v2_mx_,v3_mw_){return [0,v1_my_,v2_mx_,v3_mw_];}
    function create_canvas_mH_(w_mA_,h_mB_)
     {var c_mz_=unsafeCreateElement_k4_(document_kV_,_T_);
      if(1-(c_mz_.getContext==null_kf_?1:0))
       {c_mz_.width=w_mA_;c_mz_.height=h_mB_;return c_mz_;}
      throw [0,Canvas_not_available_lv_];}
    function min_mI_(u_mC_,v_mD_){return u_mC_<v_mD_?u_mC_:v_mD_;}
    function max_mJ_(u_mE_,v_mF_){return u_mE_<v_mF_?v_mF_:u_mE_;}
    var
     _mK_=8,
     _mL_=12,
     t_delta_mM_=pi_ly_/_mK_,
     n_mN_=_mK_*_mL_|0,
     vertices_mO_=caml_make_vect(n_mN_+2|0,vertex_mh_(0,0,0)),
     faces_mP_=caml_make_vect(n_mN_*2|0,face_mG_(0,0,0)),
     south_mQ_=n_mN_+1|0;
    caml_array_set(vertices_mO_,n_mN_,vertex_mh_(0,-1,0));
    caml_array_set(vertices_mO_,south_mQ_,vertex_mh_(0,1,0));
    var
     _mR_=0,
     _mS_=_mL_-1|0,
     p_delta_mX_=2*pi_ly_/_mL_,
     t_offset_mZ_=(pi_ly_-t_delta_mM_)/2;
    if(!(_mS_<_mR_))
     {var i_mT_=_mR_;
      for(;;)
       {var _mU_=0,_mV_=_mK_-1|0;
        if(!(_mV_<_mU_))
         {var j_mW_=_mU_;
          for(;;)
           {var
             phi_mY_=i_mT_*p_delta_mX_,
             theta_m0_=j_mW_*t_delta_mM_-t_offset_mZ_,
             k_m1_=(i_mT_*_mK_|0)+j_mW_|0;
            caml_array_set
             (vertices_mO_,
              k_m1_,
              vertex_mh_
               (Math.cos(phi_mY_)*Math.cos(theta_m0_),
                Math.sin(theta_m0_),
                Math.sin(phi_mY_)*Math.cos(theta_m0_)));
            if(0===j_mW_)
             {caml_array_set
               (faces_mP_,
                2*k_m1_|0,
                face_mG_(n_mN_,k_m1_,caml_mod(k_m1_+_mK_|0,n_mN_)));
              caml_array_set
               (faces_mP_,
                (2*k_m1_|0)+1|0,
                face_mG_
                 (south_mQ_,
                  caml_mod((k_m1_+(2*_mK_|0)|0)-1|0,n_mN_),
                  (k_m1_+_mK_|0)-1|0));}
            else
             {caml_array_set
               (faces_mP_,
                2*k_m1_|0,
                face_mG_(k_m1_,caml_mod(k_m1_+_mK_|0,n_mN_),k_m1_-1|0));
              caml_array_set
               (faces_mP_,
                (2*k_m1_|0)+1|0,
                face_mG_
                 (k_m1_-1|0,
                  caml_mod(k_m1_+_mK_|0,n_mN_),
                  caml_mod((k_m1_+_mK_|0)-1|0,n_mN_)));}
            var _m2_=j_mW_+1|0;
            if(_mV_!==j_mW_){var j_mW_=_m2_;continue;}
            break;}}
        var _m3_=i_mT_+1|0;
        if(_mS_!==i_mT_){var i_mT_=_m3_;continue;}
        break;}}
    var texture_qF_=_h_.toString();
    window_kU_.onload=
    _kN_
     (function(param_qJ_)
       {function _qw_(texture_m4_)
         {var
           w_m5_=texture_m4_.width,
           h_m6_=texture_m4_.height,
           canvas_m7_=create_canvas_mH_(w_m5_,h_m6_),
           ctx_m8_=canvas_m7_.getContext(_2d__kS_),
           _m9_=h_m6_/8|0,
           _m__=w_m5_/8|0,
           img_m$_=ctx_m8_.getImageData(0,0,_m__,_m9_),
           data_na_=img_m$_.data,
           inv_gamma_nq_=1/gamma_lA_;
          function update_shadow_nu_(obliquity_nb_)
           {var
             _nc_=0,
             _nd_=_m9_-1|0,
             cos_obl_nk_=Math.cos(obliquity_nb_),
             sin_obl_nj_=-Math.sin(obliquity_nb_);
            if(!(_nd_<_nc_))
             {var j_ne_=_nc_;
              for(;;)
               {var _nf_=0,_ng_=(_m__/2|0)-1|0;
                if(!(_ng_<_nf_))
                 {var i_nh_=_nf_;
                  for(;;)
                   {var
                     theta_ni_=(j_ne_/_m9_-0.5)*pi_ly_,
                     _nl_=
                      Math.cos(i_nh_/_m__*2*pi_ly_)*
                      Math.cos(theta_ni_)*
                      cos_obl_nk_+
                      Math.sin(theta_ni_)*
                      sin_obl_nj_,
                     k_no_=4*(i_nh_+j_ne_*_m__)|0,
                     k__nn_=4*(_m__-i_nh_+j_ne_*_m__-1)|0,
                     c_nm_=0<_nl_?dark_lB_:dark_lB_-_nl_*(1-dark_lB_)*1.2,
                     c_np_=c_nm_<=1?c_nm_:1,
                     c_nr_=255-(255.99*Math.pow(c_np_,inv_gamma_nq_)|0)|0;
                    data_na_[k_no_+3|0]=c_nr_;
                    data_na_[k__nn_+3|0]=c_nr_;
                    var _ns_=i_nh_+1|0;
                    if(_ng_!==i_nh_){var i_nh_=_ns_;continue;}
                    break;}}
                var _nt_=j_ne_+1|0;
                if(_nd_!==j_ne_){var j_ne_=_nt_;continue;}
                break;}}
            ctx_m8_.putImageData(img_m$_,0,0);
            ctx_m8_.globalCompositeOperation=_l_.toString();
            ctx_m8_.save();
            ctx_m8_.scale(8*(_m__+2|0)/_m__,8*(_m9_+2|0)/_m9_);
            ctx_m8_.translate(-1,-1);
            ctx_m8_.drawImage(canvas_m7_,0,0);
            return ctx_m8_.restore();}
          update_shadow_nu_(obliquity_lz_);
          var
           w_nv_=texture_m4_.width,
           canvas__nw_=create_canvas_mH_(w_nv_,texture_m4_.height),
           ctx__nx_=canvas__nw_.getContext(_2d__kS_),
           no_lighting_ny_=[0,0],
           canvas_nz_=create_canvas_mH_(width_lx_,width_lx_),
           canvas__nA_=create_canvas_mH_(width_lx_,width_lx_);
          _kM_(document_kV_.body,canvas_nz_);
          var
           ctx_nB_=canvas_nz_.getContext(_2d__kS_),
           ctx__nC_=canvas__nA_.getContext(_2d__kS_),
           r_nD_=width_lx_/2,
           tw_nE_=texture_m4_.width,
           th_nF_=texture_m4_.height,
           uv_nJ_=
            _bS_
             (function(v_nG_)
               {var
                 u_nH_=
                  (tw_nE_-
                   Math.atan2(v_nG_[3],v_nG_[1])*
                   ((tw_nE_/2-0.99)/pi_ly_)|
                   0)%
                  tw_nE_,
                 v_nI_=th_nF_/2+Math.asin(v_nG_[2])*((th_nF_-0.99)/pi_ly_)|0;
                if(0<=u_nH_)
                 {if(u_nH_<tw_nE_)
                   {if(0<=v_nI_)
                     {if(v_nI_<th_nF_)return [0,u_nH_,v_nI_];throw [0,_c_,_m_];}
                    throw [0,_c_,_n_];}
                  throw [0,_c_,_o_];}
                throw [0,_c_,_p_];},
              vertices_mO_),
           normals_oz_=
            _bS_
             (function(param_nK_)
               {var
                 v1_nL_=caml_array_get(vertices_mO_,param_nK_[1]),
                 v2_nN_=caml_array_get(vertices_mO_,param_nK_[2]),
                 _nM_=
                  vect_mr_(v1_nL_,caml_array_get(vertices_mO_,param_nK_[3])),
                 _nO_=vect_mr_(v1_nL_,v2_nN_),
                 z2_nP_=_nM_[3],
                 y2_nQ_=_nM_[2],
                 x2_nR_=_nM_[1],
                 z1_nS_=_nO_[3],
                 y1_nT_=_nO_[2],
                 x1_nU_=_nO_[1];
                return [254,
                        y1_nT_*z2_nP_-y2_nQ_*z1_nS_,
                        z1_nS_*x2_nR_-z2_nP_*x1_nU_,
                        x1_nU_*y2_nQ_-x2_nR_*y1_nT_];},
              faces_mP_),
           paused_oA_=[0,0],
           follow_oB_=[0,0],
           lighting_oC_=[0,1],
           clipped_oD_=[0,1],
           obl_oE_=[0,obliquity_lz_],
           face_info_oF_=
            _bS_
             (function(f_nV_)
               {var
                 match_nW_=caml_array_get(uv_nJ_,f_nV_[1]),
                 v1_nX_=match_nW_[2],
                 u1_nY_=match_nW_[1],
                 match_nZ_=caml_array_get(uv_nJ_,f_nV_[2]),
                 v2_n0_=match_nZ_[2],
                 u2_n1_=match_nZ_[1],
                 match_n2_=caml_array_get(uv_nJ_,f_nV_[3]),
                 v3_n3_=match_n2_[2],
                 u3_n4_=match_n2_[1],
                 mid_n5_=tw_nE_/2;
                if(u1_nY_==0)
                 {if(mid_n5_<u2_n1_||mid_n5_<u3_n4_)
                   var _n6_=1;
                  else
                   {var _n7_=0,_n6_=0;}
                  if(_n6_){var u1_n8_=tw_nE_-2,_n7_=1;}}
                else
                 var _n7_=0;
                if(!_n7_)var u1_n8_=u1_nY_;
                if(u2_n1_==0)
                 {if(mid_n5_<u1_n8_||mid_n5_<u3_n4_)
                   var _n9_=1;
                  else
                   {var _n__=0,_n9_=0;}
                  if(_n9_){var u2_n$_=tw_nE_-2,_n__=1;}}
                else
                 var _n__=0;
                if(!_n__)var u2_n$_=u2_n1_;
                if(u3_n4_==0)
                 {if(mid_n5_<u2_n$_||mid_n5_<u1_n8_)
                   var _oa_=1;
                  else
                   {var _ob_=0,_oa_=0;}
                  if(_oa_){var u3_oc_=tw_nE_-2,_ob_=1;}}
                else
                 var _ob_=0;
                if(!_ob_)var u3_oc_=u3_n4_;
                var mth_od_=th_nF_-2;
                if(v1_nX_==0||mth_od_<=v1_nX_)
                 var _oe_=0;
                else
                 {var u1_of_=u1_n8_,_oe_=1;}
                if(!_oe_)var u1_of_=(u2_n$_+u3_oc_)/2;
                if(v2_n0_==0||mth_od_<=v2_n0_)
                 var _og_=0;
                else
                 {var u2_oh_=u2_n$_,_og_=1;}
                if(!_og_)var u2_oh_=(u1_of_+u3_oc_)/2;
                if(v3_n3_==0||mth_od_<=v3_n3_)
                 var _oi_=0;
                else
                 {var u3_oj_=u3_oc_,_oi_=1;}
                if(!_oi_)var u3_oj_=(u2_oh_+u1_of_)/2;
                var
                 u1_ok_=max_mJ_(1,u1_of_),
                 u2_ol_=max_mJ_(1,u2_oh_),
                 u3_om_=max_mJ_(1,u3_oj_),
                 v1_on_=max_mJ_(1,v1_nX_),
                 v2_oo_=max_mJ_(1,v2_n0_),
                 v3_op_=max_mJ_(1,v3_n3_),
                 du2_oq_=u2_ol_-u1_ok_,
                 du3_or_=u3_om_-u1_ok_,
                 dv2_os_=v2_oo_-v1_on_,
                 dv3_ot_=v3_op_-v1_on_,
                 su_ou_=dv2_os_*du3_or_-dv3_ot_*du2_oq_,
                 sv_ov_=du2_oq_*dv3_ot_-du3_or_*dv2_os_,
                 u_ow_=max_mJ_(0,min_mI_(u1_ok_,min_mI_(u2_ol_,u3_om_))-4),
                 v_ox_=max_mJ_(0,min_mI_(v1_on_,min_mI_(v2_oo_,v3_op_))-4),
                 u__oy_=
                  min_mI_(tw_nE_,max_mJ_(u1_ok_,max_mJ_(u2_ol_,u3_om_))+4);
                return [0,
                        u1_ok_,
                        v1_on_,
                        du2_oq_/su_ou_,
                        dv2_os_/sv_ov_,
                        du3_or_/su_ou_,
                        dv3_ot_/sv_ov_,
                        u_ow_,
                        v_ox_,
                        u__oy_-u_ow_,
                        min_mI_(th_nF_,max_mJ_(v1_on_,max_mJ_(v2_oo_,v3_op_))+4)-
                        v_ox_];},
              faces_mP_),
           m_obliq_oG_=[0,xy_rotation_mu_(-obliquity_lz_)],
           m_oH_=[0,matrix_identity_mv_],
           phi_rot_oI_=[0,0],
           rateText_oJ_=document_kV_.createTextNode(_D_.toString()),
           ctrl_oK_=createDiv_lu_(document_kV_);
          ctrl_oK_.className=_C_.toString();
          var d_oL_=createDiv_lu_(document_kV_);
          _kM_(d_oL_,document_kV_.createTextNode(_B_.toString()));
          _kM_(ctrl_oK_,d_oL_);
          var form_oM_=createDiv_lu_(document_kV_);
          function br_oP_(param_oN_)
           {return unsafeCreateElement_k4_(document_kV_,_R_);}
          _kM_
           (form_oM_,
            toggle_button_mp_
             (_z_,_A_,function(p_oO_){paused_oA_[1]=p_oO_;return 0;}));
          _kM_(form_oM_,br_oP_(0));
          _kM_
           (form_oM_,
            toggle_button_mp_
             (_x_,_y_,function(f_oQ_){follow_oB_[1]=f_oQ_;return 0;}));
          _kM_(form_oM_,br_oP_(0));
          var b_oR_=createInput_ls_([0,button_type_lC_],0,document_kV_);
          b_oR_.value=_w_.toString();
          b_oR_.onclick=
          _kN_
           (function(param_oS_)
             {m_oH_[1]=matrix_identity_mv_;
              phi_rot_oI_[1]=0;
              m_obliq_oG_[1]=xy_rotation_mu_(-obl_oE_[1]);
              return _true_kh_;});
          _kM_(form_oM_,b_oR_);
          _kM_(form_oM_,br_oP_(0));
          var lab_oT_=createLabel_lt_(document_kV_);
          _kM_(lab_oT_,document_kV_.createTextNode(_v_.toString()));
          var
           _oU_=unsafeCreateElementEx_lm_(0,0,document_kV_,_M_),
           param_oV_=_u_;
          for(;;)
           {if(param_oV_)
             {var
               l_oY_=param_oV_[2],
               a_oX_=param_oV_[1],
               _oW_=unsafeCreateElement_k4_(document_kV_,_L_);
              _kM_(_oW_,document_kV_.createTextNode(a_oX_.toString()));
              _oU_.add(_oW_,null_kf_);
              var param_oV_=l_oY_;
              continue;}
            _oU_.onchange=
            _kN_
             (function(param_o1_)
               {var
                 _oZ_=_oU_.selectedIndex,
                 o_o0_=0===_oZ_?obliquity_lz_:1===_oZ_?0:-obliquity_lz_;
                update_shadow_nu_(o_o0_);
                obl_oE_[1]=o_o0_;
                return _true_kh_;});
            _kM_(lab_oT_,_oU_);
            _kM_(form_oM_,lab_oT_);
            _kM_(ctrl_oK_,form_oM_);
            var form_o2_=createDiv_lu_(document_kV_);
            _kM_
             (form_o2_,
              checkbox_mq_
               (_t_,1,function(l_o3_){lighting_oC_[1]=l_o3_;return 0;}));
            _kM_(form_o2_,br_oP_(0));
            _kM_
             (form_o2_,
              checkbox_mq_
               (_s_,1,function(l_o4_){clipped_oD_[1]=l_o4_;return 0;}));
            _kM_(form_o2_,br_oP_(0));
            _kM_(form_o2_,document_kV_.createTextNode(_r_.toString()));
            _kM_(form_o2_,rateText_oJ_);
            _kM_(ctrl_oK_,form_o2_);
            _kM_(document_kV_.body,ctrl_oK_);
            var _o5_=unsafeCreateElement_k4_(document_kV_,_Q_);
            _o5_.innerHTML=_q_.toString();
            _kM_(document_kV_.body,_o5_);
            var mx_o6_=[0,0],my_o7_=[0,0];
            canvas_nz_.onmousedown=
            _kN_
             (function(ev_o8_)
               {mx_o6_[1]=ev_o8_.clientX;
                my_o7_[1]=ev_o8_.clientY;
                var
                 c2_pj_=[0,null_kf_],
                 c1_pk_=
                  _kP_
                   (document_kV_,
                    mousemove_kT_,
                    _kN_
                     (function(ev_o9_)
                       {var
                         x_o__=ev_o9_.clientX,
                         y_o$_=ev_o9_.clientY,
                         dx_pa_=x_o__-mx_o6_[1]|0,
                         dy_pb_=y_o$_-my_o7_[1]|0;
                        if(0!==dy_pb_)
                         {var
                           _pc_=2*dy_pb_/width_lx_,
                           cos_phi_pd_=Math.cos(_pc_),
                           sin_phi_pe_=Math.sin(_pc_),
                           _pf_=m_oH_[1],
                           _pg_=vertex_mh_(0,-sin_phi_pe_,cos_phi_pd_),
                           _ph_=vertex_mh_(0,cos_phi_pd_,sin_phi_pe_);
                          m_oH_[1]=
                          matrix_mul_ms_([0,vertex_mh_(1,0,0),_ph_,_pg_],_pf_);}
                        if(0!==dx_pa_)
                         {var _pi_=m_oH_[1];
                          m_oH_[1]=
                          matrix_mul_ms_(xz_rotation_mt_(2*dx_pa_/width_lx_),_pi_);}
                        mx_o6_[1]=x_o__;
                        my_o7_[1]=y_o$_;
                        return _true_kh_;}),
                    _true_kh_);
                c2_pj_[1]=
                _kp_
                 (_kP_
                   (document_kV_,
                    mouseup_kR_,
                    _kN_
                     (function(param_pm_)
                       {_kQ_(c1_pk_);
                        var _pl_=c2_pj_[1];
                        if(_pl_!=null_kf_)_kQ_(_pl_);
                        return _true_kh_;}),
                    _true_kh_));
                return _false_ki_;});
            var
             ti_pn_=[0,new date_constr_kk_().getTime()],
             fps_po_=[0,0],
             loop_qd_=
              function(t_p9_,phi_pp_)
               {var rotation_pq_=xz_rotation_mt_(phi_pp_-phi_rot_oI_[1]);
                if(lighting_oC_[1])
                 {no_lighting_ny_[1]=0;
                  ctx__nx_.drawImage(texture_m4_,0,0);
                  var
                   i_pr_=
                    (2*pi_ly_-phi_pp_%(2*pi_ly_))*w_nv_/2/pi_ly_%w_nv_|0;
                  ctx__nx_.drawImage(canvas_m7_,i_pr_,0);
                  ctx__nx_.drawImage(canvas_m7_,i_pr_-w_nv_,0);}
                else
                 if(!no_lighting_ny_[1])
                  {ctx__nx_.drawImage(texture_m4_,0,0);no_lighting_ny_[1]=1;}
                var
                 _ps_=matrix_mul_ms_(m_obliq_oG_[1],rotation_pq_),
                 m_pt_=matrix_mul_ms_(m_oH_[1],_ps_),
                 _pv_=
                  _bS_
                   (function(v_pu_){return matrix_vect_mul_mb_(m_pt_,v_pu_);},
                    vertices_mO_),
                 _pw_=matrix_vect_mul_mb_(matrix_transp_l9_(m_pt_),v_i_);
                ctx__nC_.clearRect(0,0,width_lx_,width_lx_);
                ctx__nC_.save();
                if(clipped_oD_[1])
                 {ctx__nC_.beginPath();
                  ctx__nC_.arc(r_nD_,r_nD_,r_nD_*0.95,0,-2*pi_ly_,_true_kh_);
                  ctx__nC_.clip();}
                ctx__nC_.setTransform(r_nD_-2,0,0,r_nD_-2,r_nD_,r_nD_);
                ctx__nC_.globalCompositeOperation=_G_.toString();
                var _px_=0,_py_=faces_mP_.length-1-1|0;
                if(!(_py_<_px_))
                 {var i_pz_=_px_;
                  for(;;)
                   {var
                     _pA_=faces_mP_[i_pz_+1],
                     match_pB_=caml_array_get(_pv_,_pA_[1]),
                     y1_pC_=match_pB_[2],
                     x1_pD_=match_pB_[1],
                     match_pE_=caml_array_get(_pv_,_pA_[2]),
                     y2_pF_=match_pE_[2],
                     x2_pG_=match_pE_[1],
                     match_pH_=caml_array_get(_pv_,_pA_[3]),
                     y3_pI_=match_pH_[2],
                     x3_pJ_=match_pH_[1],
                     _pK_=caml_array_get(normals_oz_,i_pz_);
                    if(0<=_pK_[1]*_pw_[1]+_pK_[2]*_pw_[2]+_pK_[3]*_pw_[3])
                     {ctx__nC_.beginPath();
                      ctx__nC_.moveTo(x1_pD_,y1_pC_);
                      ctx__nC_.lineTo(x2_pG_,y2_pF_);
                      ctx__nC_.lineTo(x3_pJ_,y3_pI_);
                      ctx__nC_.closePath();
                      ctx__nC_.save();
                      ctx__nC_.clip();
                      var
                       match_pL_=caml_array_get(face_info_oF_,i_pz_),
                       dv_pM_=match_pL_[10],
                       du_pN_=match_pL_[9],
                       v_pO_=match_pL_[8],
                       u_pP_=match_pL_[7],
                       dv3_pQ_=match_pL_[6],
                       du3_pR_=match_pL_[5],
                       dv2_pS_=match_pL_[4],
                       du2_pT_=match_pL_[3],
                       v1_pU_=match_pL_[2],
                       u1_pV_=match_pL_[1],
                       dx2_pW_=x2_pG_-x1_pD_,
                       dx3_pX_=x3_pJ_-x1_pD_,
                       dy2_pY_=y2_pF_-y1_pC_,
                       dy3_pZ_=y3_pI_-y1_pC_,
                       a_p0_=dx2_pW_*dv3_pQ_-dx3_pX_*dv2_pS_,
                       b_p1_=dx2_pW_*du3_pR_-dx3_pX_*du2_pT_,
                       d_p2_=dy2_pY_*dv3_pQ_-dy3_pZ_*dv2_pS_,
                       e_p3_=dy2_pY_*du3_pR_-dy3_pZ_*du2_pT_;
                      ctx__nC_.transform
                       (a_p0_,
                        d_p2_,
                        b_p1_,
                        e_p3_,
                        x1_pD_-a_p0_*u1_pV_-b_p1_*v1_pU_,
                        y1_pC_-d_p2_*u1_pV_-e_p3_*v1_pU_);
                      ctx__nC_.drawImage
                       (canvas__nw_,
                        u_pP_,
                        v_pO_,
                        du_pN_,
                        dv_pM_,
                        u_pP_,
                        v_pO_,
                        du_pN_,
                        dv_pM_);
                      ctx__nC_.restore();}
                    var _p4_=i_pz_+1|0;
                    if(_py_!==i_pz_){var i_pz_=_p4_;continue;}
                    break;}}
                ctx__nC_.restore();
                ctx_nB_.globalCompositeOperation=_F_.toString();
                ctx_nB_.drawImage(canvas__nA_,0,0);
                try {ctx_nB_.getImageData(0,0,1,1);}catch(_qu_){}
                var
                 t__p5_=new date_constr_kk_().getTime(),
                 hz_p6_=1000/(t__p5_-ti_pn_[1]),
                 _p7_=fps_po_[1]==0?hz_p6_:0.9*fps_po_[1]+0.1*hz_p6_;
                fps_po_[1]=_p7_;
                rateText_oJ_.data=_d3_(_hT_,_E_,fps_po_[1]).toString();
                ti_pn_[1]=t__p5_;
                function _qg_(param_qe_)
                 {var
                   t__p8_=new date_constr_kk_().getTime(),
                   dt_p__=t__p8_-t_p9_,
                   dt_p$_=dt_p__<0?0:1000<dt_p__?0:dt_p__,
                   angle_qa_=2*pi_ly_*dt_p$_/1000/10,
                   _qb_=
                    paused_oA_[1]
                     ?0
                     :follow_oB_[1]?(phi_rot_oI_[1]=phi_rot_oI_[1]+angle_qa_,1):0;
                  _qb_;
                  var _qc_=paused_oA_[1]?phi_pp_:phi_pp_+angle_qa_;
                  return loop_qd_(t__p8_,_qc_);}
                var
                 match_qf_=task_j6_(0),
                 t_qh_=match_qf_[1],
                 w_qi_=match_qf_[2],
                 _qk_=0.01*1000,
                 id_ql_=
                  window_kU_.setTimeout
                   (caml_js_wrap_callback
                     (function(param_qj_){return wakeup_j5_(w_qi_,0);}),
                    _qk_);
                function _qn_(param_qm_)
                 {return window_kU_.clearTimeout(id_ql_);}
                var _qo_=repr_i8_(t_qh_)[1];
                switch(_qo_[0])
                 {case 1:
                   var
                    _qp_=
                     _qo_[1][1]===Canceled_h6_?(call_unsafe_i1_(_qn_,0),1):0;
                   break;
                  case 2:
                   var
                    sleeper_qq_=_qo_[1],
                    handler_qr_=[0,current_data_h7_[1],_qn_],
                    _qs_=sleeper_qq_[4],
                    _qt_=typeof _qs_==="number"?handler_qr_:[2,handler_qr_,_qs_];
                   sleeper_qq_[4]=_qt_;
                   var _qp_=1;
                   break;
                  default:var _qp_=0;}
                _qp_;
                return bind_j7_(t_qh_,_qg_);};
            return loop_qd_(new date_constr_kk_().getTime(),0);}}
        var _qv_=unsafeCreateElement_k4_(document_kV_,_S_);
        function _qz_(param_qx_){return [0,[0,_qv_]];}
        var match_qy_=task_j6_(0),w_qB_=match_qy_[2],t_qC_=match_qy_[1];
        function cont_qD_(x_qA_){return wakeup_j5_(w_qB_,x_qA_);}
        _qv_.onload=_kN_(function(param_qE_){cont_qD_(0);return _false_ki_;});
        _qv_.src=texture_qF_;
        var _qG_=repr_i8_(bind_j7_(bind_j7_(t_qC_,_qz_),_qw_))[1];
        switch(_qG_[0])
         {case 1:throw _qG_[1];
          case 2:
           var sleeper_qI_=_qG_[1];
           add_immutable_waiter_j3_
            (sleeper_qI_,
             function(param_qH_)
              {switch(param_qH_[0])
                {case 0:return 0;
                 case 1:return _iE_(param_qH_[1]);
                 default:throw [0,_c_,_ak_];}});
           break;
          case 3:throw [0,_c_,_aj_];
          default:}
        return _false_ki_;});
    do_at_exit_bD_(0);
    return;}
  ());
