// This program was compiled from OCaml by js_of_ocaml 1.3
function caml_raise_with_arg (tag, arg) { throw [0, tag, arg]; }
function caml_raise_with_string (tag, msg) {
  caml_raise_with_arg (tag, new MlWrappedString (msg));
}
function caml_invalid_argument (msg) {
  caml_raise_with_string(caml_global_data[4], msg);
}
function caml_array_bound_error () {
  caml_invalid_argument("index out of bounds");
}
function caml_str_repeat(n, s) {
  if (!n) { return ""; }
  if (n & 1) { return caml_str_repeat(n - 1, s) + s; }
  var r = caml_str_repeat(n >> 1, s);
  return r + r;
}
function MlString(param) {
  if (param != null) {
    this.bytes = this.fullBytes = param;
    this.last = this.len = param.length;
  }
}
MlString.prototype = {
  string:null,
  bytes:null,
  fullBytes:null,
  array:null,
  len:null,
  last:0,
  toJsString:function() {
    return this.string = decodeURIComponent (escape(this.getFullBytes()));
  },
  toBytes:function() {
    if (this.string != null)
      var b = unescape (encodeURIComponent (this.string));
    else {
      var b = "", a = this.array, l = a.length;
      for (var i = 0; i < l; i ++) b += String.fromCharCode (a[i]);
    }
    this.bytes = this.fullBytes = b;
    this.last = this.len = b.length;
    return b;
  },
  getBytes:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return b;
  },
  getFullBytes:function() {
    var b = this.fullBytes;
    if (b !== null) return b;
    b = this.bytes;
    if (b == null) b = this.toBytes ();
    if (this.last < this.len) {
      this.bytes = (b += caml_str_repeat(this.len - this.last, '\0'));
      this.last = this.len;
    }
    this.fullBytes = b;
    return b;
  },
  toArray:function() {
    var b = this.bytes;
    if (b == null) b = this.toBytes ();
    var a = [], l = this.last;
    for (var i = 0; i < l; i++) a[i] = b.charCodeAt(i);
    for (l = this.len; i < l; i++) a[i] = 0;
    this.string = this.bytes = this.fullBytes = null;
    this.last = this.len;
    this.array = a;
    return a;
  },
  getArray:function() {
    var a = this.array;
    if (!a) a = this.toArray();
    return a;
  },
  getLen:function() {
    var len = this.len;
    if (len !== null) return len;
    this.toBytes();
    return this.len;
  },
  toString:function() { var s = this.string; return s?s:this.toJsString(); },
  valueOf:function() { var s = this.string; return s?s:this.toJsString(); },
  blitToArray:function(i1, a2, i2, l) {
    var a1 = this.array;
    if (a1) {
      if (i2 <= i1) {
        for (var i = 0; i < l; i++) a2[i2 + i] = a1[i1 + i];
      } else {
        for (var i = l - 1; i >= 0; i--) a2[i2 + i] = a1[i1 + i];
      }
    } else {
      var b = this.bytes;
      if (b == null) b = this.toBytes();
      var l1 = this.last - i1;
      if (l <= l1)
        for (var i = 0; i < l; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
      else {
        for (var i = 0; i < l1; i++) a2 [i2 + i] = b.charCodeAt(i1 + i);
        for (; i < l; i++) a2 [i2 + i] = 0;
      }
    }
  },
  get:function (i) {
    var a = this.array;
    if (a) return a[i];
    var b = this.bytes;
    if (b == null) b = this.toBytes();
    return (i<this.last)?b.charCodeAt(i):0;
  },
  safeGet:function (i) {
    if (!this.len) this.toBytes();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    return this.get(i);
  },
  set:function (i, c) {
    var a = this.array;
    if (!a) {
      if (this.last == i) {
        this.bytes += String.fromCharCode (c & 0xff);
        this.last ++;
        return 0;
      }
      a = this.toArray();
    } else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    a[i] = c & 0xff;
    return 0;
  },
  safeSet:function (i, c) {
    if (this.len == null) this.toBytes ();
    if ((i < 0) || (i >= this.len)) caml_array_bound_error ();
    this.set(i, c);
  },
  fill:function (ofs, len, c) {
    if (ofs >= this.last && this.last && c == 0) return;
    var a = this.array;
    if (!a) a = this.toArray();
    else if (this.bytes != null) {
      this.bytes = this.fullBytes = this.string = null;
    }
    var l = ofs + len;
    for (var i = ofs; i < l; i++) a[i] = c;
  },
  compare:function (s2) {
    if (this.string != null && s2.string != null) {
      if (this.string < s2.string) return -1;
      if (this.string > s2.string) return 1;
      return 0;
    }
    var b1 = this.getFullBytes ();
    var b2 = s2.getFullBytes ();
    if (b1 < b2) return -1;
    if (b1 > b2) return 1;
    return 0;
  },
  equal:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string == s2.string;
    return this.getFullBytes () == s2.getFullBytes ();
  },
  lessThan:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string < s2.string;
    return this.getFullBytes () < s2.getFullBytes ();
  },
  lessEqual:function (s2) {
    if (this.string != null && s2.string != null)
      return this.string <= s2.string;
    return this.getFullBytes () <= s2.getFullBytes ();
  }
}
function MlWrappedString (s) { this.string = s; }
MlWrappedString.prototype = new MlString();
function MlMakeString (l) { this.bytes = ""; this.len = l; }
MlMakeString.prototype = new MlString ();
function caml_array_get (array, index) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  return array[index+1];
}
function caml_array_set (array, index, newval) {
  if ((index < 0) || (index >= array.length - 1)) caml_array_bound_error();
  array[index+1]=newval; return 0;
}
function caml_blit_string(s1, i1, s2, i2, len) {
  if (len === 0) return;
  if (i2 === s2.last && s2.bytes != null) {
    var b = s1.bytes;
    if (b == null) b = s1.toBytes ();
    if (i1 > 0 || s1.last > len) b = b.slice(i1, i1 + len);
    s2.bytes += b;
    s2.last += b.length;
    return;
  }
  var a = s2.array;
  if (!a) a = s2.toArray(); else { s2.bytes = s2.string = null; }
  s1.blitToArray (i1, a, i2, len);
}
function caml_call_gen(f, args) {
  if(f.fun)
    return caml_call_gen(f.fun, args);
  var n = f.length;
  var d = n - args.length;
  if (d == 0)
    return f.apply(null, args);
  else if (d < 0)
    return caml_call_gen(f.apply(null, args.slice(0,n)), args.slice(n));
  else
    return function (x){ return caml_call_gen(f, args.concat([x])); };
}
function caml_classify_float (x) {
  if (isFinite (x)) {
    if (Math.abs(x) >= 2.2250738585072014e-308) return 0;
    if (x != 0) return 1;
    return 2;
  }
  return isNaN(x)?4:3;
}
function caml_int64_compare(x,y) {
  var x3 = x[3] << 16;
  var y3 = y[3] << 16;
  if (x3 > y3) return 1;
  if (x3 < y3) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int_compare (a, b) {
  if (a < b) return (-1); if (a == b) return 0; return 1;
}
function caml_compare_val (a, b, total) {
  var stack = [];
  for(;;) {
    if (!(total && a === b)) {
      if (a instanceof MlString) {
        if (b instanceof MlString) {
            if (a != b) {
		var x = a.compare(b);
		if (x != 0) return x;
	    }
        } else
          return 1;
      } else if (a instanceof Array && a[0] === (a[0]|0)) {
        var ta = a[0];
        if (ta === 250) {
          a = a[1];
          continue;
        } else if (b instanceof Array && b[0] === (b[0]|0)) {
          var tb = b[0];
          if (tb === 250) {
            b = b[1];
            continue;
          } else if (ta != tb) {
            return (ta < tb)?-1:1;
          } else {
            switch (ta) {
            case 248: {
		var x = caml_int_compare(a[2], b[2]);
		if (x != 0) return x;
		break;
	    }
            case 255: {
		var x = caml_int64_compare(a, b);
		if (x != 0) return x;
		break;
	    }
            default:
              if (a.length != b.length) return (a.length < b.length)?-1:1;
              if (a.length > 1) stack.push(a, b, 1);
            }
          }
        } else
          return 1;
      } else if (b instanceof MlString ||
                 (b instanceof Array && b[0] === (b[0]|0))) {
        return -1;
      } else {
        if (a < b) return -1;
        if (a > b) return 1;
        if (total && a != b) {
          if (a == a) return 1;
          if (b == b) return -1;
        }
      }
    }
    if (stack.length == 0) return 0;
    var i = stack.pop();
    b = stack.pop();
    a = stack.pop();
    if (i + 1 < a.length) stack.push(a, b, i + 1);
    a = a[i];
    b = b[i];
  }
}
function caml_compare (a, b) { return caml_compare_val (a, b, true); }
function caml_create_string(len) {
  if (len < 0) caml_invalid_argument("String.create");
  return new MlMakeString(len);
}
function caml_equal (x, y) { return +(caml_compare_val(x,y,false) == 0); }
function caml_fill_string(s, i, l, c) { s.fill (i, l, c); }
function caml_parse_format (fmt) {
  fmt = fmt.toString ();
  var len = fmt.length;
  if (len > 31) caml_invalid_argument("format_int: format too long");
  var f =
    { justify:'+', signstyle:'-', filler:' ', alternate:false,
      base:0, signedconv:false, width:0, uppercase:false,
      sign:1, prec:-1, conv:'f' };
  for (var i = 0; i < len; i++) {
    var c = fmt.charAt(i);
    switch (c) {
    case '-':
      f.justify = '-'; break;
    case '+': case ' ':
      f.signstyle = c; break;
    case '0':
      f.filler = '0'; break;
    case '#':
      f.alternate = true; break;
    case '1': case '2': case '3': case '4': case '5':
    case '6': case '7': case '8': case '9':
      f.width = 0;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.width = f.width * 10 + c; i++
      }
      i--;
     break;
    case '.':
      f.prec = 0;
      i++;
      while (c=fmt.charCodeAt(i) - 48, c >= 0 && c <= 9) {
        f.prec = f.prec * 10 + c; i++
      }
      i--;
    case 'd': case 'i':
      f.signedconv = true; /* fallthrough */
    case 'u':
      f.base = 10; break;
    case 'x':
      f.base = 16; break;
    case 'X':
      f.base = 16; f.uppercase = true; break;
    case 'o':
      f.base = 8; break;
    case 'e': case 'f': case 'g':
      f.signedconv = true; f.conv = c; break;
    case 'E': case 'F': case 'G':
      f.signedconv = true; f.uppercase = true;
      f.conv = c.toLowerCase (); break;
    }
  }
  return f;
}
function caml_finish_formatting(f, rawbuffer) {
  if (f.uppercase) rawbuffer = rawbuffer.toUpperCase();
  var len = rawbuffer.length;
  if (f.signedconv && (f.sign < 0 || f.signstyle != '-')) len++;
  if (f.alternate) {
    if (f.base == 8) len += 1;
    if (f.base == 16) len += 2;
  }
  var buffer = "";
  if (f.justify == '+' && f.filler == ' ')
    for (var i = len; i < f.width; i++) buffer += ' ';
  if (f.signedconv) {
    if (f.sign < 0) buffer += '-';
    else if (f.signstyle != '-') buffer += f.signstyle;
  }
  if (f.alternate && f.base == 8) buffer += '0';
  if (f.alternate && f.base == 16) buffer += "0x";
  if (f.justify == '+' && f.filler == '0')
    for (var i = len; i < f.width; i++) buffer += '0';
  buffer += rawbuffer;
  if (f.justify == '-')
    for (var i = len; i < f.width; i++) buffer += ' ';
  return new MlWrappedString (buffer);
}
function caml_format_float (fmt, x) {
  var s, f = caml_parse_format(fmt);
  var prec = (f.prec < 0)?6:f.prec;
  if (x < 0) { f.sign = -1; x = -x; }
  if (isNaN(x)) { s = "nan"; f.filler = ' '; }
  else if (!isFinite(x)) { s = "inf"; f.filler = ' '; }
  else
    switch (f.conv) {
    case 'e':
      var s = x.toExponential(prec);
      var i = s.length;
      if (s.charAt(i - 3) == 'e')
        s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
      break;
    case 'f':
      s = x.toFixed(prec); break;
    case 'g':
      prec = prec?prec:1;
      s = x.toExponential(prec - 1);
      var j = s.indexOf('e');
      var exp = +s.slice(j + 1);
      if (exp < -4 || x.toFixed(0).length > prec) {
        var i = j - 1; while (s.charAt(i) == '0') i--;
        if (s.charAt(i) == '.') i--;
        s = s.slice(0, i + 1) + s.slice(j);
        i = s.length;
        if (s.charAt(i - 3) == 'e')
          s = s.slice (0, i - 1) + '0' + s.slice (i - 1);
        break;
      } else {
        var p = prec;
        if (exp < 0) { p -= exp + 1; s = x.toFixed(p); }
        else while (s = x.toFixed(p), s.length > prec + 1) p--;
        if (p) {
          var i = s.length - 1; while (s.charAt(i) == '0') i--;
          if (s.charAt(i) == '.') i--;
          s = s.slice(0, i + 1);
        }
      }
      break;
    }
  return caml_finish_formatting(f, s);
}
function caml_format_int(fmt, i) {
  if (fmt.toString() == "%d") return new MlWrappedString(""+i);
  var f = caml_parse_format(fmt);
  if (i < 0) { if (f.signedconv) { f.sign = -1; i = -i; } else i >>>= 0; }
  var s = i.toString(f.base);
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - s.length;
    if (n > 0) s = caml_str_repeat (n, '0') + s;
  }
  return caml_finish_formatting(f, s);
}
function caml_get_exception_backtrace () {
  caml_invalid_argument
    ("Primitive 'caml_get_exception_backtrace' not implemented");
}
function caml_greaterequal (x, y) { return +(caml_compare(x,y,false) >= 0); }
function caml_int64_to_bytes(x) {
  return [x[3] >> 8, x[3] & 0xff, x[2] >> 16, (x[2] >> 8) & 0xff, x[2] & 0xff,
          x[1] >> 16, (x[1] >> 8) & 0xff, x[1] & 0xff];
}
function caml_int64_bits_of_float (x) {
  if (!isFinite(x)) {
    if (isNaN(x)) return [255, 1, 0, 0xfff0];
    return (x > 0)?[255,0,0,0x7ff0]:[255,0,0,0xfff0];
  }
  var sign = (x>=0)?0:0x8000;
  if (sign) x = -x;
  var exp = Math.floor(Math.LOG2E*Math.log(x)) + 1023;
  if (exp <= 0) {
    exp = 0;
    x /= Math.pow(2,-1026);
  } else {
    x /= Math.pow(2,exp-1027);
    if (x < 16) { x *= 2; exp -=1; }
    if (exp == 0) { x /= 2; }
  }
  var k = Math.pow(2,24);
  var r3 = x|0;
  x = (x - r3) * k;
  var r2 = x|0;
  x = (x - r2) * k;
  var r1 = x|0;
  r3 = (r3 &0xf) | sign | exp << 4;
  return [255, r1, r2, r3];
}
function caml_hash_univ_param (count, limit, obj) {
  var hash_accu = 0;
  function hash_aux (obj) {
    limit --;
    if (count < 0 || limit < 0) return;
    if (obj instanceof Array && obj[0] === (obj[0]|0)) {
      switch (obj[0]) {
      case 248:
        count --;
        hash_accu = (hash_accu * 65599 + obj[2]) | 0;
        break
      case 250:
        limit++; hash_aux(obj); break;
      case 255:
        count --;
        hash_accu = (hash_accu * 65599 + obj[1] + (obj[2] << 24)) | 0;
        break;
      default:
        count --;
        hash_accu = (hash_accu * 19 + obj[0]) | 0;
        for (var i = obj.length - 1; i > 0; i--) hash_aux (obj[i]);
      }
    } else if (obj instanceof MlString) {
      count --;
      var a = obj.array, l = obj.getLen ();
      if (a) {
        for (var i = 0; i < l; i++) hash_accu = (hash_accu * 19 + a[i]) | 0;
      } else {
        var b = obj.getFullBytes ();
        for (var i = 0; i < l; i++)
          hash_accu = (hash_accu * 19 + b.charCodeAt(i)) | 0;
      }
    } else if (obj === (obj|0)) {
      count --;
      hash_accu = (hash_accu * 65599 + obj) | 0;
    } else if (obj === +obj) {
      count--;
      var p = caml_int64_to_bytes (caml_int64_bits_of_float (obj));
      for (var i = 7; i >= 0; i--) hash_accu = (hash_accu * 19 + p[i]) | 0;
    }
  }
  hash_aux (obj);
  return hash_accu & 0x3FFFFFFF;
}
function caml_int64_is_negative(x) {
  return (x[3] << 16) < 0;
}
function caml_int64_neg (x) {
  var y1 = - x[1];
  var y2 = - x[2] + (y1 >> 24);
  var y3 = - x[3] + (y2 >> 24);
  return [255, y1 & 0xffffff, y2 & 0xffffff, y3 & 0xffff];
}
function caml_int64_of_int32 (x) {
  return [255, x & 0xffffff, (x >> 24) & 0xffffff, (x >> 31) & 0xffff]
}
function caml_int64_ucompare(x,y) {
  if (x[3] > y[3]) return 1;
  if (x[3] < y[3]) return -1;
  if (x[2] > y[2]) return 1;
  if (x[2] < y[2]) return -1;
  if (x[1] > y[1]) return 1;
  if (x[1] < y[1]) return -1;
  return 0;
}
function caml_int64_lsl1 (x) {
  x[3] = (x[3] << 1) | (x[2] >> 23);
  x[2] = ((x[2] << 1) | (x[1] >> 23)) & 0xffffff;
  x[1] = (x[1] << 1) & 0xffffff;
}
function caml_int64_lsr1 (x) {
  x[1] = ((x[1] >>> 1) | (x[2] << 23)) & 0xffffff;
  x[2] = ((x[2] >>> 1) | (x[3] << 23)) & 0xffffff;
  x[3] = x[3] >>> 1;
}
function caml_int64_sub (x, y) {
  var z1 = x[1] - y[1];
  var z2 = x[2] - y[2] + (z1 >> 24);
  var z3 = x[3] - y[3] + (z2 >> 24);
  return [255, z1 & 0xffffff, z2 & 0xffffff, z3 & 0xffff];
}
function caml_int64_udivmod (x, y) {
  var offset = 0;
  var modulus = x.slice ();
  var divisor = y.slice ();
  var quotient = [255, 0, 0, 0];
  while (caml_int64_ucompare (modulus, divisor) > 0) {
    offset++;
    caml_int64_lsl1 (divisor);
  }
  while (offset >= 0) {
    offset --;
    caml_int64_lsl1 (quotient);
    if (caml_int64_ucompare (modulus, divisor) >= 0) {
      quotient[1] ++;
      modulus = caml_int64_sub (modulus, divisor);
    }
    caml_int64_lsr1 (divisor);
  }
  return [0,quotient, modulus];
}
function caml_int64_to_int32 (x) {
  return x[1] | (x[2] << 24);
}
function caml_int64_is_zero(x) {
  return (x[3]|x[2]|x[1]) == 0;
}
function caml_int64_format (fmt, x) {
  var f = caml_parse_format(fmt);
  if (f.signedconv && caml_int64_is_negative(x)) {
    f.sign = -1; x = caml_int64_neg(x);
  }
  var buffer = "";
  var wbase = caml_int64_of_int32(f.base);
  var cvtbl = "0123456789abcdef";
  do {
    var p = caml_int64_udivmod(x, wbase);
    x = p[1];
    buffer = cvtbl.charAt(caml_int64_to_int32(p[2])) + buffer;
  } while (! caml_int64_is_zero(x));
  if (f.prec >= 0) {
    f.filler = ' ';
    var n = f.prec - buffer.length;
    if (n > 0) buffer = caml_str_repeat (n, '0') + buffer;
  }
  return caml_finish_formatting(f, buffer);
}
function caml_parse_sign_and_base (s) {
  var i = 0, base = 10, sign = s.get(0) == 45?(i++,-1):1;
  if (s.get(i) == 48)
    switch (s.get(i + 1)) {
    case 120: case 88: base = 16; i += 2; break;
    case 111: case 79: base =  8; i += 2; break;
    case  98: case 66: base =  2; i += 2; break;
    }
  return [i, sign, base];
}
function caml_parse_digit(c) {
  if (c >= 48 && c <= 57)  return c - 48;
  if (c >= 65 && c <= 90)  return c - 55;
  if (c >= 97 && c <= 122) return c - 87;
  return -1;
}
var caml_global_data = [0];
function caml_failwith (msg) {
  caml_raise_with_string(caml_global_data[3], msg);
}
function caml_int_of_string (s) {
  var r = caml_parse_sign_and_base (s);
  var i = r[0], sign = r[1], base = r[2];
  var threshold = -1 >>> 0;
  var c = s.get(i);
  var d = caml_parse_digit(c);
  if (d < 0 || d >= base) caml_failwith("int_of_string");
  var res = d;
  for (;;) {
    i++;
    c = s.get(i);
    if (c == 95) continue;
    d = caml_parse_digit(c);
    if (d < 0 || d >= base) break;
    res = base * res + d;
    if (res > threshold) caml_failwith("int_of_string");
  }
  if (i != s.getLen()) caml_failwith("int_of_string");
  res = sign * res;
  if ((res | 0) != res) caml_failwith("int_of_string");
  return res;
}
function caml_is_printable(c) { return +(c > 31 && c < 127); }
function caml_js_call(f, o, args) { return f.apply(o, args.slice(1)); }
function caml_js_from_byte_string (s) {return s.getFullBytes();}
function caml_js_get_console () {
  var c = this.console?this.console:{};
  var m = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml",
           "trace", "group", "groupCollapsed", "groupEnd", "time", "timeEnd"];
  function f () {}
  for (var i = 0; i < m.length; i++) if (!c[m[i]]) c[m[i]]=f;
  return c;
}
var caml_js_regexps = { amp:/&/g, lt:/</g, quot:/\"/g, all:/[&<\"]/ };
function caml_js_html_escape (s) {
  if (!caml_js_regexps.all.test(s)) return s;
  return s.replace(caml_js_regexps.amp, "&amp;")
          .replace(caml_js_regexps.lt, "&lt;")
          .replace(caml_js_regexps.quot, "&quot;");
}
function caml_js_on_ie () {
  var ua = this.navigator?this.navigator.userAgent:"";
  return ua.indexOf("MSIE") != -1 && ua.indexOf("Opera") != 0;
}
function caml_js_pure_expr (f) { return f(); }
function caml_js_to_byte_string (s) {return new MlString (s);}
function caml_js_wrap_callback(f) {
  var toArray = Array.prototype.slice;
  return function () {
    var args = (arguments.length > 0)?toArray.call (arguments):[undefined];
    return caml_call_gen(f, args);
  }
}
function caml_lessequal (x, y) { return +(caml_compare(x,y,false) <= 0); }
function caml_make_vect (len, init) {
  var b = [0]; for (var i = 1; i <= len; i++) b[i] = init; return b;
}
function caml_ml_flush () { return 0; }
function caml_ml_open_descriptor_out () { return 0; }
function caml_ml_out_channels_list () { return 0; }
function caml_ml_output () { return 0; }
function caml_raise_constant (tag) { throw [0, tag]; }
function caml_raise_zero_divide () {
  caml_raise_constant(caml_global_data[6]);
}
function caml_mod(x,y) {
  if (y == 0) caml_raise_zero_divide ();
  return x%y;
}
function caml_mul(x,y) {
  return ((((x >> 16) * y) << 16) + (x & 0xffff) * y)|0;
}
function caml_notequal (x, y) { return +(caml_compare_val(x,y,false) != 0); }
function caml_obj_is_block (x) { return +(x instanceof Array); }
function caml_obj_set_tag (x, tag) { x[0] = tag; return 0; }
function caml_obj_tag (x) { return (x instanceof Array)?x[0]:1000; }
function caml_register_global (n, v) { caml_global_data[n + 1] = v; }
var caml_named_values = {};
function caml_register_named_value(nm,v) {
  caml_named_values[nm] = v; return 0;
}
function caml_string_equal(s1, s2) {
  var b1 = s1.fullBytes;
  var b2 = s2.fullBytes;
  if (b1 != null && b2 != null) return (b1 == b2)?1:0;
  return (s1.getFullBytes () == s2.getFullBytes ())?1:0;
}
function caml_string_notequal(s1, s2) { return 1-caml_string_equal(s1, s2); }
function caml_sys_get_config () {
  return [0, new MlWrappedString("Unix"), 32, 0];
}
function caml_update_dummy (x, y) {
  if( typeof y==="function" ) { x.fun = y; return 0; }
  if( y.fun ) { x.fun = y.fun; return 0; }
  var i = y.length; while (i--) x[i] = y[i]; return 0;
}
(function()
   {function _nX_(_Ki_,_Kj_,_Kk_,_Kl_,_Km_,_Kn_,_Ko_)
     {return _Ki_.length==6
              ?_Ki_(_Kj_,_Kk_,_Kl_,_Km_,_Kn_,_Ko_)
              :caml_call_gen(_Ki_,[_Kj_,_Kk_,_Kl_,_Km_,_Kn_,_Ko_]);}
    function _jR_(_Ke_,_Kf_,_Kg_,_Kh_)
     {return _Ke_.length==3
              ?_Ke_(_Kf_,_Kg_,_Kh_)
              :caml_call_gen(_Ke_,[_Kf_,_Kg_,_Kh_]);}
    function _g9_(_Kb_,_Kc_,_Kd_)
     {return _Kb_.length==2?_Kb_(_Kc_,_Kd_):caml_call_gen(_Kb_,[_Kc_,_Kd_]);}
    function _gN_(_J$_,_Ka_)
     {return _J$_.length==1?_J$_(_Ka_):caml_call_gen(_J$_,[_Ka_]);}
    var
     _a_=[0,new MlString("Failure")],
     _b_=[0,new MlString("Invalid_argument")],
     _c_=[0,new MlString("Not_found")],
     _d_=[0,new MlString("Assert_failure")],
     _e_=new MlString("File \"%s\", line %d, characters %d-%d: %s"),
     _f_=new MlString("button"),
     a_g_=[254,0.25,0],
     one_h_=[254,1,0],
     zero_i_=[254,0,0];
    caml_register_global(6,_c_);
    caml_register_global(5,[0,new MlString("Division_by_zero")]);
    caml_register_global(3,_b_);
    caml_register_global(2,_a_);
    var
     _f7_=[0,new MlString("Out_of_memory")],
     _f6_=[0,new MlString("Match_failure")],
     _f5_=[0,new MlString("Stack_overflow")],
     _f4_=new MlString("%.12g"),
     _f3_=new MlString("."),
     _f2_=new MlString("%d"),
     _f1_=new MlString("true"),
     _f0_=new MlString("false"),
     _fZ_=new MlString("Pervasives.do_at_exit"),
     _fY_=new MlString("\\b"),
     _fX_=new MlString("\\t"),
     _fW_=new MlString("\\n"),
     _fV_=new MlString("\\r"),
     _fU_=new MlString("\\\\"),
     _fT_=new MlString("\\'"),
     _fS_=new MlString(""),
     _fR_=new MlString("String.blit"),
     _fQ_=new MlString("String.sub"),
     _fP_=new MlString("Queue.Empty"),
     _fO_=new MlString("CamlinternalLazy.Undefined"),
     _fN_=new MlString("Buffer.add: cannot grow buffer"),
     _fM_=new MlString("%"),
     _fL_=new MlString(""),
     _fK_=new MlString(""),
     _fJ_=new MlString("\""),
     _fI_=new MlString("\""),
     _fH_=new MlString("'"),
     _fG_=new MlString("'"),
     _fF_=new MlString("."),
     _fE_=new MlString("printf: bad positional specification (0)."),
     _fD_=new MlString("%_"),
     _fC_=[0,new MlString("printf.ml"),144,8],
     _fB_=new MlString("''"),
     _fA_=new MlString("Printf: premature end of format string ``"),
     _fz_=new MlString("''"),
     _fy_=new MlString(" in format string ``"),
     _fx_=new MlString(", at char number "),
     _fw_=new MlString("Printf: bad conversion %"),
     _fv_=new MlString("Sformat.index_of_int: negative argument "),
     _fu_=new MlString(""),
     _ft_=new MlString(", %s%s"),
     _fs_=[1,1],
     _fr_=new MlString("%s\n"),
     _fq_=
      new
       MlString
       ("(Program not linked with -g, cannot print stack backtrace)\n"),
     _fp_=new MlString("Raised at"),
     _fo_=new MlString("Re-raised at"),
     _fn_=new MlString("Raised by primitive operation at"),
     _fm_=new MlString("Called from"),
     _fl_=new MlString("%s file \"%s\", line %d, characters %d-%d"),
     _fk_=new MlString("%s unknown location"),
     _fj_=new MlString("Pattern matching failed"),
     _fi_=new MlString("Assertion failed"),
     _fh_=new MlString("(%s%s)"),
     _fg_=new MlString(""),
     _ff_=new MlString(""),
     _fe_=new MlString("(%s)"),
     _fd_=new MlString("%d"),
     _fc_=new MlString("%S"),
     _fb_=new MlString("_"),
     _fa_=[0,new MlString("src/core/lwt.ml"),814,20],
     _e$_=[0,new MlString("src/core/lwt.ml"),816,8],
     _e__=[0,new MlString("src/core/lwt.ml"),785,16],
     _e9_=[0,new MlString("src/core/lwt.ml"),670,20],
     _e8_=[0,new MlString("src/core/lwt.ml"),673,8],
     _e7_=[0,new MlString("src/core/lwt.ml"),648,20],
     _e6_=[0,new MlString("src/core/lwt.ml"),651,8],
     _e5_=[0,new MlString("src/core/lwt.ml"),498,8],
     _e4_=[0,new MlString("src/core/lwt.ml"),487,9],
     _e3_=new MlString("Lwt.wakeup_result"),
     _e2_=new MlString("Lwt.Canceled"),
     state_return_unit_e1_=[0,0],
     _e0_=new MlString("on"),
     _eZ_=new MlString("\""),
     _eY_=new MlString(" name=\""),
     _eX_=new MlString("\""),
     _eW_=new MlString(" type=\""),
     _eV_=new MlString("<"),
     _eU_=new MlString(">"),
     _eT_=new MlString(""),
     _eS_=new MlString("<input name=\"x\">"),
     _eR_=new MlString("input"),
     _eQ_=new MlString("x"),
     _eP_=new MlString("canvas"),
     _eO_=new MlString("dt"),
     _eN_=new MlString("dd"),
     _eM_=new MlString("img"),
     _eL_=new MlString("a"),
     _eK_=new MlString("div"),
     _eJ_=new MlString("li"),
     _eI_=new MlString("dl"),
     _eH_=new MlString("ul"),
     _eG_=new MlString("click"),
     _eF_=new MlString("mouseup"),
     _eE_=new MlString("mousemove"),
     _eD_=new MlString("keydown"),
     _eC_=new MlString("touchstart"),
     _eB_=new MlString("touchmove"),
     _eA_=new MlString("touchend"),
     _ez_=new MlString("2d"),
     _ey_=new MlString("Dom_html.Canvas_not_available"),
     _ex_=new MlString("browser can't read file: unimplemented"),
     _ew_=new MlString("utf8"),
     _ev_=[0,new MlString("file.ml"),132,15],
     _eu_=new MlString("string"),
     _et_=new MlString("can't retrieve file name: not implemented"),
     _es_=new MlString("\\$&"),
     _er_=new MlString("$$$$"),
     _eq_=new MlString("g"),
     _ep_=new MlString("g"),
     _eo_=new MlString("[$]"),
     _en_=new MlString("[\\][()\\\\|+*.?{}^$]"),
     _em_=[0,new MlString(""),0],
     _el_=new MlString(""),
     _ek_=new MlString(""),
     _ej_=new MlString("#"),
     _ei_=new MlString(""),
     _eh_=new MlString("?"),
     _eg_=new MlString(""),
     _ef_=new MlString("/"),
     _ee_=new MlString("/"),
     _ed_=new MlString(":"),
     _ec_=new MlString(""),
     _eb_=new MlString("http://"),
     _ea_=new MlString(""),
     _d$_=new MlString("#"),
     _d__=new MlString(""),
     _d9_=new MlString("?"),
     _d8_=new MlString(""),
     _d7_=new MlString("/"),
     _d6_=new MlString("/"),
     _d5_=new MlString(":"),
     _d4_=new MlString(""),
     _d3_=new MlString("https://"),
     _d2_=new MlString(""),
     _d1_=new MlString("#"),
     _d0_=new MlString(""),
     _dZ_=new MlString("?"),
     _dY_=new MlString(""),
     _dX_=new MlString("/"),
     _dW_=new MlString("file://"),
     _dV_=new MlString(""),
     _dU_=new MlString(""),
     _dT_=new MlString(""),
     _dS_=new MlString(""),
     _dR_=new MlString(""),
     _dQ_=new MlString(""),
     _dP_=new MlString("="),
     _dO_=new MlString("&"),
     _dN_=new MlString("file"),
     _dM_=new MlString("file:"),
     _dL_=new MlString("http"),
     _dK_=new MlString("http:"),
     _dJ_=new MlString("https"),
     _dI_=new MlString("https:"),
     _dH_=new MlString(" "),
     _dG_=new MlString("%2B"),
     _dF_=new MlString("Url.Local_exn"),
     _dE_=new MlString("+"),
     _dD_=new MlString("g"),
     _dC_=new MlString("\\+"),
     _dB_=new MlString("Url.Not_an_http_protocol"),
     _dA_=
      new
       MlString
       ("^([Hh][Tt][Tt][Pp][Ss]?)://([0-9a-zA-Z.-]+|\\[[0-9a-zA-Z.-]+\\]|\\[[0-9A-Fa-f:.]+\\])?(:([0-9]+))?/([^\\?#]*)(\\?([^#]*))?(#(.*))?$"),
     _dz_=
      new MlString("^([Ff][Ii][Ll][Ee])://([^\\?#]*)(\\?([^#])*)?(#(.*))?$"),
     _dy_=new MlString(""),
     _dx_=new MlString("POST"),
     _dw_=new MlString("multipart/form-data; boundary="),
     _dv_=new MlString("POST"),
     _du_=
      [0,
       new MlString("POST"),
       [0,new MlString("application/x-www-form-urlencoded")],
       126925477],
     _dt_=[0,new MlString("POST"),0,126925477],
     _ds_=new MlString("GET"),
     _dr_=new MlString("?"),
     _dq_=new MlString("Content-type"),
     _dp_=new MlString("="),
     _do_=new MlString("="),
     _dn_=new MlString("&"),
     _dm_=new MlString("Content-Type: application/octet-stream\r\n"),
     _dl_=new MlString("\"\r\n"),
     _dk_=new MlString("\"; filename=\""),
     _dj_=new MlString("Content-Disposition: form-data; name=\""),
     _di_=new MlString("\r\n"),
     _dh_=new MlString("\r\n"),
     _dg_=new MlString("\r\n"),
     _df_=new MlString("--"),
     _de_=new MlString("\r\n"),
     _dd_=new MlString("\"\r\n\r\n"),
     _dc_=new MlString("Content-Disposition: form-data; name=\""),
     _db_=new MlString("--\r\n"),
     _da_=new MlString("--"),
     _c$_=new MlString("js_of_ocaml-------------------"),
     _c__=new MlString("Msxml2.XMLHTTP"),
     _c9_=new MlString("Msxml3.XMLHTTP"),
     _c8_=new MlString("Microsoft.XMLHTTP"),
     _c7_=[0,new MlString("xmlHttpRequest.ml"),79,2],
     _c6_=new MlString("XmlHttpRequest.Wrong_headers"),
     _c5_=new MlString("#"),
     _c4_=new MlString("absolute"),
     _c3_=new MlString("0"),
     _c2_=new MlString("0"),
     _c1_=new MlString("info-38.png"),
     _c0_=new MlString("absolute"),
     _cZ_=new MlString("2px"),
     _cY_=new MlString("0"),
     _cX_=new MlString("pointer"),
     _cW_=new MlString("Information"),
     _cV_=new MlString("36px"),
     _cU_=new MlString("36px"),
     _cT_=new MlString("globe-38.png"),
     _cS_=new MlString("absolute"),
     _cR_=new MlString("2px"),
     _cQ_=new MlString("48px"),
     _cP_=new MlString("pointer"),
     languages_cO_=
      [0,
       [0,new MlString("Fran\xc3\xa7ais"),new MlString("fr")],
       [0,[0,new MlString("English"),new MlString("en")],0]],
     _cN_=new MlString("Languages"),
     _cM_=new MlString("text on"),
     _cL_=new MlString("absolute"),
     _cK_=new MlString("0px"),
     _cJ_=new MlString("46px"),
     _cI_=new MlString("nowrap"),
     _cH_=new MlString("meeting-point-38.png"),
     _cG_=new MlString("absolute"),
     _cF_=new MlString("2px"),
     _cE_=new MlString("96px"),
     _cD_=new MlString("pointer"),
     _cC_=new MlString("Recenter"),
     _cB_=new MlString("36px"),
     _cA_=new MlString("36px"),
     z0_cz_=[254,0,0],
     z1_cy_=[254,0.1,0],
     z0_cx_=[254,0,0],
     z1_cw_=[254,0,0.1],
     z0_cv_=[254,0,0],
     z1_cu_=[254,-0.1,0],
     z0_ct_=[254,0,0],
     z1_cs_=[254,0,-0.1],
     _cr_=new MlString("transform"),
     _cq_=new MlString("pointer"),
     _cp_=new MlString(""),
     _co_=new MlString("transform"),
     _cn_=new MlString("transform"),
     _cm_=new MlString("hidden"),
     _cl_=new MlString("100%"),
     _ck_=new MlString("hidden"),
     _cj_=new MlString("0px"),
     _ci_=new MlString("100%"),
     _ch_=new MlString("ocsigen-powered.png"),
     _cg_=new MlString("_blank"),
     _cf_=new MlString("http://ocsigen.org/"),
     _ce_=new MlString("absolute"),
     _cd_=new MlString("0"),
     _cc_=new MlString("0"),
     _cb_=new MlString("text"),
     _ca_=new MlString("80%"),
     _b$_=new MlString("auto"),
     _b__=
      new
       MlString
       ("Unfortunately, this browser is not supported. Please try again with another browser, such as <a href=\"http://www.mozilla.org/firefox/\">Firefox</a>, <a href=\"http://www.google.com/chrome/\">Chrome</a> or <a href=\"http://www.opera.com/\">Opera</a>."),
     _b9_=new MlString("table-cell"),
     _b8_=new MlString("middle"),
     _b7_=new MlString("100%"),
     _b6_=new MlString("100%"),
     _b5_=new MlString("table"),
     _b4_=new MlString("overlay"),
     _b3_=new MlString("en"),
     _b2_=new MlString("text"),
     _b1_=new MlString("80%"),
     _b0_=new MlString("auto"),
     _bZ_=new MlString("table-cell"),
     _bY_=new MlString("middle"),
     _bX_=new MlString("100%"),
     _bW_=new MlString("100%"),
     _bV_=new MlString("table"),
     _bU_=new MlString("overlay translucent"),
     _bT_=new MlString("OK"),
     _bS_=new MlString("center"),
     _bR_=new MlString("2em auto"),
     _bQ_=new MlString("_blank"),
     _bP_=new MlString(".wikipedia.org/wiki/"),
     _bO_=new MlString("http://"),
     _bN_=new MlString("absolute"),
     _bM_=new MlString("0"),
     _bL_=new MlString("0"),
     _bK_=new MlString("0"),
     _bJ_=new MlString("0"),
     _bI_=new MlString("auto"),
     _bH_=new MlString("px"),
     _bG_=new MlString("10px"),
     _bF_=new MlString("absolute"),
     _bE_=new MlString("0"),
     _bD_=new MlString("0"),
     _bC_=new MlString("0"),
     _bB_=new MlString("0"),
     _bA_=new MlString("absolute"),
     _bz_=new MlString("0"),
     _by_=new MlString("4em"),
     _bx_=new MlString("38px"),
     _bw_=new MlString("38px"),
     _bv_=new MlString("block"),
     _bu_=new MlString("auto"),
     _bt_=new MlString("auto"),
     _bs_=new MlString("100%"),
     _br_=new MlString("100%"),
     _bq_=new MlString("auto"),
     _bp_=new MlString("auto"),
     _bo_=new MlString(".jpg"),
     _bn_=new MlString("images/"),
     _bm_=new MlString("block"),
     _bl_=new MlString("auto"),
     _bk_=new MlString("auto"),
     _bj_=new MlString("100%"),
     _bi_=new MlString("100%"),
     _bh_=new MlString("auto"),
     _bg_=new MlString("auto"),
     _bf_=new MlString("text"),
     _be_=new MlString("absolute"),
     _bd_=new MlString("0"),
     _bc_=new MlString("auto"),
     _bb_=new MlString("auto"),
     _ba_=new MlString("overlay"),
     _a$_=new MlString("100%"),
     _a__=new MlString("100%"),
     _a9_=new MlString("absolute"),
     _a8_=new MlString("0"),
     _a7_=new MlString("0"),
     _a6_=new MlString("1"),
     _a5_=new MlString("button"),
     _a4_=new MlString("absolute"),
     _a3_=new MlString("0"),
     _a2_=new MlString("0"),
     _a1_=new MlString("pointer"),
     _a0_=new MlString("Click anywhere to return to the tree"),
     _aZ_=new MlString("32px"),
     _aY_=new MlString("20px"),
     _aX_=new MlString("absolute"),
     _aW_=new MlString("0"),
     _aV_=new MlString("0"),
     _aU_=new MlString("en"),
     _aT_=new MlString(""),
     _aS_=new MlString("?uselang="),
     _aR_=new MlString("http://commons.wikimedia.org/wiki/File:"),
     _aQ_=new MlString("commons-38.png"),
     _aP_=new MlString("See image description on Wikimedia Commons"),
     _aO_=new MlString("48px"),
     _aN_=new MlString("12px"),
     _aM_=new MlString("wikipedia-38.png"),
     _aL_=new MlString("In English"),
     _aK_=new MlString("en"),
     _aJ_=new MlString("en"),
     _aI_=new MlString("In English"),
     _aH_=new MlString("No reference found."),
     _aG_=new MlString("text on"),
     _aF_=new MlString("absolute"),
     _aE_=new MlString("48px"),
     _aD_=new MlString("62px"),
     _aC_=new MlString("nowrap"),
     _aB_=new MlString("text on"),
     _aA_=new MlString("text"),
     _az_=new MlString("absolute"),
     _ay_=new MlString("tooltip on"),
     _ax_=new MlString("absolute"),
     _aw_=new MlString("38px"),
     _av_=new MlString("px"),
     _au_=new MlString("2px"),
     _at_=new MlString("2px"),
     _as_=new MlString("px 3px"),
     _ar_=new MlString("px 3px "),
     _aq_=new MlString("on"),
     _ap_=new MlString("off"),
     _ao_=new MlString("filled_button "),
     _an_=new MlString("button"),
     _am_=new MlString("48px"),
     _al_=new MlString("px"),
     _ak_=new MlString("_blank"),
     _aj_=new MlString("#888888"),
     _ai_=new MlString("on"),
     _ah_=new MlString("off"),
     _ag_=new MlString("absolute"),
     _af_=new MlString("0"),
     _ae_=new MlString("0"),
     _ad_=new MlString("image_info.json"),
     _ac_=[0,0,0,0],
     _ab_=[254,-1,0],
     _aa_=[0,new MlString("hypertree.ml"),930,2],
     _$_=new MlString("en"),
     ___=new MlString("<TITLE>"),
     _Z_=new MlString(""),
     _Y_=new MlString("20px sans-serif"),
     _X_=new MlString("black"),
     _W_=new MlString("center"),
     _V_=new MlString("middle"),
     _U_=new MlString(".jpg"),
     _T_=new MlString("thumbnails/"),
     _S_=new MlString("draw"),
     _R_=new MlString("round"),
     _Q_=new MlString("black"),
     _P_=new MlString("draw"),
     _O_=new MlString("messages.json"),
     _N_=new MlString("hyp_lang"),
     _M_=new MlString("hyp_lang"),
     _L_=new MlString("en"),
     _K_=new MlString("hidden"),
     _J_=new MlString("absolute"),
     _I_=new MlString("nowrap"),
     _H_=new MlString(""),
     _G_=new MlString(""),
     _F_=new MlString("move"),
     _E_=new MlString(""),
     _D_=new MlString("move"),
     _C_=new MlString("icons/"),
     icons_B_=
      [0,
       new MlString("commons-38.png"),
       [0,
        new MlString("wikipedia-38.png"),
        [0,
         new MlString("info-38.png"),
         [0,
          new MlString("meeting-point-38.png"),
          [0,
           new MlString("globe-38.png"),
           [0,new MlString("ocsigen-powered.png"),0]]]]]],
     _A_=new MlString("#794c0d"),
     _z_=new MlString("absolute"),
     _y_=new MlString("0"),
     _x_=new MlString("0"),
     _w_=new MlString("0.9em"),
     tree_url_v_=new MlString("tree.json"),
     _u_=new MlString("\n"),
     _t_=new MlString("[^ ]"),
     _s_=new MlString("[|]"),
     _r_=
      new
       MlString
       ("<h1>A tree of animals</h1> This <a target=\"_blank\" href=\"http://en.wikipedia.org/wiki/Phylogenetic_tree\"><em>phylogenetic</em> tree</a> displays the relationships among animals.<h2>Usage</h2>Browse the tree by dragging it with the mouse. Click on any image to display a larger version.<h2>Credits</h2>This software and the images it uses are under free licenses. Images are from <a target=\"_blank\" href=\"http://commons.wikimedia.org/wiki/Main_Page\">Wikimedia Commons</a>.  You can click on each image for details.  The software has been written by J\xc3\xa9r\xc3\xb4me Vouillon (CNRS).");
    function _q_(s_j_){throw [0,_a_,s_j_];}
    function _f8_(s_k_){throw [0,_b_,s_k_];}
    function _f9_(x_m_,y_l_){return caml_lessequal(x_m_,y_l_)?x_m_:y_l_;}
    function _f__(x_o_,y_n_){return caml_greaterequal(x_o_,y_n_)?x_o_:y_n_;}
    function _f$_(x_p_){return 0<=x_p_?x_p_:-x_p_|0;}
    function _gk_(s1_ga_,s2_gc_)
     {var
       l1_gb_=s1_ga_.getLen(),
       l2_gd_=s2_gc_.getLen(),
       s_ge_=caml_create_string(l1_gb_+l2_gd_|0);
      caml_blit_string(s1_ga_,0,s_ge_,0,l1_gb_);
      caml_blit_string(s2_gc_,0,s_ge_,l1_gb_,l2_gd_);
      return s_ge_;}
    function string_of_int_gt_(n_gf_){return caml_format_int(_f2_,n_gf_);}
    function string_of_float_gu_(f_gg_)
     {var _gh_=caml_format_float(_f4_,f_gg_),i_gi_=0,l_gj_=_gh_.getLen();
      for(;;)
       {if(l_gj_<=i_gi_)
         var _gl_=_gk_(_gh_,_f3_);
        else
         {var
           _gm_=_gh_.safeGet(i_gi_),
           _gn_=48<=_gm_?58<=_gm_?0:1:45===_gm_?1:0;
          if(_gn_){var _go_=i_gi_+1|0,i_gi_=_go_;continue;}
          var _gl_=_gh_;}
        return _gl_;}}
    function _gq_(l1_gp_,l2_gr_)
     {if(l1_gp_)
       {var hd_gs_=l1_gp_[1];return [0,hd_gs_,_gq_(l1_gp_[2],l2_gr_)];}
      return l2_gr_;}
    var stderr_gv_=caml_ml_open_descriptor_out(2);
    function output_string_gD_(oc_gx_,s_gw_)
     {return caml_ml_output(oc_gx_,s_gw_,0,s_gw_.getLen());}
    function do_at_exit_gC_(param_gB_)
     {var param_gy_=caml_ml_out_channels_list(0);
      for(;;)
       {if(param_gy_)
         {var l_gz_=param_gy_[2];
          try {}catch(_gA_){}
          var param_gy_=l_gz_;
          continue;}
        return 0;}}
    caml_register_named_value(_fZ_,do_at_exit_gC_);
    function _gH_(_gF_,_gE_){return caml_ml_output_char(_gF_,_gE_);}
    function _ha_(_gG_){return caml_ml_flush(_gG_);}
    function _g$_(f_gM_,a_gJ_)
     {var _gI_=0,_gK_=a_gJ_.length-1-1|0;
      if(!(_gK_<_gI_))
       {var i_gL_=_gI_;
        for(;;)
         {_gN_(f_gM_,a_gJ_[i_gL_+1]);
          var _gO_=i_gL_+1|0;
          if(_gK_!==i_gL_){var i_gL_=_gO_;continue;}
          break;}}
      return 0;}
    function _hb_(f_gR_,a_gP_)
     {var l_gQ_=a_gP_.length-1;
      if(0===l_gQ_)return [0];
      var
       r_gS_=caml_make_vect(l_gQ_,_gN_(f_gR_,a_gP_[0+1])),
       _gT_=1,
       _gU_=l_gQ_-1|0;
      if(!(_gU_<_gT_))
       {var i_gV_=_gT_;
        for(;;)
         {r_gS_[i_gV_+1]=_gN_(f_gR_,a_gP_[i_gV_+1]);
          var _gW_=i_gV_+1|0;
          if(_gU_!==i_gV_){var i_gV_=_gW_;continue;}
          break;}}
      return r_gS_;}
    function _hd_(a_gX_)
     {var i_gY_=a_gX_.length-1-1|0,res_gZ_=0;
      for(;;)
       {if(0<=i_gY_)
         {var
           _g1_=[0,a_gX_[i_gY_+1],res_gZ_],
           _g0_=i_gY_-1|0,
           i_gY_=_g0_,
           res_gZ_=_g1_;
          continue;}
        return res_gZ_;}}
    function _hc_(f_g8_,x_g2_,a_g5_)
     {var r_g3_=[0,x_g2_],_g4_=0,_g6_=a_g5_.length-1-1|0;
      if(!(_g6_<_g4_))
       {var i_g7_=_g4_;
        for(;;)
         {r_g3_[1]=_g9_(f_g8_,r_g3_[1],a_g5_[i_g7_+1]);
          var _g__=i_g7_+1|0;
          if(_g6_!==i_g7_){var i_g7_=_g__;continue;}
          break;}}
      return r_g3_[1];}
    function _hy_(l_he_)
     {var l1_hf_=l_he_,l2_hg_=0;
      for(;;)
       {if(l1_hf_)
         {var
           l_hh_=l1_hf_[2],
           _hi_=[0,l1_hf_[1],l2_hg_],
           l1_hf_=l_hh_,
           l2_hg_=_hi_;
          continue;}
        return l2_hg_;}}
    function _hm_(f_hk_,param_hj_)
     {if(param_hj_)
       {var l_hl_=param_hj_[2],r_hn_=_gN_(f_hk_,param_hj_[1]);
        return [0,r_hn_,_hm_(f_hk_,l_hl_)];}
      return 0;}
    function _hz_(f_hq_,param_ho_)
     {var param_hp_=param_ho_;
      for(;;)
       {if(param_hp_)
         {var l_hr_=param_hp_[2];
          _gN_(f_hq_,param_hp_[1]);
          var param_hp_=l_hr_;
          continue;}
        return 0;}}
    function _hA_(x_hv_,param_hs_)
     {var param_ht_=param_hs_;
      for(;;)
       {if(param_ht_)
         {var match_hu_=param_ht_[1],l_hx_=param_ht_[2],b_hw_=match_hu_[2];
          if(match_hu_[1]===x_hv_)return b_hw_;
          var param_ht_=l_hx_;
          continue;}
        throw [0,_c_];}}
    function _hX_(n_hB_,c_hD_)
     {var s_hC_=caml_create_string(n_hB_);
      caml_fill_string(s_hC_,0,n_hB_,c_hD_);
      return s_hC_;}
    function _hY_(s_hG_,ofs_hE_,len_hF_)
     {if(0<=ofs_hE_&&0<=len_hF_&&!((s_hG_.getLen()-len_hF_|0)<ofs_hE_))
       {var r_hH_=caml_create_string(len_hF_);
        caml_blit_string(s_hG_,ofs_hE_,r_hH_,0,len_hF_);
        return r_hH_;}
      return _f8_(_fQ_);}
    function _hZ_(s1_hK_,ofs1_hJ_,s2_hM_,ofs2_hL_,len_hI_)
     {if
       (0<=
        len_hI_&&
        0<=
        ofs1_hJ_&&
        !((s1_hK_.getLen()-len_hI_|0)<ofs1_hJ_)&&
        0<=
        ofs2_hL_&&
        !((s2_hM_.getLen()-len_hI_|0)<ofs2_hL_))
       return caml_blit_string(s1_hK_,ofs1_hJ_,s2_hM_,ofs2_hL_,len_hI_);
      return _f8_(_fR_);}
    function _h0_(sep_hT_,l_hN_)
     {if(l_hN_)
       {var hd_hO_=l_hN_[1],num_hP_=[0,0],len_hQ_=[0,0],tl_hS_=l_hN_[2];
        _hz_
         (function(s_hR_)
           {num_hP_[1]+=1;len_hQ_[1]=len_hQ_[1]+s_hR_.getLen()|0;return 0;},
          l_hN_);
        var
         r_hU_=
          caml_create_string
           (len_hQ_[1]+caml_mul(sep_hT_.getLen(),num_hP_[1]-1|0)|0);
        caml_blit_string(hd_hO_,0,r_hU_,0,hd_hO_.getLen());
        var pos_hV_=[0,hd_hO_.getLen()];
        _hz_
         (function(s_hW_)
           {caml_blit_string(sep_hT_,0,r_hU_,pos_hV_[1],sep_hT_.getLen());
            pos_hV_[1]=pos_hV_[1]+sep_hT_.getLen()|0;
            caml_blit_string(s_hW_,0,r_hU_,pos_hV_[1],s_hW_.getLen());
            pos_hV_[1]=pos_hV_[1]+s_hW_.getLen()|0;
            return 0;},
          tl_hS_);
        return r_hU_;}
      return _fS_;}
    var
     _h1_=caml_sys_get_config(0)[2],
     _h2_=(1<<(_h1_-10|0))-1|0,
     _h3_=caml_mul(_h1_/8|0,_h2_)-1|0;
    function _h7_(x_h4_){return caml_hash_univ_param(10,100,x_h4_);}
    function _ij_(initial_size_h5_)
     {return [0,0,caml_make_vect(_f9_(_f__(1,initial_size_h5_),_h2_),0)];}
    function _ik_(h_h6_,key_h8_)
     {var
       _h9_=h_h6_[2].length-1,
       _h__=caml_mod(_h7_(key_h8_),_h9_),
       _h$_=caml_array_get(h_h6_[2],_h__);
      if(_h$_)
       {var rest1_ia_=_h$_[3],d1_ib_=_h$_[2];
        if(0===caml_compare(key_h8_,_h$_[1]))return d1_ib_;
        if(rest1_ia_)
         {var rest2_ic_=rest1_ia_[3],d2_id_=rest1_ia_[2];
          if(0===caml_compare(key_h8_,rest1_ia_[1]))return d2_id_;
          if(rest2_ic_)
           {var rest3_if_=rest2_ic_[3],d3_ie_=rest2_ic_[2];
            if(0===caml_compare(key_h8_,rest2_ic_[1]))return d3_ie_;
            var param_ig_=rest3_if_;
            for(;;)
             {if(param_ig_)
               {var rest_ii_=param_ig_[3],d_ih_=param_ig_[2];
                if(0===caml_compare(key_h8_,param_ig_[1]))return d_ih_;
                var param_ig_=rest_ii_;
                continue;}
              throw [0,_c_];}}
          throw [0,_c_];}
        throw [0,_c_];}
      throw [0,_c_];}
    var _ix_=246,_ir_=250,_iw_=252,_iv_=253,_iu_=[0,_fP_],_il_=[0,_fO_];
    function _io_(param_im_){throw [0,_il_];}
    function _iy_(blk_in_)
     {var closure_ip_=blk_in_[0+1];
      blk_in_[0+1]=_io_;
      try
       {var result_iq_=_gN_(closure_ip_,0);
        blk_in_[0+1]=result_iq_;
        caml_obj_set_tag(blk_in_,_ir_);}
      catch(_is_){blk_in_[0+1]=function(param_it_){throw _is_;};throw _is_;}
      return result_iq_;}
    function _iQ_(n_iz_)
     {var
       n_iA_=1<=n_iz_?n_iz_:1,
       n_iB_=_h3_<n_iA_?_h3_:n_iA_,
       s_iC_=caml_create_string(n_iB_);
      return [0,s_iC_,0,n_iB_,s_iC_];}
    function _iR_(b_iD_){return _hY_(b_iD_[1],0,b_iD_[2]);}
    function _iK_(b_iE_,more_iG_)
     {var new_len_iF_=[0,b_iE_[3]];
      for(;;)
       {if(new_len_iF_[1]<(b_iE_[2]+more_iG_|0))
         {new_len_iF_[1]=2*new_len_iF_[1]|0;continue;}
        if(_h3_<new_len_iF_[1])
         if((b_iE_[2]+more_iG_|0)<=_h3_)new_len_iF_[1]=_h3_;else _q_(_fN_);
        var new_buffer_iH_=caml_create_string(new_len_iF_[1]);
        _hZ_(b_iE_[1],0,new_buffer_iH_,0,b_iE_[2]);
        b_iE_[1]=new_buffer_iH_;
        b_iE_[3]=new_len_iF_[1];
        return 0;}}
    function _iS_(b_iI_,c_iL_)
     {var pos_iJ_=b_iI_[2];
      if(b_iI_[3]<=pos_iJ_)_iK_(b_iI_,1);
      b_iI_[1].safeSet(pos_iJ_,c_iL_);
      b_iI_[2]=pos_iJ_+1|0;
      return 0;}
    function _iT_(b_iO_,s_iM_)
     {var len_iN_=s_iM_.getLen(),new_position_iP_=b_iO_[2]+len_iN_|0;
      if(b_iO_[3]<new_position_iP_)_iK_(b_iO_,len_iN_);
      _hZ_(s_iM_,0,b_iO_[1],b_iO_[2],len_iN_);
      b_iO_[2]=new_position_iP_;
      return 0;}
    function index_of_int_iX_(i_iU_)
     {return 0<=i_iU_?i_iU_:_q_(_gk_(_fv_,string_of_int_gt_(i_iU_)));}
    function add_int_index_iY_(i_iV_,idx_iW_)
     {return index_of_int_iX_(i_iV_+idx_iW_|0);}
    var _iZ_=_gN_(add_int_index_iY_,1);
    function _i6_(fmt_i0_){return _hY_(fmt_i0_,0,fmt_i0_.getLen());}
    function bad_conversion_i8_(sfmt_i1_,i_i2_,c_i4_)
     {var
       _i3_=_gk_(_fy_,_gk_(sfmt_i1_,_fz_)),
       _i5_=_gk_(_fx_,_gk_(string_of_int_gt_(i_i2_),_i3_));
      return _f8_(_gk_(_fw_,_gk_(_hX_(1,c_i4_),_i5_)));}
    function bad_conversion_format_jX_(fmt_i7_,i_i__,c_i9_)
     {return bad_conversion_i8_(_i6_(fmt_i7_),i_i__,c_i9_);}
    function incomplete_format_jY_(fmt_i$_)
     {return _f8_(_gk_(_fA_,_gk_(_i6_(fmt_i$_),_fB_)));}
    function extract_format_jt_(fmt_ja_,start_ji_,stop_jk_,widths_jm_)
     {function skip_positional_spec_jh_(start_jb_)
       {if
         ((fmt_ja_.safeGet(start_jb_)-48|0)<
          0||
          9<
          (fmt_ja_.safeGet(start_jb_)-48|0))
         return start_jb_;
        var i_jc_=start_jb_+1|0;
        for(;;)
         {var _jd_=fmt_ja_.safeGet(i_jc_);
          if(48<=_jd_)
           {if(!(58<=_jd_)){var _jf_=i_jc_+1|0,i_jc_=_jf_;continue;}
            var _je_=0;}
          else
           if(36===_jd_){var _jg_=i_jc_+1|0,_je_=1;}else var _je_=0;
          if(!_je_)var _jg_=start_jb_;
          return _jg_;}}
      var
       start_jj_=skip_positional_spec_jh_(start_ji_+1|0),
       b_jl_=_iQ_((stop_jk_-start_jj_|0)+10|0);
      _iS_(b_jl_,37);
      var i_jn_=start_jj_,widths_jo_=_hy_(widths_jm_);
      for(;;)
       {if(i_jn_<=stop_jk_)
         {var _jp_=fmt_ja_.safeGet(i_jn_);
          if(42===_jp_)
           {if(widths_jo_)
             {var t_jq_=widths_jo_[2];
              _iT_(b_jl_,string_of_int_gt_(widths_jo_[1]));
              var
               i_jr_=skip_positional_spec_jh_(i_jn_+1|0),
               i_jn_=i_jr_,
               widths_jo_=t_jq_;
              continue;}
            throw [0,_d_,_fC_];}
          _iS_(b_jl_,_jp_);
          var _js_=i_jn_+1|0,i_jn_=_js_;
          continue;}
        return _iR_(b_jl_);}}
    function extract_format_int_ll_
     (conv_jz_,fmt_jx_,start_jw_,stop_jv_,widths_ju_)
     {var sfmt_jy_=extract_format_jt_(fmt_jx_,start_jw_,stop_jv_,widths_ju_);
      if(78!==conv_jz_&&110!==conv_jz_)return sfmt_jy_;
      sfmt_jy_.safeSet(sfmt_jy_.getLen()-1|0,117);
      return sfmt_jy_;}
    function sub_format_jZ_
     (incomplete_format_jG_,bad_conversion_format_jQ_,conv_jV_,fmt_jA_,i_jU_)
     {var len_jB_=fmt_jA_.getLen();
      function sub_fmt_jS_(c_jC_,i_jP_)
       {var close_jD_=40===c_jC_?41:125;
        function sub_jO_(j_jE_)
         {var j_jF_=j_jE_;
          for(;;)
           {if(len_jB_<=j_jF_)return _gN_(incomplete_format_jG_,fmt_jA_);
            if(37===fmt_jA_.safeGet(j_jF_))
             {var _jH_=j_jF_+1|0;
              if(len_jB_<=_jH_)
               var _jI_=_gN_(incomplete_format_jG_,fmt_jA_);
              else
               {var _jJ_=fmt_jA_.safeGet(_jH_),_jK_=_jJ_-40|0;
                if(_jK_<0||1<_jK_)
                 {var _jL_=_jK_-83|0;
                  if(_jL_<0||2<_jL_)
                   var _jM_=1;
                  else
                   switch(_jL_)
                    {case 1:var _jM_=1;break;
                     case 2:var _jN_=1,_jM_=0;break;
                     default:var _jN_=0,_jM_=0;}
                  if(_jM_){var _jI_=sub_jO_(_jH_+1|0),_jN_=2;}}
                else
                 var _jN_=0===_jK_?0:1;
                switch(_jN_)
                 {case 1:
                   var
                    _jI_=
                     _jJ_===close_jD_
                      ?_jH_+1|0
                      :_jR_(bad_conversion_format_jQ_,fmt_jA_,i_jP_,_jJ_);
                   break;
                  case 2:break;
                  default:var _jI_=sub_jO_(sub_fmt_jS_(_jJ_,_jH_+1|0)+1|0);}}
              return _jI_;}
            var _jT_=j_jF_+1|0,j_jF_=_jT_;
            continue;}}
        return sub_jO_(i_jP_);}
      return sub_fmt_jS_(conv_jV_,i_jU_);}
    function sub_format_for_printf_km_(conv_jW_)
     {return _jR_
              (sub_format_jZ_,
               incomplete_format_jY_,
               bad_conversion_format_jX_,
               conv_jW_);}
    function iter_on_format_args_kC_(fmt_j0_,add_conv_j$_,add_char_kj_)
     {var lim_j1_=fmt_j0_.getLen()-1|0;
      function scan_fmt_kk_(i_j2_)
       {var i_j3_=i_j2_;
        a:
        for(;;)
         {if(i_j3_<lim_j1_)
           {if(37===fmt_j0_.safeGet(i_j3_))
             {var skip_j4_=0,i_j5_=i_j3_+1|0;
              for(;;)
               {if(lim_j1_<i_j5_)
                 var _j6_=incomplete_format_jY_(fmt_j0_);
                else
                 {var _j7_=fmt_j0_.safeGet(i_j5_);
                  if(58<=_j7_)
                   {if(95===_j7_)
                     {var _j9_=i_j5_+1|0,_j8_=1,skip_j4_=_j8_,i_j5_=_j9_;
                      continue;}}
                  else
                   if(32<=_j7_)
                    switch(_j7_-32|0)
                     {case 1:
                      case 2:
                      case 4:
                      case 5:
                      case 6:
                      case 7:
                      case 8:
                      case 9:
                      case 12:
                      case 15:break;
                      case 0:
                      case 3:
                      case 11:
                      case 13:var _j__=i_j5_+1|0,i_j5_=_j__;continue;
                      case 10:
                       var _ka_=_jR_(add_conv_j$_,skip_j4_,i_j5_,105),i_j5_=_ka_;
                       continue;
                      default:var _kb_=i_j5_+1|0,i_j5_=_kb_;continue;}
                  var i_kc_=i_j5_;
                  c:
                  for(;;)
                   {if(lim_j1_<i_kc_)
                     var _kd_=incomplete_format_jY_(fmt_j0_);
                    else
                     {var _ke_=fmt_j0_.safeGet(i_kc_);
                      if(126<=_ke_)
                       var _kf_=0;
                      else
                       switch(_ke_)
                        {case 78:
                         case 88:
                         case 100:
                         case 105:
                         case 111:
                         case 117:
                         case 120:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,105),_kf_=1;break;
                         case 69:
                         case 70:
                         case 71:
                         case 101:
                         case 102:
                         case 103:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,102),_kf_=1;break;
                         case 33:
                         case 37:
                         case 44:var _kd_=i_kc_+1|0,_kf_=1;break;
                         case 83:
                         case 91:
                         case 115:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,115),_kf_=1;break;
                         case 97:
                         case 114:
                         case 116:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),_kf_=1;
                          break;
                         case 76:
                         case 108:
                         case 110:
                          var j_kg_=i_kc_+1|0;
                          if(lim_j1_<j_kg_)
                           {var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,105),_kf_=1;}
                          else
                           {var _kh_=fmt_j0_.safeGet(j_kg_)-88|0;
                            if(_kh_<0||32<_kh_)
                             var _ki_=1;
                            else
                             switch(_kh_)
                              {case 0:
                               case 12:
                               case 17:
                               case 23:
                               case 29:
                               case 32:
                                var
                                 _kd_=
                                  _g9_
                                   (add_char_kj_,_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),105),
                                 _kf_=1,
                                 _ki_=0;
                                break;
                               default:var _ki_=1;}
                            if(_ki_)
                             {var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,105),_kf_=1;}}
                          break;
                         case 67:
                         case 99:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,99),_kf_=1;break;
                         case 66:
                         case 98:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,66),_kf_=1;break;
                         case 41:
                         case 125:
                          var _kd_=_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),_kf_=1;
                          break;
                         case 40:
                          var
                           _kd_=scan_fmt_kk_(_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_)),
                           _kf_=1;
                          break;
                         case 123:
                          var
                           i_kl_=_jR_(add_conv_j$_,skip_j4_,i_kc_,_ke_),
                           j_kn_=_jR_(sub_format_for_printf_km_,_ke_,fmt_j0_,i_kl_),
                           i_ko_=i_kl_;
                          for(;;)
                           {if(i_ko_<(j_kn_-2|0))
                             {var
                               _kp_=_g9_(add_char_kj_,i_ko_,fmt_j0_.safeGet(i_ko_)),
                               i_ko_=_kp_;
                              continue;}
                            var _kq_=j_kn_-1|0,i_kc_=_kq_;
                            continue c;}
                         default:var _kf_=0;}
                      if(!_kf_)
                       var _kd_=bad_conversion_format_jX_(fmt_j0_,i_kc_,_ke_);}
                    var _j6_=_kd_;
                    break;}}
                var i_j3_=_j6_;
                continue a;}}
            var _kr_=i_j3_+1|0,i_j3_=_kr_;
            continue;}
          return i_j3_;}}
      scan_fmt_kk_(0);
      return 0;}
    function count_arguments_of_format_mA_(fmt_kD_)
     {var ac_ks_=[0,0,0,0];
      function add_conv_kB_(skip_kx_,i_ky_,c_kt_)
       {var _ku_=41!==c_kt_?1:0,_kv_=_ku_?125!==c_kt_?1:0:_ku_;
        if(_kv_)
         {var inc_kw_=97===c_kt_?2:1;
          if(114===c_kt_)ac_ks_[3]=ac_ks_[3]+1|0;
          if(skip_kx_)
           ac_ks_[2]=ac_ks_[2]+inc_kw_|0;
          else
           ac_ks_[1]=ac_ks_[1]+inc_kw_|0;}
        return i_ky_+1|0;}
      iter_on_format_args_kC_
       (fmt_kD_,add_conv_kB_,function(i_kz_,c_kA_){return i_kz_+1|0;});
      return ac_ks_[1];}
    function scan_positional_spec_lh_(fmt_kE_,got_spec_kH_,n_kP_,i_kF_)
     {var _kG_=fmt_kE_.safeGet(i_kF_);
      if((_kG_-48|0)<0||9<(_kG_-48|0))return _g9_(got_spec_kH_,0,i_kF_);
      var accu_kI_=_kG_-48|0,j_kJ_=i_kF_+1|0;
      for(;;)
       {var _kK_=fmt_kE_.safeGet(j_kJ_);
        if(48<=_kK_)
         {if(!(58<=_kK_))
           {var
             _kN_=j_kJ_+1|0,
             _kM_=(10*accu_kI_|0)+(_kK_-48|0)|0,
             accu_kI_=_kM_,
             j_kJ_=_kN_;
            continue;}
          var _kL_=0;}
        else
         if(36===_kK_)
          if(0===accu_kI_)
           {var _kO_=_q_(_fE_),_kL_=1;}
          else
           {var
             _kO_=
              _g9_(got_spec_kH_,[0,index_of_int_iX_(accu_kI_-1|0)],j_kJ_+1|0),
             _kL_=1;}
         else
          var _kL_=0;
        if(!_kL_)var _kO_=_g9_(got_spec_kH_,0,i_kF_);
        return _kO_;}}
    function next_index_lc_(spec_kQ_,n_kR_)
     {return spec_kQ_?n_kR_:_gN_(_iZ_,n_kR_);}
    function get_index_k3_(spec_kS_,n_kT_){return spec_kS_?spec_kS_[1]:n_kT_;}
    function _nW_
     (to_s_mU_,get_out_kV_,outc_m6_,outs_mV_,flush_mF_,k_na_,fmt_kU_)
     {var out_kW_=_gN_(get_out_kV_,fmt_kU_);
      function pr_mE_(k_k1_,n_m$_,fmt_kX_,v_k6_)
       {var len_k0_=fmt_kX_.getLen();
        function doprn_mB_(n_m3_,i_kY_)
         {var i_kZ_=i_kY_;
          for(;;)
           {if(len_k0_<=i_kZ_)return _gN_(k_k1_,out_kW_);
            var _k2_=fmt_kX_.safeGet(i_kZ_);
            if(37===_k2_)
             {var
               get_arg_k__=
                function(spec_k5_,n_k4_)
                 {return caml_array_get(v_k6_,get_index_k3_(spec_k5_,n_k4_));},
               scan_flags_le_=
                function(spec_lg_,n_k$_,widths_lb_,i_k7_)
                 {var i_k8_=i_k7_;
                  for(;;)
                   {var _k9_=fmt_kX_.safeGet(i_k8_)-32|0;
                    if(!(_k9_<0||25<_k9_))
                     switch(_k9_)
                      {case 1:
                       case 2:
                       case 4:
                       case 5:
                       case 6:
                       case 7:
                       case 8:
                       case 9:
                       case 12:
                       case 15:break;
                       case 10:
                        return scan_positional_spec_lh_
                                (fmt_kX_,
                                 function(wspec_la_,i_lf_)
                                  {var _ld_=[0,get_arg_k__(wspec_la_,n_k$_),widths_lb_];
                                   return scan_flags_le_
                                           (spec_lg_,next_index_lc_(wspec_la_,n_k$_),_ld_,i_lf_);},
                                 n_k$_,
                                 i_k8_+1|0);
                       default:var _li_=i_k8_+1|0,i_k8_=_li_;continue;}
                    var _lj_=fmt_kX_.safeGet(i_k8_);
                    if(124<=_lj_)
                     var _lk_=0;
                    else
                     switch(_lj_)
                      {case 78:
                       case 88:
                       case 100:
                       case 105:
                       case 111:
                       case 117:
                       case 120:
                        var
                         x_lm_=get_arg_k__(spec_lg_,n_k$_),
                         s_ln_=
                          caml_format_int
                           (extract_format_int_ll_(_lj_,fmt_kX_,i_kZ_,i_k8_,widths_lb_),
                            x_lm_),
                         _lp_=
                          cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),s_ln_,i_k8_+1|0),
                         _lk_=1;
                        break;
                       case 69:
                       case 71:
                       case 101:
                       case 102:
                       case 103:
                        var
                         x_lq_=get_arg_k__(spec_lg_,n_k$_),
                         s_lr_=
                          caml_format_float
                           (extract_format_jt_(fmt_kX_,i_kZ_,i_k8_,widths_lb_),x_lq_),
                         _lp_=
                          cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),s_lr_,i_k8_+1|0),
                         _lk_=1;
                        break;
                       case 76:
                       case 108:
                       case 110:
                        var _ls_=fmt_kX_.safeGet(i_k8_+1|0)-88|0;
                        if(_ls_<0||32<_ls_)
                         var _lt_=1;
                        else
                         switch(_ls_)
                          {case 0:
                           case 12:
                           case 17:
                           case 23:
                           case 29:
                           case 32:
                            var i_lu_=i_k8_+1|0,_lv_=_lj_-108|0;
                            if(_lv_<0||2<_lv_)
                             var _lw_=0;
                            else
                             {switch(_lv_)
                               {case 1:var _lw_=0,_lx_=0;break;
                                case 2:
                                 var
                                  x_ly_=get_arg_k__(spec_lg_,n_k$_),
                                  _lz_=
                                   caml_format_int
                                    (extract_format_jt_(fmt_kX_,i_kZ_,i_lu_,widths_lb_),x_ly_),
                                  _lx_=1;
                                 break;
                                default:
                                 var
                                  x_lA_=get_arg_k__(spec_lg_,n_k$_),
                                  _lz_=
                                   caml_format_int
                                    (extract_format_jt_(fmt_kX_,i_kZ_,i_lu_,widths_lb_),x_lA_),
                                  _lx_=1;}
                              if(_lx_){var s_lB_=_lz_,_lw_=1;}}
                            if(!_lw_)
                             {var
                               x_lC_=get_arg_k__(spec_lg_,n_k$_),
                               s_lB_=
                                caml_int64_format
                                 (extract_format_jt_(fmt_kX_,i_kZ_,i_lu_,widths_lb_),x_lC_);}
                            var
                             _lp_=
                              cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),s_lB_,i_lu_+1|0),
                             _lk_=1,
                             _lt_=0;
                            break;
                           default:var _lt_=1;}
                        if(_lt_)
                         {var
                           x_lD_=get_arg_k__(spec_lg_,n_k$_),
                           s_lE_=
                            caml_format_int
                             (extract_format_int_ll_(110,fmt_kX_,i_kZ_,i_k8_,widths_lb_),
                              x_lD_),
                           _lp_=
                            cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),s_lE_,i_k8_+1|0),
                           _lk_=1;}
                        break;
                       case 83:
                       case 115:
                        var x_lF_=get_arg_k__(spec_lg_,n_k$_);
                        if(115===_lj_)
                         var x_lG_=x_lF_;
                        else
                         {var n_lH_=[0,0],_lI_=0,_lJ_=x_lF_.getLen()-1|0;
                          if(!(_lJ_<_lI_))
                           {var i_lK_=_lI_;
                            for(;;)
                             {var
                               _lL_=x_lF_.safeGet(i_lK_),
                               _lM_=
                                14<=_lL_
                                 ?34===_lL_?1:92===_lL_?1:0
                                 :11<=_lL_?13<=_lL_?1:0:8<=_lL_?1:0,
                               _lN_=_lM_?2:caml_is_printable(_lL_)?1:4;
                              n_lH_[1]=n_lH_[1]+_lN_|0;
                              var _lO_=i_lK_+1|0;
                              if(_lJ_!==i_lK_){var i_lK_=_lO_;continue;}
                              break;}}
                          if(n_lH_[1]===x_lF_.getLen())
                           var _lP_=x_lF_;
                          else
                           {var s__lQ_=caml_create_string(n_lH_[1]);
                            n_lH_[1]=0;
                            var _lR_=0,_lS_=x_lF_.getLen()-1|0;
                            if(!(_lS_<_lR_))
                             {var i_lT_=_lR_;
                              for(;;)
                               {var _lU_=x_lF_.safeGet(i_lT_),_lV_=_lU_-34|0;
                                if(_lV_<0||58<_lV_)
                                 if(-20<=_lV_)
                                  var _lW_=1;
                                 else
                                  {switch(_lV_+34|0)
                                    {case 8:
                                      s__lQ_.safeSet(n_lH_[1],92);
                                      n_lH_[1]+=1;
                                      s__lQ_.safeSet(n_lH_[1],98);
                                      var _lX_=1;
                                      break;
                                     case 9:
                                      s__lQ_.safeSet(n_lH_[1],92);
                                      n_lH_[1]+=1;
                                      s__lQ_.safeSet(n_lH_[1],116);
                                      var _lX_=1;
                                      break;
                                     case 10:
                                      s__lQ_.safeSet(n_lH_[1],92);
                                      n_lH_[1]+=1;
                                      s__lQ_.safeSet(n_lH_[1],110);
                                      var _lX_=1;
                                      break;
                                     case 13:
                                      s__lQ_.safeSet(n_lH_[1],92);
                                      n_lH_[1]+=1;
                                      s__lQ_.safeSet(n_lH_[1],114);
                                      var _lX_=1;
                                      break;
                                     default:var _lW_=1,_lX_=0;}
                                   if(_lX_)var _lW_=0;}
                                else
                                 var
                                  _lW_=
                                   (_lV_-1|0)<0||56<(_lV_-1|0)
                                    ?(s__lQ_.safeSet(n_lH_[1],92),
                                      n_lH_[1]+=
                                      1,
                                      s__lQ_.safeSet(n_lH_[1],_lU_),
                                      0)
                                    :1;
                                if(_lW_)
                                 if(caml_is_printable(_lU_))
                                  s__lQ_.safeSet(n_lH_[1],_lU_);
                                 else
                                  {s__lQ_.safeSet(n_lH_[1],92);
                                   n_lH_[1]+=1;
                                   s__lQ_.safeSet(n_lH_[1],48+(_lU_/100|0)|0);
                                   n_lH_[1]+=1;
                                   s__lQ_.safeSet(n_lH_[1],48+((_lU_/10|0)%10|0)|0);
                                   n_lH_[1]+=1;
                                   s__lQ_.safeSet(n_lH_[1],48+(_lU_%10|0)|0);}
                                n_lH_[1]+=1;
                                var _lY_=i_lT_+1|0;
                                if(_lS_!==i_lT_){var i_lT_=_lY_;continue;}
                                break;}}
                            var _lP_=s__lQ_;}
                          var x_lG_=_gk_(_fI_,_gk_(_lP_,_fJ_));}
                        if(i_k8_===(i_kZ_+1|0))
                         var s_lZ_=x_lG_;
                        else
                         {var
                           _l0_=
                            extract_format_jt_(fmt_kX_,i_kZ_,i_k8_,widths_lb_);
                          try
                           {var neg_l1_=0,i_l2_=1;
                            for(;;)
                             {if(_l0_.getLen()<=i_l2_)
                               var _l3_=[0,0,neg_l1_];
                              else
                               {var _l4_=_l0_.safeGet(i_l2_);
                                if(49<=_l4_)
                                 if(58<=_l4_)
                                  var _l5_=0;
                                 else
                                  {var
                                    _l3_=
                                     [0,
                                      caml_int_of_string
                                       (_hY_(_l0_,i_l2_,(_l0_.getLen()-i_l2_|0)-1|0)),
                                      neg_l1_],
                                    _l5_=1;}
                                else
                                 {if(45===_l4_)
                                   {var _l7_=i_l2_+1|0,_l6_=1,neg_l1_=_l6_,i_l2_=_l7_;
                                    continue;}
                                  var _l5_=0;}
                                if(!_l5_){var _l8_=i_l2_+1|0,i_l2_=_l8_;continue;}}
                              var match_l9_=_l3_;
                              break;}}
                          catch(_l__)
                           {if(_l__[1]!==_a_)throw _l__;
                            var match_l9_=bad_conversion_i8_(_l0_,0,115);}
                          var
                           p_l$_=match_l9_[1],
                           _ma_=x_lG_.getLen(),
                           _mb_=0,
                           neg_mf_=match_l9_[2],
                           _me_=32;
                          if(p_l$_===_ma_&&0===_mb_)
                           {var _mc_=x_lG_,_md_=1;}
                          else
                           var _md_=0;
                          if(!_md_)
                           if(p_l$_<=_ma_)
                            var _mc_=_hY_(x_lG_,_mb_,_ma_);
                           else
                            {var res_mg_=_hX_(p_l$_,_me_);
                             if(neg_mf_)
                              _hZ_(x_lG_,_mb_,res_mg_,0,_ma_);
                             else
                              _hZ_(x_lG_,_mb_,res_mg_,p_l$_-_ma_|0,_ma_);
                             var _mc_=res_mg_;}
                          var s_lZ_=_mc_;}
                        var
                         _lp_=
                          cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),s_lZ_,i_k8_+1|0),
                         _lk_=1;
                        break;
                       case 67:
                       case 99:
                        var x_mh_=get_arg_k__(spec_lg_,n_k$_);
                        if(99===_lj_)
                         var s_mi_=_hX_(1,x_mh_);
                        else
                         {if(39===x_mh_)
                           var _mj_=_fT_;
                          else
                           if(92===x_mh_)
                            var _mj_=_fU_;
                           else
                            {if(14<=x_mh_)
                              var _mk_=0;
                             else
                              switch(x_mh_)
                               {case 8:var _mj_=_fY_,_mk_=1;break;
                                case 9:var _mj_=_fX_,_mk_=1;break;
                                case 10:var _mj_=_fW_,_mk_=1;break;
                                case 13:var _mj_=_fV_,_mk_=1;break;
                                default:var _mk_=0;}
                             if(!_mk_)
                              if(caml_is_printable(x_mh_))
                               {var s_ml_=caml_create_string(1);
                                s_ml_.safeSet(0,x_mh_);
                                var _mj_=s_ml_;}
                              else
                               {var s_mm_=caml_create_string(4);
                                s_mm_.safeSet(0,92);
                                s_mm_.safeSet(1,48+(x_mh_/100|0)|0);
                                s_mm_.safeSet(2,48+((x_mh_/10|0)%10|0)|0);
                                s_mm_.safeSet(3,48+(x_mh_%10|0)|0);
                                var _mj_=s_mm_;}}
                          var s_mi_=_gk_(_fG_,_gk_(_mj_,_fH_));}
                        var
                         _lp_=
                          cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),s_mi_,i_k8_+1|0),
                         _lk_=1;
                        break;
                       case 66:
                       case 98:
                        var
                         _mo_=i_k8_+1|0,
                         _mn_=get_arg_k__(spec_lg_,n_k$_)?_f1_:_f0_,
                         _lp_=cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),_mn_,_mo_),
                         _lk_=1;
                        break;
                       case 40:
                       case 123:
                        var
                         xf_mp_=get_arg_k__(spec_lg_,n_k$_),
                         j_mq_=_jR_(sub_format_for_printf_km_,_lj_,fmt_kX_,i_k8_+1|0);
                        if(123===_lj_)
                         {var
                           b_mr_=_iQ_(xf_mp_.getLen()),
                           add_char_mv_=
                            function(i_mt_,c_ms_){_iS_(b_mr_,c_ms_);return i_mt_+1|0;};
                          iter_on_format_args_kC_
                           (xf_mp_,
                            function(skip_mu_,i_mx_,c_mw_)
                             {if(skip_mu_)_iT_(b_mr_,_fD_);else _iS_(b_mr_,37);
                              return add_char_mv_(i_mx_,c_mw_);},
                            add_char_mv_);
                          var
                           _my_=_iR_(b_mr_),
                           _lp_=cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),_my_,j_mq_),
                           _lk_=1;}
                        else
                         {var
                           _mz_=next_index_lc_(spec_lg_,n_k$_),
                           m_mC_=
                            add_int_index_iY_
                             (count_arguments_of_format_mA_(xf_mp_),_mz_),
                           _lp_=
                            pr_mE_
                             (function(param_mD_){return doprn_mB_(m_mC_,j_mq_);},
                              _mz_,
                              xf_mp_,
                              v_k6_),
                           _lk_=1;}
                        break;
                       case 33:
                        _gN_(flush_mF_,out_kW_);
                        var _lp_=doprn_mB_(n_k$_,i_k8_+1|0),_lk_=1;
                        break;
                       case 37:
                        var _lp_=cont_s_lo_(n_k$_,_fM_,i_k8_+1|0),_lk_=1;break;
                       case 41:
                        var _lp_=cont_s_lo_(n_k$_,_fL_,i_k8_+1|0),_lk_=1;break;
                       case 44:
                        var _lp_=cont_s_lo_(n_k$_,_fK_,i_k8_+1|0),_lk_=1;break;
                       case 70:
                        var x_mG_=get_arg_k__(spec_lg_,n_k$_);
                        if(0===widths_lb_)
                         var s_mH_=string_of_float_gu_(x_mG_);
                        else
                         {var
                           sfmt_mI_=
                            extract_format_jt_(fmt_kX_,i_kZ_,i_k8_,widths_lb_);
                          if(70===_lj_)sfmt_mI_.safeSet(sfmt_mI_.getLen()-1|0,103);
                          var s_mJ_=caml_format_float(sfmt_mI_,x_mG_);
                          if(3<=caml_classify_float(x_mG_))
                           var _mK_=s_mJ_;
                          else
                           {var i_mL_=0,l_mM_=s_mJ_.getLen();
                            for(;;)
                             {if(l_mM_<=i_mL_)
                               var _mN_=_gk_(s_mJ_,_fF_);
                              else
                               {var
                                 _mO_=s_mJ_.safeGet(i_mL_)-46|0,
                                 _mP_=
                                  _mO_<0||23<_mO_
                                   ?55===_mO_?1:0
                                   :(_mO_-1|0)<0||21<(_mO_-1|0)?1:0;
                                if(!_mP_){var _mQ_=i_mL_+1|0,i_mL_=_mQ_;continue;}
                                var _mN_=s_mJ_;}
                              var _mK_=_mN_;
                              break;}}
                          var s_mH_=_mK_;}
                        var
                         _lp_=
                          cont_s_lo_(next_index_lc_(spec_lg_,n_k$_),s_mH_,i_k8_+1|0),
                         _lk_=1;
                        break;
                       case 97:
                        var
                         printer_mR_=get_arg_k__(spec_lg_,n_k$_),
                         n_mS_=_gN_(_iZ_,get_index_k3_(spec_lg_,n_k$_)),
                         arg_mT_=get_arg_k__(0,n_mS_),
                         _mX_=i_k8_+1|0,
                         _mW_=next_index_lc_(spec_lg_,n_mS_);
                        if(to_s_mU_)
                         _g9_(outs_mV_,out_kW_,_g9_(printer_mR_,0,arg_mT_));
                        else
                         _g9_(printer_mR_,out_kW_,arg_mT_);
                        var _lp_=doprn_mB_(_mW_,_mX_),_lk_=1;
                        break;
                       case 116:
                        var
                         printer_mY_=get_arg_k__(spec_lg_,n_k$_),
                         _m0_=i_k8_+1|0,
                         _mZ_=next_index_lc_(spec_lg_,n_k$_);
                        if(to_s_mU_)
                         _g9_(outs_mV_,out_kW_,_gN_(printer_mY_,0));
                        else
                         _gN_(printer_mY_,out_kW_);
                        var _lp_=doprn_mB_(_mZ_,_m0_),_lk_=1;
                        break;
                       default:var _lk_=0;}
                    if(!_lk_)
                     var _lp_=bad_conversion_format_jX_(fmt_kX_,i_k8_,_lj_);
                    return _lp_;}},
               _m5_=i_kZ_+1|0,
               _m2_=0;
              return scan_positional_spec_lh_
                      (fmt_kX_,
                       function(spec_m4_,i_m1_)
                        {return scan_flags_le_(spec_m4_,n_m3_,_m2_,i_m1_);},
                       n_m3_,
                       _m5_);}
            _g9_(outc_m6_,out_kW_,_k2_);
            var _m7_=i_kZ_+1|0,i_kZ_=_m7_;
            continue;}}
        function cont_s_lo_(n_m__,s_m8_,i_m9_)
         {_g9_(outs_mV_,out_kW_,s_m8_);return doprn_mB_(n_m__,i_m9_);}
        return doprn_mB_(n_m$_,0);}
      var
       kpr_nb_=_g9_(pr_mE_,k_na_,index_of_int_iX_(0)),
       _nc_=count_arguments_of_format_mA_(fmt_kU_);
      if(_nc_<0||6<_nc_)
       {var
         loop_np_=
          function(i_nd_,args_nj_)
           {if(_nc_<=i_nd_)
             {var
               a_ne_=caml_make_vect(_nc_,0),
               _nh_=
                function(i_nf_,arg_ng_)
                 {return caml_array_set(a_ne_,(_nc_-i_nf_|0)-1|0,arg_ng_);},
               i_ni_=0,
               param_nk_=args_nj_;
              for(;;)
               {if(param_nk_)
                 {var _nl_=param_nk_[2],_nm_=param_nk_[1];
                  if(_nl_)
                   {_nh_(i_ni_,_nm_);
                    var _nn_=i_ni_+1|0,i_ni_=_nn_,param_nk_=_nl_;
                    continue;}
                  _nh_(i_ni_,_nm_);}
                return _g9_(kpr_nb_,fmt_kU_,a_ne_);}}
            return function(x_no_)
             {return loop_np_(i_nd_+1|0,[0,x_no_,args_nj_]);};},
         _nq_=loop_np_(0,0);}
      else
       switch(_nc_)
        {case 1:
          var
           _nq_=
            function(x_ns_)
             {var a_nr_=caml_make_vect(1,0);
              caml_array_set(a_nr_,0,x_ns_);
              return _g9_(kpr_nb_,fmt_kU_,a_nr_);};
          break;
         case 2:
          var
           _nq_=
            function(x_nu_,y_nv_)
             {var a_nt_=caml_make_vect(2,0);
              caml_array_set(a_nt_,0,x_nu_);
              caml_array_set(a_nt_,1,y_nv_);
              return _g9_(kpr_nb_,fmt_kU_,a_nt_);};
          break;
         case 3:
          var
           _nq_=
            function(x_nx_,y_ny_,z_nz_)
             {var a_nw_=caml_make_vect(3,0);
              caml_array_set(a_nw_,0,x_nx_);
              caml_array_set(a_nw_,1,y_ny_);
              caml_array_set(a_nw_,2,z_nz_);
              return _g9_(kpr_nb_,fmt_kU_,a_nw_);};
          break;
         case 4:
          var
           _nq_=
            function(x_nB_,y_nC_,z_nD_,t_nE_)
             {var a_nA_=caml_make_vect(4,0);
              caml_array_set(a_nA_,0,x_nB_);
              caml_array_set(a_nA_,1,y_nC_);
              caml_array_set(a_nA_,2,z_nD_);
              caml_array_set(a_nA_,3,t_nE_);
              return _g9_(kpr_nb_,fmt_kU_,a_nA_);};
          break;
         case 5:
          var
           _nq_=
            function(x_nG_,y_nH_,z_nI_,t_nJ_,u_nK_)
             {var a_nF_=caml_make_vect(5,0);
              caml_array_set(a_nF_,0,x_nG_);
              caml_array_set(a_nF_,1,y_nH_);
              caml_array_set(a_nF_,2,z_nI_);
              caml_array_set(a_nF_,3,t_nJ_);
              caml_array_set(a_nF_,4,u_nK_);
              return _g9_(kpr_nb_,fmt_kU_,a_nF_);};
          break;
         case 6:
          var
           _nq_=
            function(x_nM_,y_nN_,z_nO_,t_nP_,u_nQ_,v_nR_)
             {var a_nL_=caml_make_vect(6,0);
              caml_array_set(a_nL_,0,x_nM_);
              caml_array_set(a_nL_,1,y_nN_);
              caml_array_set(a_nL_,2,z_nO_);
              caml_array_set(a_nL_,3,t_nP_);
              caml_array_set(a_nL_,4,u_nQ_);
              caml_array_set(a_nL_,5,v_nR_);
              return _g9_(kpr_nb_,fmt_kU_,a_nL_);};
          break;
         default:var _nq_=_g9_(kpr_nb_,fmt_kU_,[0]);}
      return _nq_;}
    function _n__(oc_nT_)
     {function _nV_(_nS_){return 0;}
      return _nX_
              (_nW_,
               0,
               function(param_nU_){return oc_nT_;},
               _gH_,
               output_string_gD_,
               _ha_,
               _nV_);}
    function _n6_(fmt_nY_){return _iQ_(2*fmt_nY_.getLen()|0);}
    function _n3_(k_n1_,b_nZ_)
     {var s_n0_=_iR_(b_nZ_);b_nZ_[2]=0;return _gN_(k_n1_,s_n0_);}
    function _n9_(k_n2_)
     {var _n5_=_gN_(_n3_,k_n2_);
      return _nX_(_nW_,1,_n6_,_iS_,_iT_,function(_n4_){return 0;},_n5_);}
    function _n$_(fmt_n8_)
     {return _g9_(_n9_,function(s_n7_){return s_n7_;},fmt_n8_);}
    var _oa_=[0,0];
    function _oh_(x_ob_,i_oc_)
     {var f_od_=x_ob_[i_oc_+1];
      return caml_obj_is_block(f_od_)
              ?caml_obj_tag(f_od_)===_iw_
                ?_g9_(_n$_,_fc_,f_od_)
                :caml_obj_tag(f_od_)===_iv_?string_of_float_gu_(f_od_):_fb_
              :_g9_(_n$_,_fd_,f_od_);}
    function _og_(x_oe_,i_of_)
     {if(x_oe_.length-1<=i_of_)return _fu_;
      var _oi_=_og_(x_oe_,i_of_+1|0);
      return _jR_(_n$_,_ft_,_oh_(x_oe_,i_of_),_oi_);}
    32===_h1_;
    function _ol_(param_ok_)
     {var seq_oj_=[];
      caml_update_dummy(seq_oj_,[0,seq_oj_,seq_oj_]);
      return seq_oj_;}
    var Canceled_om_=[0,_e2_],current_data_on_=[0,0],max_removed_pn_=42;
    function repr_rec_or_(t_oo_)
     {var _op_=t_oo_[1];
      {if(3===_op_[0])
        {var t__oq_=_op_[1],t___os_=repr_rec_or_(t__oq_);
         if(t___os_!==t__oq_)t_oo_[1]=[3,t___os_];
         return t___os_;}
       return t_oo_;}}
    function repr_po_(t_ot_){return repr_rec_or_(t_ot_);}
    function _oW_(exn_ov_)
     {var param_ou_=_oa_[1];
      for(;;)
       {if(param_ou_)
         {var tl_oz_=param_ou_[2],hd_ow_=param_ou_[1];
          try
           {var _ox_=_gN_(hd_ow_,exn_ov_),_oy_=_ox_;}
          catch(_oA_){var _oy_=0;}
          if(!_oy_){var param_ou_=tl_oz_;continue;}}
        else
         if(exn_ov_[1]!==_f7_&&exn_ov_[1]!==_f5_)
          if(exn_ov_[1]===_f6_)
           {var match_oB_=exn_ov_[2],char_oC_=match_oB_[3];
            _nX_
             (_n$_,_e_,match_oB_[1],match_oB_[2],char_oC_,char_oC_+5|0,_fj_);}
          else
           if(exn_ov_[1]===_d_)
            {var match_oD_=exn_ov_[2],char_oE_=match_oD_[3];
             _nX_
              (_n$_,_e_,match_oD_[1],match_oD_[2],char_oE_,char_oE_+6|0,_fi_);}
           else
            {var _oF_=exn_ov_.length-1,constructor_oI_=exn_ov_[0+1][0+1];
             if(_oF_<0||2<_oF_)
              {var
                _oG_=_og_(exn_ov_,2),
                _oH_=_jR_(_n$_,_fh_,_oh_(exn_ov_,1),_oG_);}
             else
              switch(_oF_)
               {case 1:var _oH_=_ff_;break;
                case 2:var _oH_=_g9_(_n$_,_fe_,_oh_(exn_ov_,1));break;
                default:var _oH_=_fg_;}
             _gk_(constructor_oI_,_oH_);}
        caml_ml_output_char(stderr_gv_,10);
        var _oJ_=caml_get_exception_backtrace(0);
        if(_oJ_)
         {var a_oK_=_oJ_[1],_oL_=0,_oM_=a_oK_.length-1-1|0;
          if(!(_oM_<_oL_))
           {var i_oN_=_oL_;
            for(;;)
             {if(caml_notequal(caml_array_get(a_oK_,i_oN_),_fs_))
               {var
                 _oO_=caml_array_get(a_oK_,i_oN_),
                 is_raise_oP_=0===_oO_[0]?_oO_[1]:_oO_[1],
                 info_oQ_=is_raise_oP_?0===i_oN_?_fp_:_fo_:0===i_oN_?_fn_:_fm_,
                 _oR_=
                  0===_oO_[0]
                   ?_nX_(_n$_,_fl_,info_oQ_,_oO_[2],_oO_[3],_oO_[4],_oO_[5])
                   :_g9_(_n$_,_fk_,info_oQ_);
                _jR_(_n__,stderr_gv_,_fr_,_oR_);}
              var _oS_=i_oN_+1|0;
              if(_oM_!==i_oN_){var i_oN_=_oS_;continue;}
              break;}}}
        else
         _g9_(_n__,stderr_gv_,_fq_);
        do_at_exit_gC_(0);
        return caml_sys_exit(2);}}
    function call_unsafe_ph_(f_oU_,x_oT_)
     {try {var _oV_=_gN_(f_oU_,x_oT_);}catch(_oX_){return _oW_(_oX_);}
      return _oV_;}
    function run_waiters_rec_o8_(state_o2_,ws_oY_,rem_o0_)
     {var ws_oZ_=ws_oY_,rem_o1_=rem_o0_;
      for(;;)
       if(typeof ws_oZ_==="number")
        return run_waiters_rec_next_o3_(state_o2_,rem_o1_);
       else
        switch(ws_oZ_[0])
         {case 1:
           _gN_(ws_oZ_[1],state_o2_);
           return run_waiters_rec_next_o3_(state_o2_,rem_o1_);
          case 2:
           var
            ws1_o4_=ws_oZ_[1],
            _o5_=[0,ws_oZ_[2],rem_o1_],
            ws_oZ_=ws1_o4_,
            rem_o1_=_o5_;
           continue;
          default:
           var _o6_=ws_oZ_[1][1];
           return _o6_
                   ?(_gN_(_o6_[1],state_o2_),
                     run_waiters_rec_next_o3_(state_o2_,rem_o1_))
                   :run_waiters_rec_next_o3_(state_o2_,rem_o1_);}}
    function run_waiters_rec_next_o3_(state_o9_,rem_o7_)
     {return rem_o7_?run_waiters_rec_o8_(state_o9_,rem_o7_[1],rem_o7_[2]):0;}
    function run_cancel_handlers_rec_pj_(chs_o__,rem_pa_)
     {var chs_o$_=chs_o__,rem_pb_=rem_pa_;
      for(;;)
       if(typeof chs_o$_==="number")
        return run_cancel_handlers_rec_next_pd_(rem_pb_);
       else
        switch(chs_o$_[0])
         {case 1:
           var n_pc_=chs_o$_[1];
           if(n_pc_[4]){n_pc_[4]=0;n_pc_[1][2]=n_pc_[2];n_pc_[2][1]=n_pc_[1];}
           return run_cancel_handlers_rec_next_pd_(rem_pb_);
          case 2:
           var
            chs1_pe_=chs_o$_[1],
            _pf_=[0,chs_o$_[2],rem_pb_],
            chs_o$_=chs1_pe_,
            rem_pb_=_pf_;
           continue;
          default:
           var f_pg_=chs_o$_[2];
           current_data_on_[1]=chs_o$_[1];
           call_unsafe_ph_(f_pg_,0);
           return run_cancel_handlers_rec_next_pd_(rem_pb_);}}
    function run_cancel_handlers_rec_next_pd_(rem_pi_)
     {return rem_pi_?run_cancel_handlers_rec_pj_(rem_pi_[1],rem_pi_[2]):0;}
    function unsafe_run_waiters_pp_(sleeper_pl_,state_pk_)
     {var
       _pm_=
        1===state_pk_[0]
         ?state_pk_[1][1]===Canceled_om_
           ?(run_cancel_handlers_rec_pj_(sleeper_pl_[4],0),1)
           :0
         :0;
      _pm_;
      return run_waiters_rec_o8_(state_pk_,sleeper_pl_[2],0);}
    var wakening_pq_=[0,0],_pr_=[0,0,0];
    function wakeup_result_pE_(t_ps_,result_pv_)
     {var t_pt_=repr_rec_or_(t_ps_),_pu_=t_pt_[1];
      switch(_pu_[0])
       {case 1:if(_pu_[1][1]===Canceled_om_)return 0;break;
        case 2:
         var sleeper_pw_=_pu_[1];
         t_pt_[1]=result_pv_;
         var
          snapshot_px_=current_data_on_[1],
          already_wakening_py_=wakening_pq_[1]?1:(wakening_pq_[1]=1,0);
         unsafe_run_waiters_pp_(sleeper_pw_,result_pv_);
         if(already_wakening_py_)
          {current_data_on_[1]=snapshot_px_;var _pz_=0;}
         else
          for(;;)
           {if(0!==_pr_[1])
             {if(0===_pr_[1])throw [0,_iu_];
              _pr_[1]=_pr_[1]-1|0;
              var tail_pA_=_pr_[2],head_pB_=tail_pA_[2];
              if(head_pB_===tail_pA_)_pr_[2]=0;else tail_pA_[2]=head_pB_[2];
              var _pC_=head_pB_[1];
              unsafe_run_waiters_pp_(_pC_[1],_pC_[2]);
              continue;}
            wakening_pq_[1]=0;
            current_data_on_[1]=snapshot_px_;
            var _pz_=0;
            break;}
         return _pz_;
        default:}
      return _f8_(_e3_);}
    function wakeup_pT_(t_pF_,v_pD_)
     {return wakeup_result_pE_(t_pF_,[0,v_pD_]);}
    function append_pM_(l1_pG_,l2_pH_)
     {return typeof l1_pG_==="number"
              ?l2_pH_
              :typeof l2_pH_==="number"?l1_pG_:[2,l1_pG_,l2_pH_];}
    function cleanup_pJ_(ws_pI_)
     {if(typeof ws_pI_!=="number")
       switch(ws_pI_[0])
        {case 2:
          var l1_pK_=ws_pI_[1],_pL_=cleanup_pJ_(ws_pI_[2]);
          return append_pM_(cleanup_pJ_(l1_pK_),_pL_);
         case 1:break;
         default:if(!ws_pI_[1][1])return 0;}
      return ws_pI_;}
    function fast_connect_pU_(t_pN_,state_pQ_)
     {var t_pO_=repr_po_(t_pN_),_pP_=t_pO_[1];
      {if(2===_pP_[0])
        {var sleeper_pR_=_pP_[1];
         t_pO_[1]=state_pQ_;
         return unsafe_run_waiters_pp_(sleeper_pR_,state_pQ_);}
       throw [0,_d_,_e5_];}}
    function return_pV_(v_pS_){return [0,[0,v_pS_]];}
    var return_unit_qW_=[0,state_return_unit_e1_];
    function temp_qc_(t_pW_){return [0,[2,[0,[0,[0,t_pW_]],0,0,0]]];}
    function task_qX_(param_pY_)
     {var _pX_=[0,[2,[0,1,0,0,0]]];return [0,_pX_,_pX_];}
    function add_immutable_waiter_qy_(sleeper_p1_,waiter_pZ_)
     {var
       _p0_=[1,waiter_pZ_],
       _p2_=sleeper_p1_[2],
       _p3_=typeof _p2_==="number"?_p0_:[2,_p0_,_p2_];
      sleeper_p1_[2]=_p3_;
      return 0;}
    function on_cancel_qY_(t_p4_,f_p6_)
     {var _p5_=repr_po_(t_p4_)[1];
      switch(_p5_[0])
       {case 1:
         if(_p5_[1][1]===Canceled_om_)return call_unsafe_ph_(f_p6_,0);break;
        case 2:
         var
          sleeper_p7_=_p5_[1],
          handler_p8_=[0,current_data_on_[1],f_p6_],
          _p9_=sleeper_p7_[4],
          _p__=typeof _p9_==="number"?handler_p8_:[2,handler_p8_,_p9_];
         sleeper_p7_[4]=_p__;
         return 0;
        default:}
      return 0;}
    function bind_qz_(t_p$_,f_qi_)
     {var t_qa_=repr_po_(t_p$_),_qb_=t_qa_[1];
      switch(_qb_[0])
       {case 1:return [0,_qb_];
        case 2:
         var
          sleeper_qe_=_qb_[1],
          res_qd_=temp_qc_(t_qa_),
          data_qg_=current_data_on_[1];
         add_immutable_waiter_qy_
          (sleeper_qe_,
           function(state_qf_)
            {switch(state_qf_[0])
              {case 0:
                var v_qh_=state_qf_[1];
                current_data_on_[1]=data_qg_;
                try
                 {var _qj_=_gN_(f_qi_,v_qh_),_qk_=_qj_;}
                catch(_ql_){var _qk_=[0,[1,_ql_]];}
                var
                 t1_qm_=repr_po_(res_qd_),
                 t2_qn_=repr_po_(_qk_),
                 _qo_=t1_qm_[1];
                {if(2===_qo_[0])
                  {var sleeper1_qp_=_qo_[1];
                   if(t1_qm_===t2_qn_)
                    var _qq_=0;
                   else
                    {var _qr_=t2_qn_[1];
                     if(2===_qr_[0])
                      {var sleeper2_qs_=_qr_[1];
                       t2_qn_[1]=[3,t1_qm_];
                       sleeper1_qp_[1]=sleeper2_qs_[1];
                       var
                        waiters_qt_=append_pM_(sleeper1_qp_[2],sleeper2_qs_[2]),
                        removed_qu_=sleeper1_qp_[3]+sleeper2_qs_[3]|0;
                       if(max_removed_pn_<removed_qu_)
                        {sleeper1_qp_[3]=0;
                         sleeper1_qp_[2]=cleanup_pJ_(waiters_qt_);}
                       else
                        {sleeper1_qp_[3]=removed_qu_;sleeper1_qp_[2]=waiters_qt_;}
                       var
                        _qv_=sleeper2_qs_[4],
                        _qw_=sleeper1_qp_[4],
                        _qx_=
                         typeof _qw_==="number"
                          ?_qv_
                          :typeof _qv_==="number"?_qw_:[2,_qw_,_qv_];
                       sleeper1_qp_[4]=_qx_;
                       var _qq_=0;}
                     else
                      {t1_qm_[1]=_qr_;
                       var _qq_=unsafe_run_waiters_pp_(sleeper1_qp_,_qr_);}}
                   return _qq_;}
                 throw [0,_d_,_e4_];}
               case 1:return fast_connect_pU_(res_qd_,state_qf_);
               default:throw [0,_d_,_e7_];}});
         return res_qd_;
        case 3:throw [0,_d_,_e6_];
        default:return _gN_(f_qi_,_qb_[1]);}}
    function _qZ_(t_qB_,f_qA_){return bind_qz_(t_qB_,f_qA_);}
    function _q0_(t_qC_,f_qL_)
     {var t_qD_=repr_po_(t_qC_),_qE_=t_qD_[1];
      switch(_qE_[0])
       {case 1:var _qF_=[0,_qE_];break;
        case 2:
         var
          sleeper_qH_=_qE_[1],
          res_qG_=temp_qc_(t_qD_),
          data_qJ_=current_data_on_[1];
         add_immutable_waiter_qy_
          (sleeper_qH_,
           function(state_qI_)
            {switch(state_qI_[0])
              {case 0:
                var v_qK_=state_qI_[1];
                current_data_on_[1]=data_qJ_;
                try
                 {var _qM_=[0,_gN_(f_qL_,v_qK_)],_qN_=_qM_;}
                catch(_qO_){var _qN_=[1,_qO_];}
                return fast_connect_pU_(res_qG_,_qN_);
               case 1:return fast_connect_pU_(res_qG_,state_qI_);
               default:throw [0,_d_,_e9_];}});
         var _qF_=res_qG_;
         break;
        case 3:throw [0,_d_,_e8_];
        default:
         var v_qP_=_qE_[1];
         try
          {var _qQ_=[0,_gN_(f_qL_,v_qP_)],_qR_=_qQ_;}
         catch(_qS_){var _qR_=[1,_qS_];}
         var _qF_=[0,_qR_];}
      return _qF_;}
    function poll_q1_(t_qT_)
     {var _qU_=repr_po_(t_qT_)[1];
      switch(_qU_[0])
       {case 1:throw _qU_[1];
        case 2:return 0;
        case 3:throw [0,_d_,_e__];
        default:return [0,_qU_[1]];}}
    var pause_hook_q3_=[0,function(_qV_){return 0;}],_q2_=_ol_(0),_q6_=[0,0];
    function _rg_(param_q__)
     {var _q4_=1-(_q2_[2]===_q2_?1:0);
      if(_q4_)
       {var tmp_q5_=_ol_(0);
        tmp_q5_[1][2]=_q2_[2];
        _q2_[2][1]=tmp_q5_[1];
        tmp_q5_[1]=_q2_[1];
        _q2_[1][2]=tmp_q5_;
        _q2_[1]=_q2_;
        _q2_[2]=_q2_;
        _q6_[1]=0;
        var curr_q7_=tmp_q5_[2];
        for(;;)
         {var _q8_=curr_q7_!==tmp_q5_?1:0;
          if(_q8_)
           {if(curr_q7_[4])wakeup_pT_(curr_q7_[3],0);
            var _q9_=curr_q7_[2],curr_q7_=_q9_;
            continue;}
          return _q8_;}}
      return _q4_;}
    function iter_s_ra_(f_rc_,l_q$_)
     {if(l_q$_)
       {var
         l_rb_=l_q$_[2],
         x_re_=l_q$_[1],
         _rf_=function(param_rd_){return iter_s_ra_(f_rc_,l_rb_);};
        return _qZ_(_gN_(f_rc_,x_re_),_rf_);}
      return return_unit_qW_;}
    var null_rh_=null,undefined_ri_=undefined;
    function _rG_(x_rj_,f_rk_){return x_rj_==null_rh_?0:_gN_(f_rk_,x_rj_);}
    function _rr_(x_rl_,f_rm_,g_rn_)
     {return x_rl_==null_rh_?_gN_(f_rm_,0):_gN_(g_rn_,x_rl_);}
    function _rH_(x_rs_)
     {function _rq_(x_ro_){return [0,x_ro_];}
      return _rr_(x_rs_,function(param_rp_){return 0;},_rq_);}
    function _rI_(x_rt_){return x_rt_!==undefined_ri_?1:0;}
    function _rJ_(x_ru_,f_rv_)
     {return x_ru_!==undefined_ri_?_gN_(f_rv_,x_ru_):0;}
    function _rE_(x_rw_,f_rx_,g_ry_)
     {return x_rw_===undefined_ri_?_gN_(f_rx_,0):_gN_(g_ry_,x_rw_);}
    function _rK_(x_rz_,f_rA_)
     {return x_rz_===undefined_ri_?_gN_(f_rA_,0):x_rz_;}
    function _rL_(x_rF_)
     {function _rD_(x_rB_){return [0,x_rB_];}
      return _rE_(x_rF_,function(param_rC_){return 0;},_rD_);}
    var
     _true_rM_=true,
     _false_rN_=false,
     regExp_rO_=RegExp,
     array_constructor_rP_=Array;
    function array_get_rT_(_rQ_,_rR_){return _rQ_[_rR_];}
    function match_result_rU_(_rS_){return _rS_;}
    var math_rV_=Math,date_constr_rZ_=Date;
    function escape_rY_(s_rW_){return escape(s_rW_);}
    function _r0_(e_rX_)
     {return e_rX_ instanceof array_constructor_rP_
              ?0
              :[0,new MlWrappedString(e_rX_.toString())];}
    _oa_[1]=[0,_r0_,_oa_[1]];
    function _r3_(_r1_){return _r1_;}
    function _r4_(_r2_){return _r2_;}
    function _sr_(p_r5_,n_r6_){p_r5_.appendChild(n_r6_);return 0;}
    function _ss_(p_r7_,n_r8_){p_r7_.removeChild(n_r8_);return 0;}
    function _st_(f_r__)
     {return _r4_
              (caml_js_wrap_callback
                (function(e_r9_)
                  {if(e_r9_)
                    {var res_r$_=_gN_(f_r__,e_r9_);
                     if(!(res_r$_|0))e_r9_.preventDefault();
                     return res_r$_;}
                   var _sa_=event,res_sb_=_gN_(f_r__,_sa_);
                   _sa_.returnValue=res_sb_;
                   return res_sb_;}));}
    function _su_(s_sc_){return s_sc_.toString();}
    function _sv_(e_sd_,typ_se_,h_sh_,capt_so_)
     {if(e_sd_.addEventListener===undefined_ri_)
       {var
         ev_sf_=_e0_.toString().concat(typ_se_),
         callback_sm_=
          function(e_sg_)
           {var _sl_=[0,h_sh_,e_sg_,[0]];
            return _gN_
                    (function(_sk_,_sj_,_si_)
                      {return caml_js_call(_sk_,_sj_,_si_);},
                     _sl_);};
        e_sd_.attachEvent(ev_sf_,callback_sm_);
        return function(param_sn_)
         {return e_sd_.detachEvent(ev_sf_,callback_sm_);};}
      e_sd_.addEventListener(typ_se_,h_sh_,capt_so_);
      return function(param_sp_)
       {return e_sd_.removeEventListener(typ_se_,h_sh_,capt_so_);};}
    function _sw_(id_sq_){return _gN_(id_sq_,0);}
    var
     onIE_sx_=caml_js_on_ie(0)|0,
     click_sy_=_su_(_eG_),
     mouseup_sz_=_su_(_eF_),
     mousemove_sB_=_su_(_eE_),
     keydown_sA_=_su_(_eD_),
     touchstart_sC_=_su_(_eC_),
     touchmove_sE_=_su_(_eB_),
     touchend_sD_=_su_(_eA_),
     _2d__sF_=_ez_.toString(),
     window_sG_=this,
     document_sH_=window_sG_.document;
    function opt_iter_sP_(x_sI_,f_sJ_){return x_sI_?_gN_(f_sJ_,x_sI_[1]):0;}
    function createElement_sM_(doc_sL_,name_sK_)
     {return doc_sL_.createElement(name_sK_.toString());}
    function unsafeCreateElement_sQ_(doc_sO_,name_sN_)
     {return createElement_sM_(doc_sO_,name_sN_);}
    var createElementSyntax_sR_=[0,785140586];
    function createUl_s0_(doc_sS_)
     {return unsafeCreateElement_sQ_(doc_sS_,_eH_);}
    function createDl_s1_(doc_sT_)
     {return unsafeCreateElement_sQ_(doc_sT_,_eI_);}
    function createLi_s2_(doc_sU_)
     {return unsafeCreateElement_sQ_(doc_sU_,_eJ_);}
    function createDiv_s3_(doc_sV_)
     {return unsafeCreateElement_sQ_(doc_sV_,_eK_);}
    function createA_s4_(doc_sW_)
     {return unsafeCreateElement_sQ_(doc_sW_,_eL_);}
    function createImg_s5_(doc_sX_)
     {return unsafeCreateElement_sQ_(doc_sX_,_eM_);}
    function createDd_s6_(doc_sY_){return createElement_sM_(doc_sY_,_eN_);}
    function createDt_s7_(doc_sZ_){return createElement_sM_(doc_sZ_,_eO_);}
    var Canvas_not_available_s8_=[0,_ey_];
    function createCanvas_s$_(doc_s9_)
     {var c_s__=unsafeCreateElement_sQ_(doc_s9_,_eP_);
      if(1-(c_s__.getContext==null_rh_?1:0))return c_s__;
      throw [0,Canvas_not_available_s8_];}
    _r3_(this.HTMLElement)===undefined_ri_;
    function stopPropagation_tu_(ev_ta_)
     {function _td_(param_tb_){return ev_ta_.stopPropagation();}
      function _te_(param_tc_){return ev_ta_.cancelBubble=_true_rM_;}
      return _rE_(ev_ta_.stopPropagation,_te_,_td_);}
    var
     _tG_=
      caml_js_pure_expr
       (function(param_tt_)
         {var
           l_tf_=
            [0,
             window_sG_.requestAnimationFrame,
             [0,
              window_sG_.mozRequestAnimationFrame,
              [0,
               window_sG_.webkitRequestAnimationFrame,
               [0,
                window_sG_.oRequestAnimationFrame,
                [0,window_sG_.msRequestAnimationFrame,0]]]]];
          try
           {var param_tg_=l_tf_;
            for(;;)
             {if(!param_tg_)throw [0,_c_];
              var x_th_=param_tg_[1],l_ti_=param_tg_[2];
              if(!_rI_(x_th_)){var param_tg_=l_ti_;continue;}
              var _tk_=function(callback_tj_){return x_th_(callback_tj_);};
              break;}}
          catch(_tl_)
           {if(_tl_[1]===_c_)
             {var
               now_tn_=
                function(param_tm_){return new date_constr_rZ_().getTime();},
               last_to_=[0,now_tn_(0)];
              return function(callback_ts_)
               {var
                 t_tp_=now_tn_(0),
                 dt_tq_=last_to_[1]+1000/60-t_tp_,
                 dt_tr_=dt_tq_<0?0:dt_tq_;
                last_to_[1]=t_tp_;
                window_sG_.setTimeout(callback_ts_,dt_tr_);
                return 0;};}
            throw _tl_;}
          return _tk_;}),
     _tF_=this.FileReader;
    function yield_tE_(param_tC_)
     {var
       match_tv_=task_qX_(0),
       t_tw_=match_tv_[1],
       w_tx_=match_tv_[2],
       _tz_=0*1000,
       id_tA_=
        window_sG_.setTimeout
         (caml_js_wrap_callback
           (function(param_ty_){return wakeup_pT_(w_tx_,0);}),
          _tz_);
      on_cancel_qY_
       (t_tw_,function(param_tB_){return window_sG_.clearTimeout(id_tA_);});
      return t_tw_;}
    pause_hook_q3_[1]=
    function(param_tD_)
     {return 1===param_tD_
              ?(window_sG_.setTimeout(caml_js_wrap_callback(_rg_),0),0)
              :0;};
    var _tH_=caml_js_get_console(0);
    function regexp_tJ_(s_tI_)
     {return new regExp_rO_(caml_js_from_byte_string(s_tI_),_eq_.toString());}
    var
     quote_repl_re_tK_=new regExp_rO_(_eo_.toString(),_ep_.toString()),
     _tO_=regexp_tJ_(_en_);
    function split_tN_(c_tL_,s_tM_)
     {return s_tM_.split(_hX_(1,c_tL_).toString());}
    var Local_exn_tP_=[0,_dF_];
    function interrupt_tR_(param_tQ_){throw [0,Local_exn_tP_];}
    var
     _tS_=
      regexp_tJ_
       (caml_js_to_byte_string
         (caml_js_from_byte_string(_dE_).replace(_tO_,_es_.toString()))),
     plus_re_js_string_tT_=new regExp_rO_(_dC_.toString(),_dD_.toString());
    function urldecode_js_string_string_t0_(s_tU_)
     {plus_re_js_string_tT_.lastIndex=0;
      return caml_js_to_byte_string
              (unescape(s_tU_.replace(plus_re_js_string_tT_,_dH_.toString())));}
    function urlencode_t1_(_opt__tV_,s_tX_)
     {var with_plus_tW_=_opt__tV_?_opt__tV_[1]:1;
      if(with_plus_tW_)
       {var
         _tY_=
          caml_js_to_byte_string(escape_rY_(caml_js_from_byte_string(s_tX_)));
        _tS_.lastIndex=0;
        var afc9aadde_tZ_=caml_js_from_byte_string(_tY_);
        return caml_js_to_byte_string
                (afc9aadde_tZ_.replace
                  (_tS_,
                   caml_js_from_byte_string(_dG_).replace
                    (quote_repl_re_tK_,_er_.toString())));}
      return caml_js_to_byte_string
              (escape_rY_(caml_js_from_byte_string(s_tX_)));}
    var Not_an_http_protocol_uC_=[0,_dB_];
    function path_of_path_string_t8_(s_t2_)
     {try
       {var length_t3_=s_t2_.getLen();
        if(0===length_t3_)
         var _t4_=_em_;
        else
         {var i_t5_=0,_t7_=47,_t6_=s_t2_.getLen();
          for(;;)
           {if(_t6_<=i_t5_)throw [0,_c_];
            if(s_t2_.safeGet(i_t5_)!==_t7_)
             {var _t$_=i_t5_+1|0,i_t5_=_t$_;continue;}
            if(0===i_t5_)
             var
              _t9_=
               [0,_el_,path_of_path_string_t8_(_hY_(s_t2_,1,length_t3_-1|0))];
            else
             {var
               _t__=
                path_of_path_string_t8_
                 (_hY_(s_t2_,i_t5_+1|0,(length_t3_-i_t5_|0)-1|0)),
               _t9_=[0,_hY_(s_t2_,0,i_t5_),_t__];}
            var _t4_=_t9_;
            break;}}}
      catch(_ua_){if(_ua_[1]===_c_)return [0,s_t2_,0];throw _ua_;}
      return _t4_;}
    function encode_arguments_uD_(l_ue_)
     {return _h0_
              (_dO_,
               _hm_
                (function(param_ub_)
                  {var
                    n_uc_=param_ub_[1],
                    _ud_=_gk_(_dP_,urlencode_t1_(0,param_ub_[2]));
                   return _gk_(urlencode_t1_(0,n_uc_),_ud_);},
                 l_ue_));}
    function decode_arguments_js_string_uE_(s_uf_)
     {var arr_ug_=split_tN_(38,s_uf_),len_uB_=arr_ug_.length;
      function aux_ux_(acc_uw_,idx_uh_)
       {var idx_ui_=idx_uh_;
        for(;;)
         {if(0<=idx_ui_)
           {try
             {var
               _uu_=idx_ui_-1|0,
               _uv_=
                function(s_up_)
                 {function _ur_(param_uj_)
                   {var y_un_=param_uj_[2],x_um_=param_uj_[1];
                    function get_ul_(t_uk_)
                     {return urldecode_js_string_string_t0_
                              (_rK_(t_uk_,interrupt_tR_));}
                    var _uo_=get_ul_(y_un_);
                    return [0,get_ul_(x_um_),_uo_];}
                  var arr_bis_uq_=split_tN_(61,s_up_);
                  if(2===arr_bis_uq_.length)
                   {var
                     _us_=array_get_rT_(arr_bis_uq_,1),
                     _ut_=_r3_([0,array_get_rT_(arr_bis_uq_,0),_us_]);}
                  else
                   var _ut_=undefined_ri_;
                  return _rE_(_ut_,interrupt_tR_,_ur_);},
               _uy_=
                aux_ux_
                 ([0,
                   _rE_(array_get_rT_(arr_ug_,idx_ui_),interrupt_tR_,_uv_),
                   acc_uw_],
                  _uu_);}
            catch(_uz_)
             {if(_uz_[1]===Local_exn_tP_)
               {var _uA_=idx_ui_-1|0,idx_ui_=_uA_;continue;}
              throw _uz_;}
            return _uy_;}
          return acc_uw_;}}
      return aux_ux_(0,len_uB_-1|0);}
    var
     url_re_uF_=new regExp_rO_(caml_js_from_byte_string(_dA_)),
     file_re_ve_=new regExp_rO_(caml_js_from_byte_string(_dz_));
    function string_of_url_vd_(param_uG_)
     {switch(param_uG_[0])
       {case 1:
         var
          match_uH_=param_uG_[1],
          frag_uI_=match_uH_[6],
          args_uJ_=match_uH_[5],
          port_uK_=match_uH_[2],
          path_uN_=match_uH_[3],
          host_uM_=match_uH_[1],
          _uL_=
           caml_string_notequal(frag_uI_,_ea_)
            ?_gk_(_d$_,urlencode_t1_(0,frag_uI_))
            :_d__,
          _uO_=args_uJ_?_gk_(_d9_,encode_arguments_uD_(args_uJ_)):_d8_,
          _uQ_=_gk_(_uO_,_uL_),
          _uS_=
           _gk_
            (_d6_,
             _gk_
              (_h0_
                (_d7_,
                 _hm_
                  (function(eta_uP_){return urlencode_t1_(0,eta_uP_);},
                   path_uN_)),
               _uQ_)),
          _uR_=443===port_uK_?_d4_:_gk_(_d5_,string_of_int_gt_(port_uK_)),
          _uT_=_gk_(_uR_,_uS_);
         return _gk_(_d3_,_gk_(urlencode_t1_(0,host_uM_),_uT_));
        case 2:
         var
          match_uU_=param_uG_[1],
          frag_uV_=match_uU_[4],
          args_uW_=match_uU_[3],
          path_uY_=match_uU_[1],
          _uX_=
           caml_string_notequal(frag_uV_,_d2_)
            ?_gk_(_d1_,urlencode_t1_(0,frag_uV_))
            :_d0_,
          _uZ_=args_uW_?_gk_(_dZ_,encode_arguments_uD_(args_uW_)):_dY_,
          _u1_=_gk_(_uZ_,_uX_);
         return _gk_
                 (_dW_,
                  _gk_
                   (_h0_
                     (_dX_,
                      _hm_
                       (function(eta_u0_){return urlencode_t1_(0,eta_u0_);},
                        path_uY_)),
                    _u1_));
        default:
         var
          match_u2_=param_uG_[1],
          frag_u3_=match_u2_[6],
          args_u4_=match_u2_[5],
          port_u5_=match_u2_[2],
          path_u8_=match_u2_[3],
          host_u7_=match_u2_[1],
          _u6_=
           caml_string_notequal(frag_u3_,_ek_)
            ?_gk_(_ej_,urlencode_t1_(0,frag_u3_))
            :_ei_,
          _u9_=args_u4_?_gk_(_eh_,encode_arguments_uD_(args_u4_)):_eg_,
          _u$_=_gk_(_u9_,_u6_),
          _vb_=
           _gk_
            (_ee_,
             _gk_
              (_h0_
                (_ef_,
                 _hm_
                  (function(eta_u__){return urlencode_t1_(0,eta_u__);},
                   path_u8_)),
               _u$_)),
          _va_=80===port_u5_?_ec_:_gk_(_ed_,string_of_int_gt_(port_u5_)),
          _vc_=_gk_(_va_,_vb_);
         return _gk_(_eb_,_gk_(urlencode_t1_(0,host_u7_),_vc_));}}
    var l_vf_=location;
    urldecode_js_string_string_t0_(l_vf_.hostname);
    try {}catch(_vg_){if(_vg_[1]!==_a_)throw _vg_;}
    path_of_path_string_t8_(urldecode_js_string_string_t0_(l_vf_.pathname));
    decode_arguments_js_string_uE_(l_vf_.search);
    urldecode_js_string_string_t0_(l_vf_.href);
    var formData_vo_=this.FormData;
    function _vn_(form_contents_vh_,form_elt_vj_)
     {if(891486873<=form_contents_vh_[1])
       {var list_vi_=form_contents_vh_[2];
        list_vi_[1]=[0,form_elt_vj_,list_vi_[1]];
        return 0;}
      var
       f_vk_=form_contents_vh_[2],
       _vl_=form_elt_vj_[2],
       _vm_=form_elt_vj_[1];
      return 781515420<=_vl_[1]
              ?f_vk_.append(_vm_.toString(),_vl_[2])
              :f_vk_.append(_vm_.toString(),_vl_[2]);}
    function _vq_(param_vp_){return ActiveXObject;}
    var _vt_=[0,_c6_];
    function icon_vs_(nm_vr_){return _gk_(_C_,nm_vr_).toString();}
    var tree_color_vu_=_A_.toString();
    function option_vx_(var_vw_)
     {return _rK_
              (var_vw_,
               function(param_vv_){return new array_constructor_rP_();});}
    var style_vy_=option_vx_(window.hyp_style);
    function opt_style_wq_(v_vB_,default_vz_)
     {return _rK_(v_vB_,function(param_vA_){return default_vz_;});}
    function sdiv_wi_(z_vC_,s_vD_)
     {return [254,z_vC_[1]/s_vD_,z_vC_[2]/s_vD_];}
    function sq_norm_vF_(c_vE_){return c_vE_[1]*c_vE_[1]+c_vE_[2]*c_vE_[2];}
    function norm_wh_(c_vG_){return Math.sqrt(sq_norm_vF_(c_vG_));}
    function conj_v3_(z_vH_){return [254,z_vH_[1],-z_vH_[2]];}
    function neg_wr_(z_vI_){return [254,-z_vI_[1],-z_vI_[2]];}
    function add_wd_(z_vK_,t_vJ_)
     {return [254,z_vK_[1]+t_vJ_[1],z_vK_[2]+t_vJ_[2]];}
    function sub_wk_(z_vM_,t_vL_)
     {return [254,z_vM_[1]-t_vL_[1],z_vM_[2]-t_vL_[2]];}
    function mul_v5_(z_vO_,t_vN_)
     {return [254,
              z_vO_[1]*t_vN_[1]-z_vO_[2]*t_vN_[2],
              z_vO_[1]*t_vN_[2]+z_vO_[2]*t_vN_[1]];}
    function add_mul_vV_(a_vR_,z_vQ_,b_vP_)
     {return [254,
              a_vR_[1]*z_vQ_[1]-a_vR_[2]*z_vQ_[2]+b_vP_[1],
              a_vR_[1]*z_vQ_[2]+a_vR_[2]*z_vQ_[1]+b_vP_[2]];}
    function div_v2_(z_vU_,t_vS_)
     {var n_vT_=sq_norm_vF_(t_vS_);
      return [254,
              (z_vU_[1]*t_vS_[1]+z_vU_[2]*t_vS_[2])/n_vT_,
              (z_vU_[2]*t_vS_[1]-z_vU_[1]*t_vS_[2])/n_vT_];}
    function transf_v6_(a_v0_,b_vZ_,c_vY_,d_vW_,z_vX_)
     {var _v1_=add_mul_vV_(c_vY_,z_vX_,d_vW_);
      return div_v2_(add_mul_vV_(a_v0_,z_vX_,b_vZ_),_v1_);}
    function transl_ws_(p_v4_)
     {var c_v8_=mul_v5_(conj_v3_(p_v4_),one_h_);
      return function(z_v7_)
       {return transf_v6_(one_h_,p_v4_,c_v8_,one_h_,z_v7_);};}
    function compose_wt_(param_wa_,_v9_)
     {var
       t2_v__=_v9_[2],
       p2_v$_=_v9_[1],
       t1_wc_=param_wa_[2],
       t2p1_wb_=mul_v5_(t2_v__,param_wa_[1]),
       den_we_=add_wd_(mul_v5_(t2p1_wb_,conj_v3_(p2_v$_)),one_h_),
       _wf_=div_v2_(conj_v3_(den_we_),den_we_),
       _wg_=mul_v5_(mul_v5_(t1_wc_,t2_v__),_wf_),
       _wj_=sdiv_wi_(_wg_,norm_wh_(_wg_));
      return [0,div_v2_(add_wd_(t2p1_wb_,p2_v$_),den_we_),_wj_];}
    function compute_translation_wu_(z0_wl_,z1_wm_)
     {var
       dz_wn_=sub_wk_(z1_wm_,z0_wl_),
       z0z1_wo_=mul_v5_(z0_wl_,z1_wm_),
       _wp_=1-sq_norm_vF_(z0z1_wo_);
      return sdiv_wi_(add_wd_(mul_v5_(z0z1_wo_,conj_v3_(dz_wn_)),dz_wn_),_wp_);}
    var json_wv_=JSON;
    function http_get_zp_(url_xb_)
     {var _wz_=0,_wA_=0,_wB_=0,_wC_=0,_wD_=0,_wE_=0;
      function _wG_(r_ww_)
       {var cod_wx_=r_ww_[2],msg_wy_=r_ww_[4];
        if(0!==cod_wx_&&200!==cod_wx_)return [0,[2,[0,0,0,0,0]]];
        return return_pV_(msg_wy_);}
      var
       headers_wF_=_wE_?_wE_[1]:0,
       get_args_wH_=_wB_?_wB_[1]:0,
       check_headers_wI_=_wz_?_wz_[1]:function(param_wJ_,_wK_){return 1;};
      if(_wA_)
       {var form_arg_wL_=_wA_[1];
        if(_wC_)
         {var post_args_wN_=_wC_[1];
          _hz_
           (function(param_wM_)
             {return _vn_
                      (form_arg_wL_,
                       [0,param_wM_[1],[0,-976970511,param_wM_[2].toString()]]);},
            post_args_wN_);}
        var form_arg_wO_=[0,form_arg_wL_];}
      else
       if(_wC_)
        {var
          post_args_wP_=_wC_[1],
          _wQ_=_rL_(_r3_(formData_vo_)),
          contents_wR_=_wQ_?[0,808620462,new (_wQ_[1])()]:[0,891486873,[0,0]];
         _hz_
          (function(param_wS_)
            {return _vn_
                     (contents_wR_,
                      [0,param_wS_[1],[0,-976970511,param_wS_[2].toString()]]);},
           post_args_wP_);
         var form_arg_wO_=[0,contents_wR_];}
       else
        var form_arg_wO_=0;
      if(form_arg_wO_)
       {var _wT_=form_arg_wO_[1];
        if(_wD_)
         var _wU_=[0,_dx_,_wD_,126925477];
        else
         {if(891486873<=_wT_[1])
           {var yes_wV_=0,no_wW_=0,param_wX_=_wT_[2][1];
            for(;;)
             {if(param_wX_)
               {var
                 l_wY_=param_wX_[2],
                 x_wZ_=param_wX_[1],
                 _w0_=781515420<=x_wZ_[2][1]?0:1;
                if(_w0_)
                 {var _w1_=[0,x_wZ_,yes_wV_],yes_wV_=_w1_,param_wX_=l_wY_;
                  continue;}
                var _w2_=[0,x_wZ_,no_wW_],no_wW_=_w2_,param_wX_=l_wY_;
                continue;}
              var _w3_=_hy_(no_wW_);
              _hy_(yes_wV_);
              if(_w3_)
               {var
                 nine_digits_w5_=
                  function(param_w4_)
                   {return string_of_int_gt_(math_rV_.random()*1000000000|0);},
                 _w6_=nine_digits_w5_(0),
                 _w7_=_gk_(_c$_,_gk_(nine_digits_w5_(0),_w6_)),
                 _w8_=[0,_dv_,[0,_gk_(_dw_,_w7_)],[0,164354597,_w7_]];}
              else
               var _w8_=_du_;
              var _w9_=_w8_;
              break;}}
          else
           var _w9_=_dt_;
          var _wU_=_w9_;}
        var match_w__=_wU_;}
      else
       var match_w__=[0,_ds_,_wD_,126925477];
      var
       post_encode_w$_=match_w__[3],
       content_type_xa_=match_w__[2],
       _xc_=caml_js_from_byte_string(url_xb_),
       method__xL_=match_w__[1];
      function _xM_(handle_xd_)
       {var
         res_xe_=match_result_rU_(handle_xd_),
         _xf_=
          caml_js_to_byte_string
           (_rK_(array_get_rT_(res_xe_,1),interrupt_tR_).toLowerCase());
        if(caml_string_notequal(_xf_,_dN_)&&caml_string_notequal(_xf_,_dM_))
         {if(caml_string_notequal(_xf_,_dL_)&&caml_string_notequal(_xf_,_dK_))
           {if
             (caml_string_notequal(_xf_,_dJ_)&&
              caml_string_notequal(_xf_,_dI_))
             {var _xh_=1,_xg_=0;}
            else
             var _xg_=1;
            if(_xg_){var ssl_xi_=1,_xh_=2;}}
          else
           var _xh_=0;
          switch(_xh_)
           {case 1:var _xj_=0;break;
            case 2:var _xj_=1;break;
            default:var ssl_xi_=0,_xj_=1;}
          if(_xj_)
           {var
             path_str_xk_=
              urldecode_js_string_string_t0_
               (_rK_(array_get_rT_(res_xe_,5),interrupt_tR_)),
             _xm_=function(param_xl_){return caml_js_from_byte_string(_dR_);},
             _xo_=
              urldecode_js_string_string_t0_
               (_rK_(array_get_rT_(res_xe_,9),_xm_)),
             _xp_=function(param_xn_){return caml_js_from_byte_string(_dS_);},
             _xq_=
              decode_arguments_js_string_uE_
               (_rK_(array_get_rT_(res_xe_,7),_xp_)),
             _xs_=path_of_path_string_t8_(path_str_xk_),
             _xt_=function(param_xr_){return caml_js_from_byte_string(_dT_);},
             _xu_=caml_js_to_byte_string(_rK_(array_get_rT_(res_xe_,4),_xt_)),
             _xv_=
              caml_string_notequal(_xu_,_dQ_)
               ?caml_int_of_string(_xu_)
               :ssl_xi_?443:80,
             url_xw_=
              [0,
               urldecode_js_string_string_t0_
                (_rK_(array_get_rT_(res_xe_,2),interrupt_tR_)),
               _xv_,
               _xs_,
               path_str_xk_,
               _xq_,
               _xo_],
             _xx_=ssl_xi_?[1,url_xw_]:[0,url_xw_];
            return [0,_xx_];}}
        throw [0,Not_an_http_protocol_uC_];}
      function _xN_(param_xK_)
       {function _xI_(handle_xy_)
         {var
           res_xz_=match_result_rU_(handle_xy_),
           path_str_xA_=
            urldecode_js_string_string_t0_
             (_rK_(array_get_rT_(res_xz_,2),interrupt_tR_));
          function _xC_(param_xB_){return caml_js_from_byte_string(_dU_);}
          var
           _xE_=
            caml_js_to_byte_string(_rK_(array_get_rT_(res_xz_,6),_xC_));
          function _xF_(param_xD_){return caml_js_from_byte_string(_dV_);}
          var
           _xG_=
            decode_arguments_js_string_uE_
             (_rK_(array_get_rT_(res_xz_,4),_xF_));
          return [0,
                  [2,
                   [0,
                    path_of_path_string_t8_(path_str_xA_),
                    path_str_xA_,
                    _xG_,
                    _xE_]]];}
        function _xJ_(param_xH_){return 0;}
        return _rr_(file_re_ve_.exec(_xc_),_xJ_,_xI_);}
      var _xO_=_rr_(url_re_uF_.exec(_xc_),_xN_,_xM_);
      if(_xO_)
       {var _xP_=_xO_[1];
        switch(_xP_[0])
         {case 0:
           var url_xQ_=_xP_[1],_xR_=url_xQ_.slice(),_xS_=url_xQ_[5];
           _xR_[5]=0;
           var match_xT_=[0,string_of_url_vd_([0,_xR_]),_xS_],_xU_=1;
           break;
          case 1:
           var url_xV_=_xP_[1],_xW_=url_xV_.slice(),_xX_=url_xV_[5];
           _xW_[5]=0;
           var match_xT_=[0,string_of_url_vd_([1,_xW_]),_xX_],_xU_=1;
           break;
          default:var _xU_=0;}}
      else
       var _xU_=0;
      if(!_xU_)var match_xT_=[0,url_xb_,0];
      var
       url_xY_=match_xT_[1],
       _xZ_=_gq_(match_xT_[2],get_args_wH_),
       url_x0_=
        _xZ_?_gk_(url_xY_,_gk_(_dr_,encode_arguments_uD_(_xZ_))):url_xY_,
       match_x1_=task_qX_(0),
       w_x2_=match_x1_[2],
       res_x3_=match_x1_[1];
      try
       {var _x4_=new XMLHttpRequest(),req_x5_=_x4_;}
      catch(_zb_)
       {try
         {var
           a287eef3f_x6_=_vq_(0),
           _x7_=new a287eef3f_x6_(_c__.toString()),
           req_x5_=_x7_;}
        catch(_yc_)
         {try
           {var
             adf052a6f_x8_=_vq_(0),
             _x9_=new adf052a6f_x8_(_c9_.toString()),
             req_x5_=_x9_;}
          catch(_yb_)
           {try
             {var
               a90ab7ebb_x__=_vq_(0),
               _x$_=new a90ab7ebb_x__(_c8_.toString());}
            catch(_ya_){throw [0,_d_,_c7_];}
            var req_x5_=_x$_;}}}
      req_x5_.open(method__xL_.toString(),url_x0_.toString(),_true_rM_);
      if(content_type_xa_)
       req_x5_.setRequestHeader
        (_dq_.toString(),content_type_xa_[1].toString());
      _hz_
       (function(param_yd_)
         {return req_x5_.setRequestHeader
                  (param_yd_[1].toString(),param_yd_[2].toString());},
        headers_wF_);
      function headers_yj_(s_yh_)
       {function _yg_(v_ye_){return [0,new MlWrappedString(v_ye_)];}
        function _yi_(param_yf_){return 0;}
        return _rr_
                (req_x5_.getResponseHeader(caml_js_from_byte_string(s_yh_)),
                 _yi_,
                 _yg_);}
      var checked_yk_=[0,0];
      function do_check_headers_yn_(param_ym_)
       {var
         _yl_=
          checked_yk_[1]
           ?0
           :_g9_(check_headers_wI_,req_x5_.status,headers_yj_)
             ?0
             :(wakeup_result_pE_
                (w_x2_,[1,[0,_vt_,[0,req_x5_.status,headers_yj_]]]),
               req_x5_.abort(),
               1);
        _yl_;
        checked_yk_[1]=1;
        return 0;}
      req_x5_.onreadystatechange=
      caml_js_wrap_callback
       (function(param_ys_)
         {switch(req_x5_.readyState)
           {case 2:if(!onIE_sx_)return do_check_headers_yn_(0);break;
            case 3:if(onIE_sx_)return do_check_headers_yn_(0);break;
            case 4:
             do_check_headers_yn_(0);
             var
              _yr_=
               function(param_yq_)
                {var _yo_=_rH_(req_x5_.responseXML);
                 if(_yo_)
                  {var doc_yp_=_yo_[1];
                   return _r4_(doc_yp_.documentElement)===null_rh_
                           ?0
                           :[0,doc_yp_];}
                 return 0;};
             return wakeup_pT_
                     (w_x2_,
                      [0,
                       url_x0_,
                       req_x5_.status,
                       headers_yj_,
                       new MlWrappedString(req_x5_.responseText),
                       _yr_]);
            default:}
          return 0;});
      if(form_arg_wO_)
       {var _yt_=form_arg_wO_[1];
        if(891486873<=_yt_[1])
         {var l_yu_=_yt_[2];
          if(typeof post_encode_w$_==="number")
           {var _yA_=l_yu_[1];
            req_x5_.send
             (_r4_
               (_h0_
                  (_dn_,
                   _hm_
                    (function(param_yv_)
                      {var _yw_=param_yv_[2],_yx_=param_yv_[1];
                       if(781515420<=_yw_[1])
                        {var
                          _yy_=
                           _gk_
                            (_dp_,urlencode_t1_(0,new MlWrappedString(_yw_[2].name)));
                         return _gk_(urlencode_t1_(0,_yx_),_yy_);}
                       var
                        _yz_=
                         _gk_(_do_,urlencode_t1_(0,new MlWrappedString(_yw_[2])));
                       return _gk_(urlencode_t1_(0,_yx_),_yz_);},
                     _yA_)).toString
                 ()));}
          else
           {var
             boundary_yB_=post_encode_w$_[2],
             _yE_=
              function(data_yC_)
               {var data_yD_=_r4_(data_yC_.join(_dy_.toString()));
                return _rI_(req_x5_.sendAsBinary)
                        ?req_x5_.sendAsBinary(data_yD_)
                        :req_x5_.send(data_yD_);},
             _yG_=l_yu_[1],
             b_yF_=new array_constructor_rP_(),
             _y$_=
              function(param_yH_)
               {b_yF_.push(_gk_(_da_,_gk_(boundary_yB_,_db_)).toString());
                return b_yF_;};
            _q0_
             (_q0_
               (iter_s_ra_
                 (function(v_yI_)
                   {b_yF_.push(_gk_(_df_,_gk_(boundary_yB_,_dg_)).toString());
                    var _yJ_=v_yI_[2],_yK_=v_yI_[1];
                    if(781515420<=_yJ_[1])
                     {var
                       value_yL_=_yJ_[2],
                       _yS_=-1041425454,
                       _yT_=
                        function(file_yR_)
                         {var
                           _yO_=_dm_.toString(),
                           _yN_=_dl_.toString(),
                           _yM_=_rL_(value_yL_.name);
                          if(_yM_)
                           var _yP_=_yM_[1];
                          else
                           {var
                             _yQ_=_rL_(value_yL_.fileName),
                             _yP_=_yQ_?_yQ_[1]:_q_(_et_);}
                          b_yF_.push
                           (_gk_(_dj_,_gk_(_yK_,_dk_)).toString(),_yP_,_yN_,_yO_);
                          b_yF_.push(_dh_.toString(),file_yR_,_di_.toString());
                          return return_pV_(0);},
                       _yU_=_rL_(_r3_(_tF_));
                      if(_yU_)
                       {var
                         reader_yV_=new (_yU_[1])(),
                         match_yW_=task_qX_(0),
                         res_yX_=match_yW_[1],
                         w_y1_=match_yW_[2];
                        reader_yV_.onloadend=
                        _st_
                         (function(param_y2_)
                           {if(2===reader_yV_.readyState)
                             {var
                               _yY_=reader_yV_.result,
                               _yZ_=
                                caml_equal(typeof _yY_,_eu_.toString())?_r4_(_yY_):null_rh_,
                               _y0_=_rH_(_yZ_);
                              if(!_y0_)throw [0,_d_,_ev_];
                              wakeup_pT_(w_y1_,_y0_[1]);}
                            return _false_rN_;});
                        on_cancel_qY_
                         (res_yX_,function(param_y3_){return reader_yV_.abort();});
                        if(typeof _yS_==="number")
                         if(-550809787===_yS_)
                          reader_yV_.readAsDataURL(value_yL_);
                         else
                          if(936573133<=_yS_)
                           reader_yV_.readAsText(value_yL_);
                          else
                           reader_yV_.readAsBinaryString(value_yL_);
                        else
                         reader_yV_.readAsText(value_yL_,_yS_[2]);
                        var _y4_=res_yX_;}
                      else
                       {var fail_y6_=function(param_y5_){return _q_(_ex_);};
                        if(typeof _yS_==="number")
                         var
                          _y7_=
                           -550809787===_yS_
                            ?_rI_(value_yL_.getAsDataURL)
                              ?value_yL_.getAsDataURL()
                              :fail_y6_(0)
                            :936573133<=_yS_
                              ?_rI_(value_yL_.getAsText)
                                ?value_yL_.getAsText(_ew_.toString())
                                :fail_y6_(0)
                              :_rI_(value_yL_.getAsBinary)
                                ?value_yL_.getAsBinary()
                                :fail_y6_(0);
                        else
                         {var
                           e_y8_=_yS_[2],
                           _y7_=
                            _rI_(value_yL_.getAsText)
                             ?value_yL_.getAsText(e_y8_)
                             :fail_y6_(0);}
                        var _y4_=return_pV_(_y7_);}
                      return _qZ_(_y4_,_yT_);}
                    var value_y__=_yJ_[2],_y9_=_de_.toString();
                    b_yF_.push
                     (_gk_(_dc_,_gk_(_yK_,_dd_)).toString(),value_y__,_y9_);
                    return return_pV_(0);},
                  _yG_),
                _y$_),
              _yE_);}}
        else
         req_x5_.send(_yt_[2]);}
      else
       req_x5_.send(null_rh_);
      on_cancel_qY_(res_x3_,function(param_za_){return req_x5_.abort();});
      return bind_qz_(res_x3_,_wG_);}
    function load_image_zq_(src_zl_)
     {var img_zc_=createImg_s5_(document_sH_);
      function _zf_(param_zd_){return return_pV_(img_zc_);}
      var match_ze_=task_qX_(0),w_zh_=match_ze_[2],t_zi_=match_ze_[1];
      function cont_zj_(x_zg_){return wakeup_pT_(w_zh_,x_zg_);}
      img_zc_.onload=
      _st_(function(param_zk_){cont_zj_(0);return _false_rN_;});
      img_zc_.src=src_zl_;
      return bind_qz_(t_zi_,_zf_);}
    function create_canvas_zr_(w_zn_,h_zo_)
     {var c_zm_=createCanvas_s$_(window_sG_.document);
      c_zm_.width=w_zn_;
      c_zm_.height=h_zo_;
      return c_zm_;}
    var debug_widget_zs_=createDiv_s3_(document_sH_);
    debug_widget_zs_.style.position=_z_.toString();
    debug_widget_zs_.style.bottom=_y_.toString();
    debug_widget_zs_.style.left=_x_.toString();
    debug_widget_zs_.style.lineHeight=_w_.toString();
    var
     text_size_div_zv_=
      [246,
       function(param_zu_)
        {var d_zt_=createDiv_s3_(document_sH_);
         d_zt_.style.visibility=_K_.toString();
         d_zt_.style.position=_J_.toString();
         d_zt_.style.whiteSpace=_I_.toString();
         _sr_(document_sH_.body,d_zt_);
         return d_zt_;}],
     navigator_zw_=window.navigator;
    function default_language_zE_(param_zB_)
     {function _zA_(param_zz_)
       {function _zy_(param_zx_){return _L_.toString();}
        return _rK_(navigator_zw_.userLanguage,_zy_);}
      return _rK_(navigator_zw_.language,_zA_).substring(0,2);}
    function _zG_(st_zC_)
     {var
       _zD_=st_zC_.getItem(_M_.toString()),
       _zF_=_zD_==null_rh_?default_language_zE_(0):_zD_;
      return _zF_;}
    var
     language_zH_=
      [0,_rE_(window_sG_.localStorage,default_language_zE_,_zG_)];
    _tH_.log(language_zH_[1]);
    function local_messages_zP_(msgs_zI_)
     {return option_vx_(msgs_zI_[language_zH_[1]]);}
    function screen_transform_zQ_(canvas_zL_)
     {var
       _zJ_=opt_style_wq_(style_vy_.padding,0),
       offset_zK_=opt_style_wq_(style_vy_.border,0.5)+_zJ_,
       w_zM_=canvas_zL_.width,
       h_zN_=canvas_zL_.height,
       rx_zO_=_f__(5,w_zM_/2-offset_zK_);
      return [0,rx_zO_,_f__(5,h_zN_/2-offset_zK_),w_zM_/2,h_zN_/2];}
    var eps_zR_=0.05;
    function from_screen_zY_(canvas_zS_,x_zV_,y_zU_)
     {var
       match_zT_=screen_transform_zQ_(canvas_zS_),
       z_zW_=
        [254,
         (x_zV_-match_zT_[3])/match_zT_[1],
         (y_zU_-match_zT_[4])/match_zT_[2]],
       n_zX_=norm_wh_(z_zW_);
      return n_zX_<=1-eps_zR_?z_zW_:sdiv_wi_(z_zW_,n_zX_/(1-eps_zR_));}
    var pi_zZ_=4*Math.atan(1);
    function ellipse_arc_z8_
     (c_z0_,cx_z2_,cy_z1_,rx_z4_,ry_z3_,start_z7_,fin_z6_,clock_wise_z5_)
     {c_z0_.save();
      c_z0_.translate(cx_z2_,cy_z1_);
      c_z0_.scale(rx_z4_,ry_z3_);
      c_z0_.arc(0,0,1,start_z7_,fin_z6_,clock_wise_z5_);
      return c_z0_.restore();}
    var shadow_z9_=0;
    function _Av_(x_z__,f_z$_){return _gN_(f_z$_,x_z__);}
    function tree_vertice_count_Ab_(n_Aa_)
     {var l_Af_=n_Aa_[2],_Ae_=1;
      return _hc_
              (function(s_Ad_,n_Ac_)
                {return s_Ad_+tree_vertice_count_Ab_(n_Ac_)|0;},
               _Ae_,
               l_Af_);}
    function tree_edge_count_Ah_(n_Ag_)
     {var l_Al_=n_Ag_[2],_Ak_=0;
      return _hc_
              (function(s_Aj_,n_Ai_)
                {return (s_Aj_+1|0)+tree_edge_count_Ah_(n_Ai_)|0;},
               _Ak_,
               l_Al_);}
    function randomize_tree_Au_(n_Am_)
     {var ch_An_=n_Am_[2],_Ao_=ch_An_.length-1-1|0,_Ap_=0;
      if(!(_Ao_<_Ap_))
       {var i_Aq_=_Ao_;
        for(;;)
         {var
           v_Ar_=caml_array_get(ch_An_,i_Aq_),
           j_As_=math_rV_.random()*(i_Aq_+1|0)|0;
          caml_array_set(ch_An_,i_Aq_,caml_array_get(ch_An_,j_As_));
          caml_array_set(ch_An_,j_As_,v_Ar_);
          var _At_=i_Aq_-1|0;
          if(_Ap_!==i_Aq_){var i_Aq_=_At_;continue;}
          break;}}
      return _g$_(randomize_tree_Au_,ch_An_);}
    var
     need_redraw_Aw_=[0,0],
     redraw_funct_Ay_=[0,function(param_Ax_){return 0;}];
    function perform_redraw_AA_(param_Az_)
     {need_redraw_Aw_[1]=0;return _gN_(redraw_funct_Ay_[1],0);}
    function schedule_redraw_AD_(now_AC_)
     {return need_redraw_Aw_[1]
              ?0
              :(need_redraw_Aw_[1]=
                1,
                _gN_
                 (_tG_,
                  caml_js_wrap_callback
                   (function(param_AB_)
                     {return need_redraw_Aw_[1]?perform_redraw_AA_(0):0;})));}
    regexp_tJ_(_u_);
    regexp_tJ_(_t_);
    regexp_tJ_(_s_);
    function compute_text_nodes_C5_(node_names_AE_,nodes_AP_)
     {try
       {var _AF_=_hA_(language_zH_[1],node_names_AE_)[1],names_AG_=_AF_;}
      catch(_AH_)
       {if(_AH_[1]!==_c_)throw _AH_;
        try
         {var _AI_=_hA_(_$_.toString(),node_names_AE_)[1],_AJ_=_AI_;}
        catch(_AK_){if(_AK_[1]!==_c_)throw _AK_;var _AJ_=_ij_(11);}
        var names_AG_=_AJ_;}
      try
       {var _AL_=_ik_(names_AG_,___),_AM_=_AL_;}
      catch(_AN_){if(_AN_[1]!==_c_)throw _AN_;var _AM_=_Z_;}
      document_sH_.title=_AM_.toString();
      var _AO_=0,_AQ_=nodes_AP_.length-1-1|0;
      if(!(_AQ_<_AO_))
       {var i_AR_=_AO_;
        for(;;)
         {var _AS_=caml_array_get(nodes_AP_,i_AR_),_AT_=_AS_[2],_Bd_=_AS_[1];
          if(typeof _AT_==="number"||!(4204112===_AT_[1]))
           var _AU_=0;
          else
           {var
             match_AV_=_AT_[2],
             info_AW_=match_AV_[3],
             is_root_Bc_=match_AV_[1];
            try
             {var
               _AX_=_ik_(names_AG_,info_AW_),
               font_AY_=opt_style_wq_(style_vy_.nodeFont,_Y_.toString()),
               _AZ_=caml_obj_tag(text_size_div_zv_),
               d_A0_=
                250===_AZ_
                 ?text_size_div_zv_[1]
                 :246===_AZ_?_iy_(text_size_div_zv_):text_size_div_zv_;
              d_A0_.style.font=font_AY_;
              var txt_A1_=document_sH_.createTextNode(_AX_.toString());
              _sr_(d_A0_,txt_A1_);
              var _A3_=d_A0_.clientHeight,_A2_=d_A0_.clientWidth;
              _ss_(d_A0_,txt_A1_);
              var
               w_A4_=_A2_+8|0,
               h_A5_=_A3_+8|0,
               canvas_A6_=create_canvas_zr_(w_A4_,h_A5_),
               c_A7_=canvas_A6_.getContext(_2d__sF_);
              c_A7_.fillStyle=
              opt_style_wq_(style_vy_.nodeBackgroundColor,tree_color_vu_);
              var _A8_=0,_A9_=0,r_A__=_f9_(4,_f9_(w_A4_,h_A5_)/2);
              c_A7_.beginPath();
              c_A7_.moveTo(_A9_+r_A__,_A8_);
              c_A7_.arcTo(_A9_+w_A4_,_A8_,_A9_+w_A4_,_A8_+r_A__,r_A__);
              c_A7_.arcTo
               (_A9_+w_A4_,_A8_+h_A5_,_A9_+w_A4_-r_A__,_A8_+h_A5_,r_A__);
              c_A7_.arcTo(_A9_,_A8_+h_A5_,_A9_,_A8_+h_A5_-r_A__,r_A__);
              c_A7_.arcTo(_A9_,_A8_,_A9_+r_A__,_A8_,r_A__);
              c_A7_.fill();
              c_A7_.font=font_AY_;
              c_A7_.fillStyle=
              opt_style_wq_(style_vy_.nodeColor,_X_.toString());
              c_A7_.textAlign=_W_.toString();
              c_A7_.textBaseline=_V_.toString();
              c_A7_.fillText(_AX_.toString(),w_A4_/2,h_A5_/2);
              var _A$_=[0,canvas_A6_],canvas_Ba_=_A$_;}
            catch(_Bb_){if(_Bb_[1]!==_c_)throw _Bb_;var canvas_Ba_=0;}
            caml_array_set
             (nodes_AP_,
              i_AR_,
              [0,_Bd_,[0,4204112,[0,is_root_Bc_,canvas_Ba_,info_AW_]]]);
            var _AU_=1;}
          _AU_;
          var _Be_=i_AR_+1|0;
          if(_AQ_!==i_AR_){var i_AR_=_Be_;continue;}
          break;}}
      return 0;}
    function weight_sum_Bn_(l_Bi_)
     {var _Bh_=0;
      return _hc_(function(s_Bg_,n_Bf_){return s_Bg_+n_Bf_[1];},_Bh_,l_Bi_);}
    function compute_weights_Bl_(node_Bj_)
     {var l_Bk_=node_Bj_[2];
      if(0===l_Bk_.length-1)return [0,1,[0]];
      var l__Bm_=_hb_(compute_weights_Bl_,l_Bk_);
      return [0,0.6*weight_sum_Bn_(l__Bm_),l__Bm_];}
    function close_button_Cx_(over_Bu_)
     {var
       color_Bo_=opt_style_wq_(style_vy_.buttonColor,_aj_.toString()),
       size_Bp_=32,
       offset_Bq_=4,
       lw_Br_=4,
       canvas_Bs_=create_canvas_zr_(size_Bp_,size_Bp_),
       c_Bt_=canvas_Bs_.getContext(_2d__sF_);
      c_Bt_.save();
      c_Bt_.lineWidth=2;
      c_Bt_.strokeStyle=color_Bo_;
      if(over_Bu_){c_Bt_.shadowBlur=offset_Bq_;c_Bt_.shadowColor=color_Bo_;}
      c_Bt_.beginPath();
      var
       a_Bv_=offset_Bq_+lw_Br_/Math.sqrt(2),
       b_Bw_=size_Bp_-offset_Bq_-lw_Br_/Math.sqrt(2);
      c_Bt_.moveTo(a_Bv_,a_Bv_);
      c_Bt_.lineTo(b_Bw_,b_Bw_);
      c_Bt_.moveTo(a_Bv_,b_Bw_);
      c_Bt_.lineTo(b_Bw_,a_Bv_);
      c_Bt_.stroke();
      c_Bt_.restore();
      var _Bx_=over_Bu_?_ai_:_ah_;
      canvas_Bs_.className=_Bx_.toString();
      canvas_Bs_.style.position=_ag_.toString();
      canvas_Bs_.style.top=_af_.toString();
      canvas_Bs_.style.right=_ae_.toString();
      return canvas_Bs_;}
    function img_button_CC_(href_BL_,h_BB_,src_Bz_)
     {function decoration_BI_(over_BG_)
       {var img_By_=createImg_s5_(document_sH_);
        img_By_.src=icon_vs_(src_Bz_);
        var div_BA_=createDiv_s3_(document_sH_);
        div_BA_.style.position=_ax_.toString();
        div_BA_.style.width=_aw_.toString();
        var ad7054ea4_BC_=div_BA_.style;
        ad7054ea4_BC_.height=
        _gk_(string_of_int_gt_(_f__(38,h_BB_)),_av_).toString();
        div_BA_.style.margin=_au_.toString();
        div_BA_.style.borderRadius=_at_.toString();
        var
         extra_BD_=_f__(6,44-h_BB_|0),
         abb2ac2f2_BE_=div_BA_.style,
         _BF_=
          _gk_(_ar_,_gk_(string_of_int_gt_(extra_BD_-(extra_BD_/2|0)|0),_as_));
        abb2ac2f2_BE_.padding=
        _gk_(string_of_int_gt_(extra_BD_/2|0),_BF_).toString();
        var _BH_=over_BG_?_aq_:_ap_;
        div_BA_.className=_gk_(_ao_,_BH_).toString();
        _sr_(div_BA_,img_By_);
        return div_BA_;}
      var button_BJ_=createDiv_s3_(document_sH_);
      button_BJ_.className=_an_.toString();
      button_BJ_.style.width=_am_.toString();
      var a8f48e114_BK_=button_BJ_.style;
      a8f48e114_BK_.height=
      _gk_(string_of_int_gt_(8+_f__(38,h_BB_)|0),_al_).toString();
      if(href_BL_)
       {var url_BN_=href_BL_[1],a_BM_=createA_s4_(document_sH_);
        a_BM_.target=_ak_.toString();
        a_BM_.href=url_BN_;
        _sr_(button_BJ_,a_BM_);
        var container_BO_=a_BM_;}
      else
       var container_BO_=button_BJ_;
      _sr_(container_BO_,decoration_BI_(1));
      _sr_(container_BO_,decoration_BI_(0));
      return button_BJ_;}
    function tooltip_Cy_(txt_BQ_)
     {var tooltip_BP_=createDiv_s3_(document_sH_);
      tooltip_BP_.style.position=_az_.toString();
      tooltip_BP_.className=_ay_.toString();
      tooltip_BP_.innerHTML=txt_BQ_;
      return tooltip_BP_;}
    function show_on_click_C1_(button_BY_,txt_BT_)
     {var activated_BR_=[0,0];
      return button_BY_.onclick=
             _st_
              (function(ev_BX_)
                {if(!activated_BR_[1])
                  {activated_BR_[1]=1;
                   var c_BS_=[0,null_rh_];
                   c_BS_[1]=
                   _r4_
                    (_sv_
                      (document_sH_,
                       click_sy_,
                       _st_
                        (function(ev_BW_)
                          {function _BV_(param_BU_)
                            {_rG_(c_BS_[1],_sw_);
                             txt_BT_.className=_aB_.toString();
                             activated_BR_[1]=0;
                             return return_pV_(0);}
                           bind_qz_(yield_tE_(0),_BV_);
                           return _true_rM_;}),
                       _true_rM_));
                   txt_BT_.className=_aA_.toString();}
                 stopPropagation_tu_(ev_BX_);
                 return _false_rN_;});}
    function show_image_C6_
     (all_messages_BZ_,image_info_C4_,name_B2_,small_image_Cf_)
     {return bind_qz_
              (image_info_C4_,
               function(image_info_B4_)
                {var
                  messages_B0_=local_messages_zP_(all_messages_BZ_),
                  i_B1_=[0,-1],
                  _B3_=0,
                  _B5_=image_info_B4_.length-1-1|0,
                  name_js_B7_=name_B2_.toString();
                 if(!(_B5_<_B3_))
                  {var j_B6_=_B3_;
                   for(;;)
                    {if(name_js_B7_===caml_array_get(image_info_B4_,j_B6_)[1])
                      i_B1_[1]=j_B6_;
                     var _B8_=j_B6_+1|0;
                     if(_B5_!==j_B6_){var j_B6_=_B8_;continue;}
                     break;}}
                 if(0<=i_B1_[1])
                  {var info_B9_=caml_array_get(image_info_B4_,i_B1_[1]);
                   _tH_.log(name_B2_,i_B1_[1]);
                   var container_B__=createDiv_s3_(document_sH_);
                   container_B__.style.margin=_bG_.toString();
                   container_B__.style.position=_bF_.toString();
                   container_B__.style.top=_bE_.toString();
                   container_B__.style.bottom=_bD_.toString();
                   container_B__.style.left=_bC_.toString();
                   container_B__.style.right=_bB_.toString();
                   var img_container_B$_=createDiv_s3_(document_sH_);
                   img_container_B$_.style.position=_bA_.toString();
                   img_container_B$_.style.top=_bz_.toString();
                   img_container_B$_.style.bottom=_by_.toString();
                   img_container_B$_.style.left=_bx_.toString();
                   img_container_B$_.style.right=_bw_.toString();
                   var
                    wrap_Cd_=
                     function(elt_Cc_)
                      {var w_Ca_=createDiv_s3_(document_sH_);
                       w_Ca_.style.position=_bN_.toString();
                       w_Ca_.style.top=_bM_.toString();
                       w_Ca_.style.bottom=_bL_.toString();
                       w_Ca_.style.left=_bK_.toString();
                       w_Ca_.style.right=_bJ_.toString();
                       w_Ca_.style.margin=_bI_.toString();
                       var a4b0d7196_Cb_=w_Ca_.style;
                       a4b0d7196_Cb_.maxHeight=
                       _gk_(string_of_int_gt_(info_B9_[5]),_bH_).toString();
                       _sr_(w_Ca_,elt_Cc_);
                       return w_Ca_;},
                    img_Ce_=createImg_s5_(document_sH_),
                    _Cg_=caml_obj_tag(small_image_Cf_),
                    _Ch_=
                     250===_Cg_
                      ?small_image_Cf_[1]
                      :246===_Cg_?_iy_(small_image_Cf_):small_image_Cf_,
                    _Ci_=poll_q1_(_Ch_);
                   if(_Ci_)
                    {var
                      small_image_Ck_=_Ci_[1],
                      canvas_Cj_=create_canvas_zr_(info_B9_[4],info_B9_[5]),
                      c_Cl_=canvas_Cj_.getContext(_2d__sF_);
                     c_Cl_.drawImage(small_image_Ck_,0,0,info_B9_[4],info_B9_[5]);
                     canvas_Cj_.style.display=_bv_.toString();
                     canvas_Cj_.style.height=_bu_.toString();
                     canvas_Cj_.style.width=_bt_.toString();
                     canvas_Cj_.style.maxWidth=_bs_.toString();
                     canvas_Cj_.style.maxHeight=_br_.toString();
                     canvas_Cj_.style.marginLeft=_bq_.toString();
                     canvas_Cj_.style.marginRight=_bp_.toString();
                     var w_Cm_=wrap_Cd_(canvas_Cj_);
                     _sr_(img_container_B$_,w_Cm_);
                     img_Ce_.onload=
                     _st_
                      (function(param_Cn_)
                        {_ss_(img_container_B$_,w_Cm_);return _false_rN_;});}
                   var
                    _Co_=info_B9_[7],
                    _Cp_=_Co_?_Co_[1]:_gk_(_bn_,_gk_(name_B2_,_bo_)).toString();
                   img_Ce_.src=_Cp_;
                   img_Ce_.width=info_B9_[4];
                   img_Ce_.height=info_B9_[5];
                   img_Ce_.style.display=_bm_.toString();
                   img_Ce_.style.height=_bl_.toString();
                   img_Ce_.style.width=_bk_.toString();
                   img_Ce_.style.maxWidth=_bj_.toString();
                   img_Ce_.style.maxHeight=_bi_.toString();
                   img_Ce_.style.marginLeft=_bh_.toString();
                   img_Ce_.style.marginRight=_bg_.toString();
                   var
                    w_Cq_=wrap_Cd_(img_Ce_),
                    handle_error_Cs_=
                     function(param_Cr_)
                      {_ss_(img_container_B$_,w_Cq_);return _false_rN_;};
                   img_Ce_.onerror=_st_(handle_error_Cs_);
                   img_Ce_.onabort=_st_(handle_error_Cs_);
                   _sr_(img_container_B$_,w_Cq_);
                   _sr_(container_B__,img_container_B$_);
                   var legend_Ct_=createDiv_s3_(document_sH_);
                   legend_Ct_.innerHTML=info_B9_[3];
                   legend_Ct_.onclick=
                   _st_
                    (function(ev_Cu_)
                      {stopPropagation_tu_(ev_Cu_);return _true_rM_;});
                   legend_Ct_.className=_bf_.toString();
                   legend_Ct_.style.position=_be_.toString();
                   legend_Ct_.style.bottom=_bd_.toString();
                   legend_Ct_.style.marginRight=_bc_.toString();
                   legend_Ct_.style.marginLeft=_bb_.toString();
                   _sr_(container_B__,legend_Ct_);
                   var background_Cv_=createDiv_s3_(document_sH_);
                   _sr_(background_Cv_,container_B__);
                   background_Cv_.className=_ba_.toString();
                   background_Cv_.style.width=_a$_.toString();
                   background_Cv_.style.height=_a__.toString();
                   background_Cv_.style.position=_a9_.toString();
                   background_Cv_.style.top=_a8_.toString();
                   background_Cv_.style.left=_a7_.toString();
                   background_Cv_.style.zIndex=_a6_.toString();
                   var button_Cw_=createDiv_s3_(document_sH_);
                   button_Cw_.className=_a5_.toString();
                   button_Cw_.style.position=_a4_.toString();
                   button_Cw_.style.top=_a3_.toString();
                   button_Cw_.style.right=_a2_.toString();
                   button_Cw_.style.cursor=_a1_.toString();
                   _sr_(button_Cw_,close_button_Cx_(1));
                   _sr_(button_Cw_,close_button_Cx_(0));
                   var
                    tt_Cz_=
                     tooltip_Cy_
                      (opt_style_wq_(messages_B0_.close,_a0_.toString()));
                   tt_Cz_.style.right=_aZ_.toString();
                   tt_Cz_.style.top=_aY_.toString();
                   _sr_(button_Cw_,tt_Cz_);
                   _sr_(background_Cv_,button_Cw_);
                   var buttons_CA_=createDiv_s3_(document_sH_);
                   buttons_CA_.style.position=_aX_.toString();
                   buttons_CA_.style.top=_aW_.toString();
                   buttons_CA_.style.left=_aV_.toString();
                   var
                    suffix_CB_=
                     language_zH_[1]===_aU_.toString()
                      ?_aT_
                      :_gk_(_aS_,new MlWrappedString(language_zH_[1])),
                    commons_CD_=
                     img_button_CC_
                      ([0,
                        _gk_(_aR_,_gk_(new MlWrappedString(info_B9_[2]),suffix_CB_)).toString
                         ()],
                       52,
                       _aQ_),
                    tt_CE_=
                     tooltip_Cy_
                      (opt_style_wq_
                        (messages_B0_.wikimediaCommons,_aP_.toString()));
                   tt_CE_.style.left=_aO_.toString();
                   tt_CE_.style.top=_aN_.toString();
                   _sr_(commons_CD_,tt_CE_);
                   _sr_(buttons_CA_,commons_CD_);
                   var
                    wikipedia_CF_=img_button_CC_(0,34,_aM_),
                    txt_CG_=createDiv_s3_(document_sH_),
                    count_CH_=[0,0],
                    dl_CI_=createDl_s1_(document_sH_),
                    list_CY_=
                     function(title_CW_,lang_CN_)
                      {var
                        ul_CJ_=createUl_s0_(document_sH_),
                        empty_CK_=[0,1],
                        _CU_=info_B9_[6];
                       _g$_
                        (function(param_CL_)
                          {var name_CM_=param_CL_[1],refer_CP_=param_CL_[3];
                           if(param_CL_[2]===lang_CN_)
                            {empty_CK_[1]=0;
                             var a_CO_=createA_s4_(document_sH_);
                             _sr_(a_CO_,document_sH_.createTextNode(name_CM_));
                             a_CO_.target=_bQ_.toString();
                             var
                              refer_CQ_=new MlWrappedString(refer_CP_),
                              _CR_=
                               0===refer_CQ_.getLen()
                                ?new MlWrappedString(name_CM_)
                                :refer_CQ_,
                              _CS_=_gk_(_bP_,_CR_);
                             a_CO_.href=
                             _gk_(_bO_,_gk_(new MlWrappedString(lang_CN_),_CS_)).toString
                              ();
                             var li_CT_=createLi_s2_(document_sH_);
                             _sr_(li_CT_,a_CO_);
                             return _sr_(ul_CJ_,li_CT_);}
                           return 0;},
                         _CU_);
                       if(empty_CK_[1])return 0;
                       count_CH_[1]+=1;
                       var dd_CV_=createDd_s6_(document_sH_);
                       _sr_(dd_CV_,document_sH_.createTextNode(title_CW_));
                       _sr_(dl_CI_,dd_CV_);
                       var dt_CX_=createDt_s7_(document_sH_);
                       _sr_(dt_CX_,ul_CJ_);
                       return _sr_(dl_CI_,dt_CX_);},
                    _CZ_=language_zH_[1];
                   list_CY_
                    (opt_style_wq_(messages_B0_.language,_aL_.toString()),_CZ_);
                   if(language_zH_[1]!==_aK_.toString())
                    list_CY_(_aI_.toString(),_aJ_.toString());
                   if(0<count_CH_[1])
                    _sr_(txt_CG_,dl_CI_);
                   else
                    _sr_
                     (txt_CG_,
                      document_sH_.createTextNode
                       (opt_style_wq_(messages_B0_.noRef,_aH_.toString())));
                   txt_CG_.className=_aG_.toString();
                   txt_CG_.style.position=_aF_.toString();
                   txt_CG_.style.left=_aE_.toString();
                   txt_CG_.style.top=_aD_.toString();
                   txt_CG_.style.whiteSpace=_aC_.toString();
                   _sr_(wikipedia_CF_,txt_CG_);
                   _sr_(buttons_CA_,wikipedia_CF_);
                   txt_CG_.onclick=
                   _st_
                    (function(ev_C0_)
                      {stopPropagation_tu_(ev_C0_);return _true_rM_;});
                   show_on_click_C1_(wikipedia_CF_,txt_CG_);
                   buttons_CA_.onclick=
                   _st_
                    (function(ev_C2_)
                      {stopPropagation_tu_(ev_C2_);return _true_rM_;});
                   _sr_(background_Cv_,buttons_CA_);
                   _sr_(document_sH_.body,background_Cv_);
                   background_Cv_.onclick=
                   _st_
                    (function(param_C3_)
                      {_ss_(document_sH_.body,background_Cv_);return _true_rM_;});}
                 return return_pV_(0);});}
    var information_en_C8_=_r_.toString();
    _hz_
     (function(src_C7_){load_image_zq_(icon_vs_(src_C7_));return 0;},icons_B_);
    function _C__(s_C9_){return return_pV_(json_wv_.parse(s_C9_.toString()));}
    var _Fp_=bind_qz_(http_get_zp_(_O_),_C__);
    function _Fq_(s_C$_)
     {var
       info_Da_=json_wv_.parse(s_C$_.toString()),
       tree_Db_=info_Da_[1],
       node_names_Dc_=info_Da_[2];
      randomize_tree_Au_(tree_Db_);
      var
       node_names_DE_=
        _Av_
         (_Av_
           (node_names_Dc_,
            _gN_
             (_hb_,
              function(param_Dd_)
               {var
                 about_Dh_=param_Dd_[3],
                 tbl_Dg_=param_Dd_[2],
                 lang_Df_=param_Dd_[1],
                 h_De_=_ij_(101);
                _g$_
                 (function(param_Di_)
                   {var
                     _Dj_=new MlWrappedString(param_Di_[1]),
                     _Dl_=new MlWrappedString(param_Di_[2]),
                     _Dk_=h_De_[2].length-1,
                     i_Dm_=caml_mod(_h7_(_Dj_),_Dk_);
                    caml_array_set
                     (h_De_[2],
                      i_Dm_,
                      [0,_Dj_,_Dl_,caml_array_get(h_De_[2],i_Dm_)]);
                    h_De_[1]=h_De_[1]+1|0;
                    var _Dn_=h_De_[2].length-1<<1<h_De_[1]?1:0;
                    if(_Dn_)
                     {var
                       odata_Do_=h_De_[2],
                       osize_Dp_=odata_Do_.length-1,
                       nsize_Dq_=_f9_((2*osize_Dp_|0)+1|0,_h2_),
                       _Dr_=nsize_Dq_!==osize_Dp_?1:0;
                      if(_Dr_)
                       {var
                         ndata_Ds_=caml_make_vect(nsize_Dq_,0),
                         insert_bucket_Dv_=
                          function(param_Dt_)
                           {if(param_Dt_)
                             {var key_Du_=param_Dt_[1],data_Dw_=param_Dt_[2];
                              insert_bucket_Dv_(param_Dt_[3]);
                              var nidx_Dx_=caml_mod(_h7_(key_Du_),nsize_Dq_);
                              return caml_array_set
                                      (ndata_Ds_,
                                       nidx_Dx_,
                                       [0,key_Du_,data_Dw_,caml_array_get(ndata_Ds_,nidx_Dx_)]);}
                            return 0;},
                         _Dy_=0,
                         _Dz_=osize_Dp_-1|0;
                        if(!(_Dz_<_Dy_))
                         {var i_DA_=_Dy_;
                          for(;;)
                           {insert_bucket_Dv_(caml_array_get(odata_Do_,i_DA_));
                            var _DB_=i_DA_+1|0;
                            if(_Dz_!==i_DA_){var i_DA_=_DB_;continue;}
                            break;}}
                        h_De_[2]=ndata_Ds_;
                        var _DC_=0;}
                      else
                       var _DC_=_Dr_;
                      var _DD_=_DC_;}
                    else
                     var _DD_=_Dn_;
                    return _DD_;},
                  tbl_Dg_);
                return [0,lang_Df_,[0,h_De_,about_Dh_]];})),
          _hd_);
      function compute_DQ_(is_root_DO_,n_DF_)
       {var _DG_=new MlWrappedString(n_DF_[1]),ch_DP_=n_DF_[2];
        if(0===_DG_.getLen())
         var info_DH_=870530776;
        else
         if(124===_DG_.safeGet(0))
          {var
            _DI_=_hY_(_DG_,1,_DG_.getLen()-1|0),
            info_DH_=
             [0,
              3654627,
              [0,
               [246,
                function(param_DN_)
                 {function _DM_(param_DL_)
                   {function _DK_(img_DJ_)
                     {schedule_redraw_AD_(0);return return_pV_(img_DJ_);}
                    return bind_qz_
                            (load_image_zq_(_gk_(_T_,_gk_(_DI_,_U_)).toString()),_DK_);}
                  return bind_qz_(yield_tE_(0),_DM_);}],
               _DI_]];}
         else
          var info_DH_=[0,4204112,[0,is_root_DO_,0,_DG_]];
        return [0,
                info_DH_,
                _hb_(function(n_DR_){return compute_DQ_(0,n_DR_);},ch_DP_)];}
      var
       _DS_=compute_DQ_(1,tree_Db_),
       node_count_DT_=tree_vertice_count_Ab_(_DS_),
       vertices_DU_=caml_make_vect(node_count_DT_,zero_i_),
       edges_DV_=caml_make_vect(tree_edge_count_Ah_(_DS_),_ac_),
       nodes_DW_=caml_make_vect(node_count_DT_,[0,[0],870530776]),
       vi_DX_=[0,0],
       ei_DY_=[0,0],
       weights_Ey_=compute_weights_Bl_(_DS_);
      function layout_rec_El_
       (current_DZ_,
        current_weights_D1_,
        is_root_D8_,
        transf_D5_,
        lineWidth_Ek_,
        dir_Ec_)
       {var
         ch_D0_=current_DZ_[2],
         ch_weights_D2_=current_weights_D1_[2],
         i_D3_=vi_DX_[1],
         info_D4_=current_DZ_[1];
        vi_DX_[1]+=1;
        caml_array_set(vertices_DU_,i_D3_,transf_D5_[1]);
        if(0===ch_D0_.length-1)
         var ch__D6_=[0];
        else
         {var
           total_weight_D7_=weight_sum_Bn_(ch_weights_D2_),
           j_D__=[0,0],
           _D9_=
            is_root_D8_
             ?(total_weight_D7_-caml_array_get(ch_weights_D2_,0)[1])/2
             :0,
           w0_D$_=[0,_D9_],
           _Eq_=
            function(node_Em_,weights_Ea_)
             {var
               w_Eb_=weights_Ea_[1],
               angle_Ed_=Math.acos(dir_Ec_[1])*w_Eb_/total_weight_D7_,
               th_Ee_=
                Math.acos(dir_Ec_[1])*
                ((w0_D$_[1]+w_Eb_/2)/total_weight_D7_*2-1);
              j_D__[1]+=1;
              w0_D$_[1]=w0_D$_[1]+w_Eb_;
              var
               min_angle_Ef_=pi_zZ_/3,
               a_Eg_=
                [254,
                 (Math.cos(angle_Ed_)-Math.cos(min_angle_Ef_))/
                 (1-Math.cos(min_angle_Ef_+angle_Ed_)),
                 0],
               dir_Eh_=[254,Math.cos(min_angle_Ef_),Math.sin(min_angle_Ef_)],
               match_Ei_=
                0.25<a_Eg_[1]
                 ?[0,a_Eg_,dir_Eh_]
                 :[0,
                   a_g_,
                   _g9_
                    (transl_ws_,
                     neg_wr_(a_g_),
                     [254,Math.cos(angle_Ed_),Math.sin(angle_Ed_)])],
               dir_Ej_=match_Ei_[2],
               ch_En_=
                layout_rec_El_
                 (node_Em_,
                  weights_Ea_,
                  0,
                  compose_wt_
                   (compose_wt_
                     ([0,match_Ei_[1],one_h_],
                      [0,zero_i_,[254,Math.cos(th_Ee_),Math.sin(th_Ee_)]]),
                    transf_D5_),
                  lineWidth_Ek_*0.94,
                  dir_Ej_),
               i__Ep_=ch_En_[1],
               k_Eo_=ei_DY_[1];
              ei_DY_[1]+=1;
              caml_array_set(edges_DV_,k_Eo_,[0,i_D3_,i__Ep_,lineWidth_Ek_]);
              return ch_En_;},
           l_Er_=ch_D0_.length-1;
          if(ch_weights_D2_.length-1!==l_Er_)throw [0,_d_,_aa_];
          if(0===l_Er_)
           var _Es_=[0];
          else
           {var
             r_Et_=
              caml_make_vect
               (l_Er_,
                _Eq_
                 (caml_array_get(ch_D0_,0),caml_array_get(ch_weights_D2_,0))),
             _Eu_=1,
             _Ev_=l_Er_-1|0;
            if(!(_Ev_<_Eu_))
             {var i_Ew_=_Eu_;
              for(;;)
               {caml_array_set
                 (r_Et_,
                  i_Ew_,
                  _Eq_
                   (caml_array_get(ch_D0_,i_Ew_),
                    caml_array_get(ch_weights_D2_,i_Ew_)));
                var _Ex_=i_Ew_+1|0;
                if(_Ev_!==i_Ew_){var i_Ew_=_Ex_;continue;}
                break;}}
            var _Es_=r_Et_;}
          var ch__D6_=_Es_;}
        caml_array_set(nodes_DW_,i_D3_,[0,[0],info_D4_]);
        return [0,i_D3_,ch__D6_];}
      var
       tree_Ez_=layout_rec_El_(_DS_,weights_Ey_,1,[0,zero_i_,one_h_],6,_ab_),
       frontiers_EA_=caml_make_vect(nodes_DW_.length-1,[0,[0],[0]]);
      function node_info_EK_(param_EB_){return param_EB_[1];}
      function status_EH_(i_EC_)
       {return [0,i_EC_,870530776!==caml_array_get(nodes_DW_,i_EC_)[2]?1:0];}
      function compute_frontiers_EG_(node_ED_)
       {var l_EE_=node_ED_[2],i_EF_=node_ED_[1];
        _g$_(compute_frontiers_EG_,l_EE_);
        if(0===l_EE_.length-1)
         {var _EI_=[0,status_EH_(i_EF_)],_EJ_=[0,[0,status_EH_(i_EF_)],_EI_];}
        else
         {var
           _EL_=
            caml_array_get
              (frontiers_EA_,
               node_info_EK_(caml_array_get(l_EE_,l_EE_.length-1-1|0)))
             [2],
           _EJ_=
            [0,
             caml_array_get
               (frontiers_EA_,node_info_EK_(caml_array_get(l_EE_,0)))
              [1],
             _EL_];}
        return caml_array_set(frontiers_EA_,i_EF_,_EJ_);}
      compute_frontiers_EG_(tree_Ez_);
      var neighboors_EM_=caml_make_vect(nodes_DW_.length-1,[0]);
      function compute_neigh_Fj_(node_EN_,parent_ET_,lft_ES_,rght_ER_)
       {var
         ch_EO_=node_EN_[2],
         i_EP_=node_EN_[1],
         aa_EU_=
          [0,
           parent_ET_,
           [0,
            lft_ES_,
            [0,
             rght_ER_,
             [0,
              _hb_
               (function(n_EQ_){return status_EH_(node_info_EK_(n_EQ_));},
                ch_EO_),
              0]]]];
        for(;;)
         {if(aa_EU_)
           {var a_EV_=aa_EU_[1],rem_Fa_=aa_EU_[2];
            if(!(0<a_EV_.length-1)){var aa_EU_=rem_Fa_;continue;}
            var accu_EW_=0,param_EX_=aa_EU_,_E0_=a_EV_[0+1];
            for(;;)
             {if(param_EX_)
               {var
                 t_EZ_=param_EX_[2],
                 _EY_=accu_EW_+(param_EX_[1].length-1)|0,
                 accu_EW_=_EY_,
                 param_EX_=t_EZ_;
                continue;}
              var
               res_E1_=caml_make_vect(accu_EW_,_E0_),
               pos_E2_=0,
               param_E3_=aa_EU_;
              for(;;)
               {if(param_E3_)
                 {var
                   h_E4_=param_E3_[1],
                   _E5_=0,
                   _E6_=h_E4_.length-1-1|0,
                   t_E9_=param_E3_[2];
                  if(!(_E6_<_E5_))
                   {var i_E7_=_E5_;
                    for(;;)
                     {res_E1_[(pos_E2_+i_E7_|0)+1]=h_E4_[i_E7_+1];
                      var _E8_=i_E7_+1|0;
                      if(_E6_!==i_E7_){var i_E7_=_E8_;continue;}
                      break;}}
                  var
                   _E__=pos_E2_+(h_E4_.length-1)|0,
                   pos_E2_=_E__,
                   param_E3_=t_E9_;
                  continue;}
                var _E$_=res_E1_;
                break;}
              break;}}
          else
           var _E$_=[0];
          caml_array_set(neighboors_EM_,i_EP_,_E$_);
          var
           is_root_Fb_=0===parent_ET_.length-1?1:0,
           n_Fc_=ch_EO_.length-1,
           _Fd_=0,
           _Fe_=n_Fc_-1|0;
          if(!(_Fe_<_Fd_))
           {var j_Ff_=_Fd_;
            for(;;)
             {var
               lft_Fg_=
                0<j_Ff_
                 ?caml_array_get
                    (frontiers_EA_,
                     node_info_EK_(caml_array_get(ch_EO_,j_Ff_-1|0)))
                   [2]
                 :is_root_Fb_
                   ?caml_array_get
                      (frontiers_EA_,
                       node_info_EK_(caml_array_get(ch_EO_,n_Fc_-1|0)))
                     [2]
                   :lft_ES_,
               rght_Fh_=
                j_Ff_<(n_Fc_-1|0)
                 ?caml_array_get
                    (frontiers_EA_,
                     node_info_EK_(caml_array_get(ch_EO_,j_Ff_+1|0)))
                   [1]
                 :is_root_Fb_
                   ?caml_array_get
                      (frontiers_EA_,node_info_EK_(caml_array_get(ch_EO_,0)))
                     [1]
                   :rght_ER_,
               _Fi_=[0,status_EH_(i_EP_)];
              compute_neigh_Fj_
               (caml_array_get(ch_EO_,j_Ff_),_Fi_,lft_Fg_,rght_Fh_);
              var _Fk_=j_Ff_+1|0;
              if(_Fe_!==j_Ff_){var j_Ff_=_Fk_;continue;}
              break;}}
          return 0;}}
      compute_neigh_Fj_(tree_Ez_,[0],[0],[0]);
      var _Fl_=0,_Fm_=nodes_DW_.length-1-1|0;
      if(!(_Fm_<_Fl_))
       {var i_Fn_=_Fl_;
        for(;;)
         {caml_array_set
           (nodes_DW_,
            i_Fn_,
            [0,
             caml_array_get(neighboors_EM_,i_Fn_),
             caml_array_get(nodes_DW_,i_Fn_)[2]]);
          var _Fo_=i_Fn_+1|0;
          if(_Fm_!==i_Fn_){var i_Fn_=_Fo_;continue;}
          break;}}
      compute_text_nodes_C5_(node_names_DE_,nodes_DW_);
      return return_pV_
              ([0,
                [0,
                 vertices_DU_,
                 edges_DV_,
                 nodes_DW_,
                 [0,
                  caml_make_vect(node_count_DT_,0),
                  caml_make_vect(node_count_DT_,0),
                  caml_make_vect(node_count_DT_,0),
                  caml_make_vect(node_count_DT_,0)]],
                node_names_DE_]);}
    var _Fs_=bind_qz_(http_get_zp_(tree_url_v_),_Fq_);
    function _Ft_(s_Fr_){return return_pV_(json_wv_.parse(s_Fr_.toString()));}
    var _Fu_=bind_qz_(http_get_zp_(_ad_),_Ft_);
    window_sG_.onload=
    _st_
     (function(param_J__)
       {try
         {createCanvas_s$_(window_sG_.document);
          var
           _J2_=
            repr_po_
              (bind_qz_
                (_Fs_,
                 function(param_Fv_)
                  {var
                    tree_i18n_Fw_=param_Fv_[2],
                    match_Fx_=param_Fv_[1],
                    boxes_Fy_=match_Fx_[4],
                    nodes_Fz_=match_Fx_[3],
                    edges_FA_=match_Fx_[2],
                    vertices_FB_=match_Fx_[1];
                   return bind_qz_
                           (_Fp_,
                            function(all_messages_If_)
                             {var page_FC_=document_sH_.documentElement;
                              page_FC_.style.overflow=_cm_.toString();
                              page_FC_.style.height=_cl_.toString();
                              document_sH_.body.style.overflow=_ck_.toString();
                              document_sH_.body.style.margin=_cj_.toString();
                              document_sH_.body.style.height=_ci_.toString();
                              var
                               canvas_FD_=
                                create_canvas_zr_
                                 (page_FC_.clientWidth,page_FC_.clientHeight);
                              _sr_(document_sH_.body,canvas_FD_);
                              var
                               tr_FE_=[0,[0,zero_i_,one_h_]],
                               tr__FF_=[0,tr_FE_[1]],
                               l_FG_=vertices_FB_.length-1;
                              if(0===l_FG_)
                               var vertices__FH_=[0];
                              else
                               {var
                                 res_FI_=caml_make_vect(l_FG_,vertices_FB_[0+1]),
                                 _FJ_=1,
                                 _FK_=l_FG_-1|0;
                                if(!(_FK_<_FJ_))
                                 {var i_FL_=_FJ_;
                                  for(;;)
                                   {res_FI_[i_FL_+1]=vertices_FB_[i_FL_+1];
                                    var _FM_=i_FL_+1|0;
                                    if(_FK_!==i_FL_){var i_FL_=_FM_;continue;}
                                    break;}}
                                var vertices__FH_=res_FI_;}
                              redraw_funct_Ay_[1]=
                              function(param_HC_)
                               {need_redraw_Aw_[1]=0;
                                _tH_.time(_co_.toString());
                                var
                                 w_FN_=page_FC_.clientWidth,
                                 h_FO_=page_FC_.clientHeight,
                                 _FP_=
                                  w_FN_!==canvas_FD_.width?0:h_FO_!==canvas_FD_.height?0:1;
                                if(!_FP_){canvas_FD_.width=w_FN_;canvas_FD_.height=h_FO_;}
                                var
                                 _FQ_=tr__FF_[1],
                                 t_FR_=_FQ_[2],
                                 p_FS_=_FQ_[1],
                                 _FT_=0,
                                 _FU_=vertices_FB_.length-1-1|0,
                                 c_FW_=mul_v5_(conj_v3_(p_FS_),t_FR_);
                                if(!(_FU_<_FT_))
                                 {var i_FV_=_FT_;
                                  for(;;)
                                   {caml_array_set
                                     (vertices__FH_,
                                      i_FV_,
                                      transf_v6_
                                       (t_FR_,
                                        p_FS_,
                                        c_FW_,
                                        one_h_,
                                        caml_array_get(vertices_FB_,i_FV_)));
                                    var _FX_=i_FV_+1|0;
                                    if(_FU_!==i_FV_){var i_FV_=_FX_;continue;}
                                    break;}}
                                _tH_.timeEnd(_cn_.toString());
                                _tH_.time(_S_.toString());
                                var
                                 c_FY_=canvas_FD_.getContext(_2d__sF_),
                                 transf_FZ_=screen_transform_zQ_(canvas_FD_),
                                 dy_F0_=transf_FZ_[4],
                                 dx_F1_=transf_FZ_[3],
                                 ry_F3_=transf_FZ_[2],
                                 rx_F2_=transf_FZ_[1];
                                c_FY_.clearRect(0,0,canvas_FD_.width,canvas_FD_.height);
                                var padding_F4_=opt_style_wq_(style_vy_.padding,0);
                                c_FY_.beginPath();
                                ellipse_arc_z8_
                                 (c_FY_,
                                  dx_F1_,
                                  dy_F0_,
                                  rx_F2_+padding_F4_,
                                  ry_F3_+padding_F4_,
                                  0,
                                  7,
                                  _false_rN_);
                                function _F6_(color_F5_)
                                 {c_FY_.fillStyle=color_F5_;return c_FY_.fill();}
                                _rJ_(style_vy_.backgroundColor,_F6_);
                                function _F8_(color_F7_)
                                 {c_FY_.lineWidth=1;
                                  c_FY_.strokeStyle=color_F7_;
                                  return c_FY_.stroke();}
                                _rJ_(style_vy_.boundaryColor,_F8_);
                                c_FY_.lineWidth=2;
                                c_FY_.lineCap=_R_.toString();
                                c_FY_.strokeStyle=
                                opt_style_wq_(style_vy_.treeColor,tree_color_vu_);
                                var
                                 ry_F9_=transf_FZ_[2],
                                 rx_F__=transf_FZ_[1],
                                 _F$_=0,
                                 _Ga_=edges_FA_.length-1-1|0;
                                if(!(_Ga_<_F$_))
                                 {var i_Gb_=_F$_;
                                  for(;;)
                                   {var
                                     match_Gc_=caml_array_get(edges_FA_,i_Gb_),
                                     z_Gd_=caml_array_get(vertices__FH_,match_Gc_[1]),
                                     z__Ge_=caml_array_get(vertices__FH_,match_Gc_[2]),
                                     x_Gf_=z_Gd_[1]-z__Ge_[1],
                                     y_Gg_=z_Gd_[2]-z__Ge_[2],
                                     w_Gh_=match_Gc_[3];
                                    if(4<rx_F__*ry_F9_*(x_Gf_*x_Gf_+y_Gg_*y_Gg_))
                                     {c_FY_.lineWidth=w_Gh_;
                                      var d_Gi_=2*(z_Gd_[1]*z__Ge_[2]-z_Gd_[2]*z__Ge_[1]);
                                      if(Math.abs(d_Gi_)<0.05)
                                       {var
                                         dy_Gj_=transf_FZ_[4],
                                         dx_Gk_=transf_FZ_[3],
                                         ry_Gl_=transf_FZ_[2],
                                         rx_Gm_=transf_FZ_[1];
                                        c_FY_.beginPath();
                                        c_FY_.moveTo(z_Gd_[1]*rx_Gm_+dx_Gk_,z_Gd_[2]*ry_Gl_+dy_Gj_);
                                        c_FY_.lineTo
                                         (z__Ge_[1]*rx_Gm_+dx_Gk_,z__Ge_[2]*ry_Gl_+dy_Gj_);
                                        c_FY_.stroke();}
                                      else
                                       {var
                                         n1_Gn_=sq_norm_vF_(z_Gd_)+1,
                                         n2_Go_=sq_norm_vF_(z__Ge_)+1,
                                         z0_Gp_=
                                          [254,
                                           (z__Ge_[2]*n1_Gn_-z_Gd_[2]*n2_Go_)/d_Gi_,
                                           (z_Gd_[1]*n2_Go_-z__Ge_[1]*n1_Gn_)/d_Gi_],
                                         dy_Gq_=transf_FZ_[4],
                                         dx_Gr_=transf_FZ_[3],
                                         ry_Gs_=transf_FZ_[2],
                                         rx_Gt_=transf_FZ_[1],
                                         rd_Gu_=norm_wh_(sub_wk_(z_Gd_,z0_Gp_)),
                                         start_Gv_=Math.atan2(z_Gd_[2]-z0_Gp_[2],z_Gd_[1]-z0_Gp_[1]),
                                         fin_Gw_=Math.atan2(z__Ge_[2]-z0_Gp_[2],z__Ge_[1]-z0_Gp_[1]);
                                        c_FY_.beginPath();
                                        var alpha_Gx_=(fin_Gw_-start_Gv_+2*pi_zZ_)%(2*pi_zZ_);
                                        if(rx_Gt_==ry_Gs_)
                                         c_FY_.arc
                                          (z0_Gp_[1]*rx_Gt_+dx_Gr_,
                                           z0_Gp_[2]*rx_Gt_+dy_Gq_,
                                           rd_Gu_*rx_Gt_,
                                           start_Gv_,
                                           fin_Gw_,
                                           !!(pi_zZ_<alpha_Gx_?1:0));
                                        else
                                         ellipse_arc_z8_
                                          (c_FY_,
                                           z0_Gp_[1]*rx_Gt_+dx_Gr_,
                                           z0_Gp_[2]*ry_Gs_+dy_Gq_,
                                           rd_Gu_*rx_Gt_,
                                           rd_Gu_*ry_Gs_,
                                           start_Gv_,
                                           fin_Gw_,
                                           !!(pi_zZ_<alpha_Gx_?1:0));
                                        c_FY_.stroke();}}
                                    var _Gy_=i_Gb_+1|0;
                                    if(_Ga_!==i_Gb_){var i_Gb_=_Gy_;continue;}
                                    break;}}
                                var
                                 image_count_Gz_=[0,0],
                                 large_image_count_GA_=[0,0],
                                 _GB_=0,
                                 _GC_=nodes_Fz_.length-1-1|0;
                                if(!(_GC_<_GB_))
                                 {var i_GD_=_GB_;
                                  for(;;)
                                   {var
                                     match_GE_=caml_array_get(nodes_Fz_,i_GD_),
                                     img_GF_=match_GE_[2],
                                     l_GG_=match_GE_[1];
                                    if(typeof img_GF_==="number")
                                     var _GH_=0;
                                    else
                                     {if(4204112<=img_GF_[1])
                                       {var _GI_=img_GF_[2],_GJ_=_GI_[2];
                                        if(_GJ_)
                                         {var
                                           txt_GK_=_GJ_[1],
                                           z_GL_=caml_array_get(vertices__FH_,i_GD_),
                                           circle_GP_=_GI_[1],
                                           _GO_=1,
                                           r2_GR_=
                                            _hc_
                                             (function(z_GL_)
                                                {return function(r2_GN_,param_GM_)
                                                  {return _f9_
                                                           (r2_GN_,
                                                            sq_norm_vF_
                                                             (sub_wk_(caml_array_get(vertices__FH_,param_GM_[1]),z_GL_)));};}
                                               (z_GL_),
                                              _GO_,
                                              l_GG_),
                                           w_GQ_=txt_GK_.width,
                                           h_GS_=txt_GK_.height,
                                           img_d_GT_=Math.sqrt(w_GQ_*w_GQ_+h_GS_*h_GS_),
                                           rd_GU_=Math.sqrt(r2_GR_*rx_F__*ry_F9_)*0.5,
                                           rd_GV_=img_d_GT_/2<rd_GU_?img_d_GT_/2:rd_GU_,
                                           w_GW_=w_GQ_/img_d_GT_*rd_GV_,
                                           h_GX_=h_GS_/img_d_GT_*rd_GV_;
                                          if(circle_GP_)
                                           {c_FY_.beginPath();
                                            c_FY_.fillStyle=
                                            opt_style_wq_(style_vy_.nodeBackgroundColor,tree_color_vu_);
                                            c_FY_.arc
                                             (z_GL_[1]*rx_F__+dx_F1_,
                                              z_GL_[2]*ry_F9_+dy_F0_,
                                              Math.sqrt(w_GW_*w_GW_+h_GX_*h_GX_),
                                              0,
                                              7,
                                              _false_rN_);
                                            c_FY_.fill();}
                                          c_FY_.drawImage
                                           (txt_GK_,
                                            z_GL_[1]*rx_F__+dx_F1_-w_GW_,
                                            z_GL_[2]*ry_F9_+dy_F0_-h_GX_,
                                            2*w_GW_,
                                            2*h_GX_);
                                          var _GY_=1;}
                                        else
                                         {var _GH_=0,_GY_=0;}}
                                      else
                                       {var img_GZ_=img_GF_[2][1];
                                        caml_array_set(boxes_Fy_[3],i_GD_,0);
                                        var
                                         z_G0_=caml_array_get(vertices__FH_,i_GD_),
                                         min_scale_Hf_=
                                          function(z_G0_)
                                            {return function(l_G4_,w_G9_,h_G$_,s_G1_)
                                              {var s_G2_=[0,s_G1_],_G3_=0,_G5_=l_G4_.length-1-1|0;
                                               if(!(_G5_<_G3_))
                                                {var i_G6_=_G3_;
                                                 for(;;)
                                                  {var
                                                    match_G7_=caml_array_get(l_G4_,i_G6_),
                                                    j_G8_=match_G7_[1],
                                                    sx_G__=
                                                     Math.abs(caml_array_get(vertices__FH_,j_G8_)[1]-z_G0_[1])/
                                                     w_G9_,
                                                    sy_Ha_=
                                                     Math.abs(caml_array_get(vertices__FH_,j_G8_)[2]-z_G0_[2])/
                                                     h_G$_,
                                                    large_Hc_=match_G7_[2],
                                                    s__Hb_=sy_Ha_<sx_G__?sx_G__:sy_Ha_,
                                                    s__Hd_=large_Hc_?s__Hb_:1.9*s__Hb_;
                                                   if(s__Hd_<s_G2_[1])s_G2_[1]=s__Hd_;
                                                   var _He_=i_G6_+1|0;
                                                   if(_G5_!==i_G6_){var i_G6_=_He_;continue;}
                                                   break;}}
                                               return s_G2_[1];};}
                                           (z_G0_);
                                        if(caml_obj_tag(img_GZ_)!==_ix_)
                                         {var
                                           _Hg_=caml_obj_tag(img_GZ_),
                                           _Hh_=250===_Hg_?img_GZ_[1]:246===_Hg_?_iy_(img_GZ_):img_GZ_,
                                           _Hi_=poll_q1_(_Hh_);
                                          if(_Hi_)
                                           {var
                                             img_Hj_=_Hi_[1],
                                             w_Hk_=img_Hj_.width,
                                             h_Hl_=img_Hj_.height,
                                             s_Hm_=min_scale_Hf_(l_GG_,1,1,1),
                                             scale_Hn_=s_Hm_/_f__(w_Hk_/rx_F__,h_Hl_/ry_F9_),
                                             w_Ho_=w_Hk_*scale_Hn_/2,
                                             h_Hp_=h_Hl_*scale_Hn_/2;
                                            if(1<w_Ho_&&1<h_Hp_)
                                             {if(shadow_z9_)
                                               {c_FY_.save();
                                                var
                                                 blur_Hq_=7*scale_Hn_,
                                                 offset_Hr_=5*scale_Hn_,
                                                 _Hs_=blur_Hq_<1?0:blur_Hq_;
                                                c_FY_.shadowBlur=_Hs_;
                                                var _Ht_=blur_Hq_<1?0:offset_Hr_;
                                                c_FY_.shadowOffsetX=_Ht_;
                                                var _Hu_=blur_Hq_<1?0:offset_Hr_;
                                                c_FY_.shadowOffsetY=_Hu_;
                                                c_FY_.shadowColor=_Q_.toString();}
                                              var
                                               x_Hv_=z_G0_[1]*rx_F__+dx_F1_,
                                               y_Hw_=z_G0_[2]*ry_F9_+dy_F0_;
                                              c_FY_.drawImage
                                               (img_Hj_,x_Hv_-w_Ho_,y_Hw_-h_Hp_,2*w_Ho_,2*h_Hp_);
                                              if(shadow_z9_)c_FY_.restore();
                                              caml_array_set(boxes_Fy_[1],i_GD_,x_Hv_);
                                              caml_array_set(boxes_Fy_[2],i_GD_,y_Hw_);
                                              caml_array_set(boxes_Fy_[3],i_GD_,w_Ho_);
                                              caml_array_set(boxes_Fy_[4],i_GD_,h_Hp_);
                                              image_count_Gz_[1]+=1;
                                              var
                                               _Hx_=
                                                2<=w_Ho_?2<=h_Hp_?(large_image_count_GA_[1]+=1,1):0:0;
                                              _Hx_;
                                              var _Hy_=1;}
                                            else
                                             var _Hy_=0;
                                            _Hy_;}}
                                        else
                                         {var s_Hz_=min_scale_Hf_(l_GG_,1,1,1);
                                          if(1<s_Hz_*_f__(rx_F__,ry_F9_))
                                           {var _HA_=caml_obj_tag(img_GZ_);
                                            if(250!==_HA_&&246===_HA_)_iy_(img_GZ_);}}
                                        var _GY_=1;}
                                      if(_GY_)var _GH_=1;}
                                    _GH_;
                                    var _HB_=i_GD_+1|0;
                                    if(_GC_!==i_GD_){var i_GD_=_HB_;continue;}
                                    break;}}
                                _tH_.timeEnd(_P_.toString());
                                return _tH_.log(image_count_Gz_[1],large_image_count_GA_[1]);};
                              perform_redraw_AA_(0);
                              window_sG_.onresize=
                              _st_
                               (function(param_HG_)
                                 {var
                                   page_HD_=document_sH_.documentElement,
                                   h_HF_=page_HD_.clientHeight,
                                   _HE_=
                                    page_HD_.clientWidth!==canvas_FD_.width
                                     ?0
                                     :h_HF_!==canvas_FD_.height?0:1;
                                  if(!_HE_)schedule_redraw_AD_(1);
                                  return _true_rM_;});
                              function find_box_HQ_(boxes_HJ_,x_HM_,y_HN_)
                               {var p_HH_=[0,-1],_HI_=0,_HK_=boxes_HJ_[3].length-1-1|0;
                                if(!(_HK_<_HI_))
                                 {var i_HL_=_HI_;
                                  for(;;)
                                   {var
                                     _HO_=
                                      0<boxes_HJ_[3][i_HL_+1]
                                       ?Math.abs(x_HM_-boxes_HJ_[1][i_HL_+1])<boxes_HJ_[3][i_HL_+1]
                                         ?Math.abs(y_HN_-boxes_HJ_[2][i_HL_+1])<boxes_HJ_[4][i_HL_+1]
                                           ?(p_HH_[1]=i_HL_,1)
                                           :0
                                         :0
                                       :0;
                                    _HO_;
                                    var _HP_=i_HL_+1|0;
                                    if(_HK_!==i_HL_){var i_HL_=_HP_;continue;}
                                    break;}}
                                return p_HH_[1];}
                              var on_image_HR_=[0,0];
                              function update_cursor_HV_(x_HT_,y_HS_)
                               {return -1===find_box_HQ_(boxes_Fy_,x_HT_,y_HS_)
                                        ?on_image_HR_[1]
                                          ?(canvas_FD_.style.cursor=
                                            _cp_.toString(),
                                            on_image_HR_[1]=
                                            0,
                                            0)
                                          :0
                                        :on_image_HR_[1]
                                          ?0
                                          :(canvas_FD_.style.cursor=
                                            _cq_.toString(),
                                            on_image_HR_[1]=
                                            1,
                                            0);}
                              canvas_FD_.onmousemove=
                              _st_
                               (function(ev_HU_)
                                 {update_cursor_HV_(ev_HU_.clientX,ev_HU_.clientY);
                                  return _false_rN_;});
                              var fuzz_HW_=4;
                              canvas_FD_.onmousedown=
                              _st_
                               (function(ev_HX_)
                                 {var
                                   x0_HY_=ev_HX_.clientX,
                                   y0_HZ_=ev_HX_.clientY,
                                   started_H0_=[0,0],
                                   c2_H8_=[0,null_rh_],
                                   c1_H9_=
                                    _sv_
                                     (document_sH_,
                                      mousemove_sB_,
                                      _st_
                                       (function(ev_H1_)
                                         {var x_H2_=ev_H1_.clientX,y_H3_=ev_H1_.clientY;
                                          if(started_H0_[1])
                                           var _H4_=0;
                                          else
                                           {if
                                             (fuzz_HW_<
                                              _f$_(x_H2_-x0_HY_|0)||
                                              fuzz_HW_<
                                              _f$_(y_H3_-y0_HZ_|0))
                                             var _H5_=1;
                                            else
                                             {var _H4_=0,_H5_=0;}
                                            if(_H5_)
                                             {started_H0_[1]=1;
                                              canvas_FD_.style.cursor=_D_.toString();
                                              var _H4_=1;}}
                                          _H4_;
                                          if(started_H0_[1])
                                           {var
                                             z0_H6_=from_screen_zY_(canvas_FD_,x0_HY_,y0_HZ_),
                                             z1_H7_=from_screen_zY_(canvas_FD_,x_H2_,y_H3_);
                                            tr__FF_[1]=
                                            [0,
                                             compute_translation_wu_
                                              (_g9_(transl_ws_,neg_wr_(tr_FE_[1][1]),z0_H6_),z1_H7_),
                                             one_h_];
                                            schedule_redraw_AD_(1);}
                                          stopPropagation_tu_(ev_H1_);
                                          return _true_rM_;}),
                                      _true_rM_);
                                  c2_H8_[1]=
                                  _r4_
                                   (_sv_
                                     (document_sH_,
                                      mouseup_sz_,
                                      _st_
                                       (function(ev_H__)
                                         {_sw_(c1_H9_);
                                          _rG_(c2_H8_[1],_sw_);
                                          if(started_H0_[1])
                                           {canvas_FD_.style.cursor=_E_.toString();
                                            var _Ia_=ev_H__.clientY,_H$_=ev_H__.clientX;
                                            tr_FE_[1]=tr__FF_[1];
                                            on_image_HR_[1]=0;
                                            update_cursor_HV_(_H$_,_Ia_);}
                                          else
                                           {var
                                             i_Ib_=
                                              find_box_HQ_(boxes_Fy_,ev_H__.clientX,ev_H__.clientY);
                                            if(0<i_Ib_)
                                             {var _Ic_=caml_array_get(nodes_Fz_,i_Ib_)[2];
                                              if(typeof _Ic_==="number"||!(3654627===_Ic_[1]))
                                               var _Id_=0;
                                              else
                                               {var match_Ie_=_Ic_[2];
                                                show_image_C6_
                                                 (all_messages_If_,_Fu_,match_Ie_[2],match_Ie_[1]);
                                                var _Id_=1;}
                                              _Id_;}}
                                          return _true_rM_;}),
                                      _true_rM_));
                                  return _true_rM_;});
                              var fuzz_Ig_=4;
                              _sv_
                               (canvas_FD_,
                                touchstart_sC_,
                                _st_
                                 (function(ev_IX_)
                                   {function _IY_(touch_Ih_)
                                     {var
                                       id_Ii_=touch_Ih_.identifier,
                                       x0_Ij_=touch_Ih_.clientX,
                                       y0_Ik_=touch_Ih_.clientY,
                                       started_Il_=[0,0],
                                       c1_Iz_=
                                        _sv_
                                         (document_sH_,
                                          touchmove_sE_,
                                          _st_
                                           (function(ev_In_)
                                             {var _Im_=0,_Io_=ev_In_.changedTouches.length-1|0;
                                              if(!(_Io_<_Im_))
                                               {var i_Ip_=_Im_;
                                                for(;;)
                                                 {var
                                                   _Ix_=
                                                    function(touch_Iq_)
                                                     {if(touch_Iq_.identifier===id_Ii_)
                                                       {var x_Ir_=touch_Iq_.clientX,y_Is_=touch_Iq_.clientY;
                                                        if(started_Il_[1])
                                                         var _It_=0;
                                                        else
                                                         {if
                                                           (fuzz_Ig_<
                                                            _f$_(x_Ir_-x0_Ij_|0)||
                                                            fuzz_Ig_<
                                                            _f$_(y_Is_-y0_Ik_|0))
                                                           var _Iu_=1;
                                                          else
                                                           {var _It_=0,_Iu_=0;}
                                                          if(_Iu_)
                                                           {started_Il_[1]=1;
                                                            canvas_FD_.style.cursor=_F_.toString();
                                                            var _It_=1;}}
                                                        _It_;
                                                        if(started_Il_[1])
                                                         {_tH_.time(_cr_.toString());
                                                          var
                                                           z0_Iv_=from_screen_zY_(canvas_FD_,x0_Ij_,y0_Ik_),
                                                           z1_Iw_=from_screen_zY_(canvas_FD_,x_Ir_,y_Is_);
                                                          tr__FF_[1]=
                                                          [0,
                                                           compute_translation_wu_
                                                            (_g9_(transl_ws_,neg_wr_(tr_FE_[1][1]),z0_Iv_),z1_Iw_),
                                                           one_h_];
                                                          return schedule_redraw_AD_(1);}
                                                        return 0;}
                                                      return 0;};
                                                  _rJ_(ev_In_.changedTouches.item(i_Ip_),_Ix_);
                                                  var _Iy_=i_Ip_+1|0;
                                                  if(_Io_!==i_Ip_){var i_Ip_=_Iy_;continue;}
                                                  break;}}
                                              stopPropagation_tu_(ev_In_);
                                              return _false_rN_;}),
                                          _true_rM_),
                                       c2_IA_=[0,null_rh_],
                                       c3_IB_=[0,null_rh_];
                                      c2_IA_[1]=
                                      _r4_
                                       (_sv_
                                         (document_sH_,
                                          touchend_sD_,
                                          _st_
                                           (function(ev_ID_)
                                             {var _IC_=0,_IE_=ev_ID_.changedTouches.length-1|0;
                                              if(!(_IE_<_IC_))
                                               {var i_IF_=_IC_;
                                                for(;;)
                                                 {var
                                                   _IO_=
                                                    function(touch_IG_)
                                                     {if(touch_IG_.identifier===id_Ii_)
                                                       {var x_II_=touch_IG_.clientX,y_IH_=touch_IG_.clientY;
                                                        _sw_(c1_Iz_);
                                                        _rG_(c2_IA_[1],_sw_);
                                                        _rG_(c3_IB_[1],_sw_);
                                                        if(started_Il_[1])
                                                         {canvas_FD_.style.cursor=_G_.toString();
                                                          tr_FE_[1]=tr__FF_[1];
                                                          return 0;}
                                                        var i_IJ_=find_box_HQ_(boxes_Fy_,x_II_,y_IH_);
                                                        if(0<i_IJ_)
                                                         {var _IK_=caml_array_get(nodes_Fz_,i_IJ_)[2];
                                                          if(typeof _IK_==="number"||!(3654627===_IK_[1]))
                                                           var _IL_=0;
                                                          else
                                                           {var match_IM_=_IK_[2];
                                                            show_image_C6_
                                                             (all_messages_If_,_Fu_,match_IM_[2],match_IM_[1]);
                                                            var _IN_=0,_IL_=1;}
                                                          if(!_IL_)var _IN_=0;}
                                                        else
                                                         var _IN_=0;
                                                        return _IN_;}
                                                      return 0;};
                                                  _rJ_(ev_ID_.changedTouches.item(i_IF_),_IO_);
                                                  var _IP_=i_IF_+1|0;
                                                  if(_IE_!==i_IF_){var i_IF_=_IP_;continue;}
                                                  break;}}
                                              return _true_rM_;}),
                                          _true_rM_));
                                      c3_IB_[1]=
                                      _r4_
                                       (_sv_
                                         (document_sH_,
                                          touchend_sD_,
                                          _st_
                                           (function(ev_IR_)
                                             {var _IQ_=0,_IS_=ev_IR_.changedTouches.length-1|0;
                                              if(!(_IS_<_IQ_))
                                               {var i_IT_=_IQ_;
                                                for(;;)
                                                 {var
                                                   _IV_=
                                                    function(touch_IU_)
                                                     {if(touch_IU_.identifier===id_Ii_)
                                                       {_sw_(c1_Iz_);
                                                        _rG_(c2_IA_[1],_sw_);
                                                        _rG_(c3_IB_[1],_sw_);
                                                        if(started_Il_[1])canvas_FD_.style.cursor=_H_.toString();
                                                        tr_FE_[1]=tr__FF_[1];
                                                        return 0;}
                                                      return 0;};
                                                  _rJ_(ev_IR_.changedTouches.item(i_IT_),_IV_);
                                                  var _IW_=i_IT_+1|0;
                                                  if(_IS_!==i_IT_){var i_IT_=_IW_;continue;}
                                                  break;}}
                                              return _false_rN_;}),
                                          _true_rM_));
                                      return 0;}
                                    _rJ_(ev_IX_.changedTouches.item(0),_IY_);
                                    return _false_rN_;}),
                                _true_rM_);
                              _sv_
                               (document_sH_,
                                keydown_sA_,
                                _st_
                                 (function(ev_IZ_)
                                   {var _I0_=ev_IZ_.keyCode-37|0;
                                    if(_I0_<0||3<_I0_)return _true_rM_;
                                    switch(_I0_)
                                     {case 1:
                                       tr__FF_[1]=
                                       [0,
                                        compute_translation_wu_
                                         (_g9_(transl_ws_,neg_wr_(tr_FE_[1][1]),z0_cx_),z1_cw_),
                                        one_h_];
                                       tr_FE_[1]=tr__FF_[1];
                                       schedule_redraw_AD_(1);
                                       return _false_rN_;
                                      case 2:
                                       tr__FF_[1]=
                                       [0,
                                        compute_translation_wu_
                                         (_g9_(transl_ws_,neg_wr_(tr_FE_[1][1]),z0_cv_),z1_cu_),
                                        one_h_];
                                       tr_FE_[1]=tr__FF_[1];
                                       schedule_redraw_AD_(1);
                                       return _false_rN_;
                                      case 3:
                                       tr__FF_[1]=
                                       [0,
                                        compute_translation_wu_
                                         (_g9_(transl_ws_,neg_wr_(tr_FE_[1][1]),z0_ct_),z1_cs_),
                                        one_h_];
                                       tr_FE_[1]=tr__FF_[1];
                                       schedule_redraw_AD_(1);
                                       return _false_rN_;
                                      default:
                                       tr__FF_[1]=
                                       [0,
                                        compute_translation_wu_
                                         (_g9_(transl_ws_,neg_wr_(tr_FE_[1][1]),z0_cz_),z1_cy_),
                                        one_h_];
                                       tr_FE_[1]=tr__FF_[1];
                                       schedule_redraw_AD_(1);
                                       return _false_rN_;}}),
                                _true_rM_);
                              var prev_buttons_I1_=[0,0];
                              function make_buttons_JQ_(param_JY_)
                               {var _I2_=prev_buttons_I1_[1];
                                if(_I2_)_ss_(document_sH_.body,_I2_[1]);
                                var buttons_I3_=createDiv_s3_(document_sH_);
                                buttons_I3_.style.position=_c4_.toString();
                                buttons_I3_.style.right=_c3_.toString();
                                buttons_I3_.style.bottom=_c2_.toString();
                                var
                                 messages_I4_=local_messages_zP_(all_messages_If_),
                                 info_I5_=img_button_CC_(0,38,_c1_);
                                info_I5_.style.position=_c0_.toString();
                                info_I5_.style.bottom=_cZ_.toString();
                                info_I5_.style.right=_cY_.toString();
                                info_I5_.style.cursor=_cX_.toString();
                                info_I5_.onclick=
                                _st_
                                 (function(param_JD_)
                                   {try
                                     {var
                                       _I6_=_hA_(language_zH_[1],tree_i18n_Fw_)[2],
                                       info_I7_=_I6_;}
                                    catch(_I8_)
                                     {if(_I8_[1]!==_c_)throw _I8_;
                                      try
                                       {var _I9_=_hA_(_b3_.toString(),tree_i18n_Fw_)[2],_I__=_I9_;}
                                      catch(_I$_)
                                       {if(_I$_[1]!==_c_)throw _I$_;var _I__=information_en_C8_;}
                                      var info_I7_=_I__;}
                                    var txt_Ja_=createDiv_s3_(document_sH_);
                                    txt_Ja_.className=_b2_.toString();
                                    txt_Ja_.style.width=_b1_.toString();
                                    txt_Ja_.style.margin=_b0_.toString();
                                    txt_Ja_.innerHTML=info_I7_;
                                    var cell_Jb_=createDiv_s3_(document_sH_);
                                    cell_Jb_.style.display=_bZ_.toString();
                                    cell_Jb_.style.verticalAlign=_bY_.toString();
                                    _sr_(cell_Jb_,txt_Ja_);
                                    var table_Jc_=createDiv_s3_(document_sH_);
                                    table_Jc_.style.width=_bX_.toString();
                                    table_Jc_.style.height=_bW_.toString();
                                    table_Jc_.style.display=_bV_.toString();
                                    _sr_(table_Jc_,cell_Jb_);
                                    var overlay_Jd_=createDiv_s3_(document_sH_);
                                    overlay_Jd_.className=_bU_.toString();
                                    _sr_(overlay_Jd_,table_Jc_);
                                    var c_Je_=[0,null_rh_];
                                    function close_info_Ji_(param_Jf_)
                                     {_ss_(document_sH_.body,overlay_Jd_);
                                      return _rG_(c_Je_[1],_sw_);}
                                    c_Je_[1]=
                                    _r4_
                                     (_sv_
                                       (document_sH_,
                                        keydown_sA_,
                                        _st_
                                         (function(e_Jg_)
                                           {var _Jh_=e_Jg_.keyCode;
                                            if(13!==_Jh_&&27!==_Jh_)return _true_rM_;
                                            close_info_Ji_(0);
                                            return _false_rN_;}),
                                        _true_rM_));
                                    var _Jj_=0,_Jk_=0;
                                    for(;;)
                                     {if(0===_Jk_&&0===_Jj_)
                                       {var _Jl_=createElement_sM_(document_sH_,_f_),_Jm_=1;}
                                      else
                                       var _Jm_=0;
                                      if(!_Jm_)
                                       {var _Jn_=createElementSyntax_sR_[1];
                                        if(785140586===_Jn_)
                                         {try
                                           {var
                                             el_Jo_=document_sH_.createElement(_eS_.toString()),
                                             _Jp_=_eR_.toString(),
                                             _Jq_=el_Jo_.tagName.toLowerCase()===_Jp_?1:0,
                                             _Jr_=_Jq_?el_Jo_.name===_eQ_.toString()?1:0:_Jq_,
                                             _Js_=_Jr_;}
                                          catch(_Ju_){var _Js_=0;}
                                          var _Jt_=_Js_?982028505:-1003883683;
                                          createElementSyntax_sR_[1]=_Jt_;
                                          continue;}
                                        if(982028505<=_Jn_)
                                         {var a_Jv_=new array_constructor_rP_();
                                          a_Jv_.push(_eV_.toString(),_f_.toString());
                                          opt_iter_sP_
                                           (_Jk_,
                                            function(t_Jw_)
                                             {a_Jv_.push
                                               (_eW_.toString(),caml_js_html_escape(t_Jw_),_eX_.toString());
                                              return 0;});
                                          opt_iter_sP_
                                           (_Jj_,
                                            function(n_Jx_)
                                             {a_Jv_.push
                                               (_eY_.toString(),caml_js_html_escape(n_Jx_),_eZ_.toString());
                                              return 0;});
                                          a_Jv_.push(_eU_.toString());
                                          var
                                           _Jl_=
                                            document_sH_.createElement(a_Jv_.join(_eT_.toString()));}
                                        else
                                         {var res_Jy_=createElement_sM_(document_sH_,_f_);
                                          opt_iter_sP_
                                           (_Jk_,function(t_Jz_){return res_Jy_.type=t_Jz_;});
                                          opt_iter_sP_
                                           (_Jj_,function(n_JA_){return res_Jy_.name=n_JA_;});
                                          var _Jl_=res_Jy_;}}
                                      _sr_
                                       (_Jl_,
                                        document_sH_.createTextNode
                                         (opt_style_wq_(messages_I4_.ok,_bT_.toString())));
                                      _Jl_.onclick=
                                      _st_
                                       (function(param_JB_){close_info_Ji_(0);return _false_rN_;});
                                      var button_div_JC_=createDiv_s3_(document_sH_);
                                      button_div_JC_.style.textAlign=_bS_.toString();
                                      button_div_JC_.style.margin=_bR_.toString();
                                      _sr_(button_div_JC_,_Jl_);
                                      _sr_(txt_Ja_,button_div_JC_);
                                      _sr_(document_sH_.body,overlay_Jd_);
                                      return _false_rN_;}});
                                var
                                 tt_JE_=
                                  tooltip_Cy_
                                   (opt_style_wq_(messages_I4_.info,_cW_.toString()));
                                tt_JE_.style.right=_cV_.toString();
                                tt_JE_.style.bottom=_cU_.toString();
                                _sr_(info_I5_,tt_JE_);
                                _sr_(buttons_I3_,info_I5_);
                                var lang_JF_=img_button_CC_(0,38,_cT_);
                                lang_JF_.style.position=_cS_.toString();
                                lang_JF_.style.bottom=_cR_.toString();
                                lang_JF_.style.right=_cQ_.toString();
                                lang_JF_.style.cursor=_cP_.toString();
                                var
                                 txt_JG_=createDiv_s3_(document_sH_),
                                 dl_JH_=createDl_s1_(document_sH_),
                                 ul_JI_=createUl_s0_(document_sH_);
                                _hz_
                                 (function(param_JJ_)
                                   {var
                                     id_JM_=param_JJ_[2],
                                     name_JL_=param_JJ_[1],
                                     a_JK_=createA_s4_(document_sH_);
                                    _sr_(a_JK_,document_sH_.createTextNode(name_JL_.toString()));
                                    a_JK_.href=_c5_.toString();
                                    a_JK_.onclick=
                                    _st_
                                     (function(param_JR_)
                                       {var _JN_=id_JM_.toString();
                                        function _JP_(st_JO_)
                                         {return st_JO_.setItem(_N_.toString(),_JN_);}
                                        _rJ_(window_sG_.localStorage,_JP_);
                                        language_zH_[1]=_JN_;
                                        make_buttons_JQ_(0);
                                        compute_text_nodes_C5_(tree_i18n_Fw_,nodes_Fz_);
                                        schedule_redraw_AD_(1);
                                        return _false_rN_;});
                                    var li_JS_=createLi_s2_(document_sH_);
                                    _sr_(li_JS_,a_JK_);
                                    return _sr_(ul_JI_,li_JS_);},
                                  languages_cO_);
                                var dd_JT_=createDd_s6_(document_sH_);
                                _sr_
                                 (dd_JT_,
                                  document_sH_.createTextNode
                                   (opt_style_wq_(messages_I4_.languages,_cN_.toString())));
                                _sr_(dl_JH_,dd_JT_);
                                var dt_JU_=createDt_s7_(document_sH_);
                                _sr_(dt_JU_,ul_JI_);
                                _sr_(dl_JH_,dt_JU_);
                                _sr_(txt_JG_,dl_JH_);
                                txt_JG_.className=_cM_.toString();
                                txt_JG_.style.position=_cL_.toString();
                                txt_JG_.style.right=_cK_.toString();
                                txt_JG_.style.bottom=_cJ_.toString();
                                txt_JG_.style.whiteSpace=_cI_.toString();
                                _sr_(lang_JF_,txt_JG_);
                                show_on_click_C1_(lang_JF_,txt_JG_);
                                _sr_(buttons_I3_,lang_JF_);
                                var recenter_JV_=img_button_CC_(0,38,_cH_);
                                recenter_JV_.style.position=_cG_.toString();
                                recenter_JV_.style.bottom=_cF_.toString();
                                recenter_JV_.style.right=_cE_.toString();
                                recenter_JV_.style.cursor=_cD_.toString();
                                recenter_JV_.onclick=
                                _st_
                                 (function(param_JW_)
                                   {tr__FF_[1]=[0,zero_i_,one_h_];
                                    tr_FE_[1]=tr__FF_[1];
                                    schedule_redraw_AD_(1);
                                    return _false_rN_;});
                                var
                                 tt_JX_=
                                  tooltip_Cy_
                                   (opt_style_wq_(messages_I4_.recenter,_cC_.toString()));
                                tt_JX_.style.right=_cB_.toString();
                                tt_JX_.style.bottom=_cA_.toString();
                                _sr_(recenter_JV_,tt_JX_);
                                _sr_(buttons_I3_,recenter_JV_);
                                _sr_(document_sH_.body,buttons_I3_);
                                prev_buttons_I1_[1]=[0,buttons_I3_];
                                return 0;}
                              make_buttons_JQ_(0);
                              var img_JZ_=createImg_s5_(document_sH_);
                              img_JZ_.src=icon_vs_(_ch_);
                              var a_J0_=createA_s4_(document_sH_);
                              a_J0_.target=_cg_.toString();
                              a_J0_.href=_cf_.toString();
                              _sr_(a_J0_,img_JZ_);
                              var logo_J1_=createDiv_s3_(document_sH_);
                              logo_J1_.style.position=_ce_.toString();
                              logo_J1_.style.left=_cd_.toString();
                              logo_J1_.style.bottom=_cc_.toString();
                              _sr_(logo_J1_,a_J0_);
                              _sr_(document_sH_.body,logo_J1_);
                              return return_pV_(0);});}))
             [1];
          switch(_J2_[0])
           {case 1:throw _J2_[1];
            case 2:
             var sleeper_J4_=_J2_[1];
             add_immutable_waiter_qy_
              (sleeper_J4_,
               function(param_J3_)
                {switch(param_J3_[0])
                  {case 0:return 0;
                   case 1:return _oW_(param_J3_[1]);
                   default:throw [0,_d_,_fa_];}});
             break;
            case 3:throw [0,_d_,_e$_];
            default:}}
        catch(_J5_)
         {if(_J5_[1]===Canvas_not_available_s8_)
           {var txt_J6_=createDiv_s3_(document_sH_);
            txt_J6_.className=_cb_.toString();
            txt_J6_.style.width=_ca_.toString();
            txt_J6_.style.margin=_b$_.toString();
            txt_J6_.innerHTML=_b__.toString();
            var cell_J7_=createDiv_s3_(document_sH_);
            cell_J7_.style.display=_b9_.toString();
            cell_J7_.style.verticalAlign=_b8_.toString();
            _sr_(cell_J7_,txt_J6_);
            var table_J8_=createDiv_s3_(document_sH_);
            table_J8_.style.width=_b7_.toString();
            table_J8_.style.height=_b6_.toString();
            table_J8_.style.display=_b5_.toString();
            _sr_(table_J8_,cell_J7_);
            var overlay_J9_=createDiv_s3_(document_sH_);
            overlay_J9_.className=_b4_.toString();
            _sr_(overlay_J9_,table_J8_);
            _sr_(document_sH_.body,overlay_J9_);
            return _false_rN_;}
          throw _J5_;}
        return _false_rN_;});
    do_at_exit_gC_(0);
    return;}
  ());
